<?php
/**
 * @copyright	Copyright (C) 2014 Holest Engineering www.holest.com.
 * @license		GNU General Public License version 2 or later
 */
defined('_JEXEC') or die('Restricted Access not allowed');

if(!defined('DS'))
	define('DS', DIRECTORY_SEPARATOR );

if(!defined('SCMANAGER_VER'))
define('SCMANAGER_VER', '1.3.43' );

if(!defined('SCPLATFORM'))
	define('SCPLATFORM', "virtuemart" );

require_once("include.php");


if (!interface_exists('Throwable', false)) {
  class Throwable extends Exception {
  }
}

//$app  = JFactory::getApplication();
$lang = JFactory::getLanguage();
//$input = $app->input;

global $vm_lang;

$vm_lang  = $lang->get('tag',null);

if (!class_exists( 'VmConfig' ))
	require(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_virtuemart'. DIRECTORY_SEPARATOR .'helpers'. DIRECTORY_SEPARATOR .'config.php');


global $sc_luid;
if(!isset($sc_luid))
	$sc_luid = 0;


if(class_exists('vmAccess')){
	class SCvmAccess extends vmAccess {
		public static function resetCredentials($cred){
			global $sc_luid;
			//VM 3.0.10+
			self::$_cu = array();
			vmAccess::getBgManager($sc_luid);
			self::$_cu[0] = self::$_cu[$sc_luid];
			unset(self::$_cu[$sc_luid]);
		}
	};
	SCvmAccess::resetCredentials(array('username' => 'admin', 'password' => 'admin','silent' => true));
}

VmConfig::loadConfig(true);

if(!class_exists("SCvmAccess")){
	if(class_exists('vmAccess')){
		class SCvmAccess extends vmAccess {
			public static function resetCredentials($cred){
				global $sc_luid;
				//VM 3.0.10+
				self::$_cu = array();
				vmAccess::getBgManager($sc_luid);
				self::$_cu[0] = self::$_cu[$sc_luid];
				unset(self::$_cu[$sc_luid]);
			}
		};
		SCvmAccess::resetCredentials(array('username' => 'admin', 'password' => 'admin','silent' => true));
	}
}

if (!class_exists( 'calculationHelper' )) require(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_virtuemart'. DIRECTORY_SEPARATOR .'helpers'. DIRECTORY_SEPARATOR .'calculationh.php');
if (!class_exists( 'CurrencyDisplay' )) require(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_virtuemart'. DIRECTORY_SEPARATOR .'helpers'. DIRECTORY_SEPARATOR .'currencydisplay.php');
if (!class_exists( 'VirtueMartModelVendor' )) require(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_virtuemart'. DIRECTORY_SEPARATOR .'models'. DIRECTORY_SEPARATOR .'vendor.php');
if (!class_exists( 'VmImage' )) require(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_virtuemart'. DIRECTORY_SEPARATOR .'helpers'. DIRECTORY_SEPARATOR .'image.php');
if (!class_exists( 'shopFunctionsF' )) require(JPATH_SITE. DIRECTORY_SEPARATOR .'components'. DIRECTORY_SEPARATOR .'com_virtuemart'. DIRECTORY_SEPARATOR .'helpers'. DIRECTORY_SEPARATOR .'shopfunctionsf.php');
//if (!class_exists( 'calculationHelper' )) require(JPATH_COMPONENT_SITE. DIRECTORY_SEPARATOR .'helpers'. DIRECTORY_SEPARATOR .'cart.php');
if (!class_exists( 'VirtueMartModelProduct' )){
   JLoader::import( 'product', JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_virtuemart' . DIRECTORY_SEPARATOR . 'models' );
}

if(!defined('SC_VM_RUNV')){
   $v = explode(".",vmVersion::$RELEASE);
   if($v[0] > 2 || ($v[0] == 2 && $v[1] >= 9))
	define('SC_VM_RUNV',3);
   else
	define('SC_VM_RUNV',2);
}

class SCManager{

	var $db_lng_suffix         	  = "en_gb";
	var $user             		  = null;
	var $app               		  = null;
	var $db               		  = null;
	var $has_gtinmpn       		  = true;
	var $productModel      		  = null;
	var $categoryModel     		  = null;
	var $manufacturerModel 		  = null;
	var $customfieldModel  		  = null;
	var $calculator        		  = null;
	var $tbl               		  = array();
	var $default_shopper_group_id = 0;
	var $guest_shopper_group_id   = 0;
	var $QUERIES                  = array();
	var $SCMDEBUG                 = false;
	var $user_id                  = 0;
	var $datascope                = null;

	function __construct($dscope) {
		$this->datascope = $dscope;

		global $sc_luid;

		$this->user = JFactory::getUser($sc_luid);
		$this->app  = JFactory::getApplication();
		$this->db   = JFactory::getDBO();

		$jtoken = JSession::getFormToken();
		$this->app->input->set($jtoken,1);
		$this->user_id = $this->user->id;

		if(!isset($this->user_id))
			$this->user_id = 0;

		global $vm_lang;
		$this->languages        = null;//CONSTRUCT ON NEED getDBLanguages()
		$vm_lang                = VmConfig::get('vmlang',($vm_lang ? $vm_lang : "en_gb"));

		$this->db_lng_suffix    = strtolower(str_replace("-","_",$vm_lang));
		$this->default_language = $vm_lang;

		if(!$this->db_lng_suffix)
			$this->db_lng_suffix = "en_gb";

		$this->lng = explode("_",$this->db_lng_suffix);
		$this->lng[1] = strtoupper($this->lng[1]);
		$this->lng = implode("-",$this->lng);

		$this->root_url = rtrim(str_ireplace("/index.php","",JUri::root()),"/");

		$language = JFactory::getLanguage();
		vmLanguage::setLanguageByTag($this->lng, true);

		vmLanguage::loadJLang('com_virtuemart',"en-GB");
		vmLanguage::loadJLang('com_virtuemart',$this->lng);

		$language->load('com_virtuemart', JPATH_SITE, null,false);
		$language->load('com_virtuemart', JPATH_SITE . DIRECTORY_SEPARATOR . "components" . DIRECTORY_SEPARATOR . "com_virtuemart","en-GB",false);
		$language->load('com_virtuemart', JPATH_SITE . DIRECTORY_SEPARATOR . "components" . DIRECTORY_SEPARATOR . "com_virtuemart",$this->lng,false);

		$language->load('com_virtuemart', JPATH_ADMINISTRATOR, null,false);
		$language->load('com_virtuemart', JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . "components" . DIRECTORY_SEPARATOR . "com_virtuemart","en-GB",true);
		$language->load('com_virtuemart', JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . "components" . DIRECTORY_SEPARATOR . "com_virtuemart",$this->lng,true);

		$this->user_id = sc_read_sanitized_get_parm("user_id", $this->user_id);

		$this->vendor_id         = NULL;

		$this->settings = $this->getSettings();

		if(!isset($this->settings->import_multivalue_separator))
			$this->settings->import_multivalue_separator = ",";

		////////////////////////////////////////////////////////////
		$this->productModel      = VmModel::getModel('Product');
		$this->categoryModel     = VmModel::getModel('Category');
		$this->manufacturerModel = VmModel::getModel('Manufacturer');
		$this->customfieldModel  = VmModel::getModel('Customfields');
        ////////////////////////////////////////////////////////////
		global $sc_error_log_suppress;
		$sc_error_log_suppress = true;
		$this->calculator = calculationHelper::getInstance ();
		$sc_error_log_suppress = false;

		$this->db_sqlQuery("SHOW COLUMNS FROM #__virtuemart_products WHERE Field LIKE 'product_gtin' OR  Field LIKE 'product_mpn';");
		$this->has_gtinmpn = (count($this->db->loadObjectList()) == 2);

		$this->db_sqlQuery("SELECT `default`, virtuemart_shoppergroup_id FROM #__virtuemart_shoppergroups WHERE `default` > 0");
		$sgs = $this->db->loadAssocList("default");

		if(isset($sgs["1"]))
			$this->default_shopper_group_id = $sgs["1"]["virtuemart_shoppergroup_id"];

		if(isset($sgs["2"]))
			$this->guest_shopper_group_id   = $sgs["2"]["virtuemart_shoppergroup_id"];


		$mpaths = array(
						'media_category_path' => "images/stories/virtuemart/category",
						'media_product_path' => "images/stories/virtuemart/product",
						'media_manufacturer_path' => "images/stories/virtuemart/manufacturer",
						'media_vendor_path' => "images/stories/virtuemart/vendor"
					   );



		foreach($mpaths as $what => $path){
			$c_path = trim(VmConfig::get($what));
			if($c_path)
				$this->{$what} = $c_path;

			if(substr($this->{$what}, -1) == "/")
				$this->{$what} = substr($this->{$what},0,strlen($this->{$what}) - 1);

			$this->{$what . "_thumb"} = $this->{$what}. DIRECTORY_SEPARATOR . "resized";
		}

		$this->thumb_width  = VmConfig::get('img_width',220);
		$this->thumb_height = VmConfig::get('img_height',220);
	}
	
	function prepareSessionForUpdateTask(){
		
		try{
			vRequest::setVar("token",JSession::getFormToken());
		}catch(Throwable $settex){
			
		}
		
		if(!isset($this->__session_sqlmode_set)){
			$this->__session_sqlmode_set = 1;
			try{
				$this->db_sqlQuery("SET sql_mode='';");
				$this->db->execute();
			}catch(Throwable $ex){

			}
		}
	}

	function sessionGroupConcat(){
		if(!isset($this->__group_concat_max_len_set)){
			$this->__group_concat_max_len_set = 1;
			try{
				$this->db_sqlQuery("SET SESSION group_concat_max_len = 4294967295;");
				$this->db->execute();
			}catch(Throwable $ex){

			}
		}
	}

	function getDBLanguages(){
		if(!$this->languages){
			$this->languages = array();
			$vml = VmConfig::get('active_languages',array());
			foreach($vml as $lng){
			   $dblng = str_replace("-","_",strtolower($lng));
			   try{

					$this->db_sqlQuery("SELECT 1 FROM #__virtuemart_products_$dblng;");
					$res = $this->db->loadResult();
					if($res){
						$this->languages[] = $dblng;
					}
			   }catch(Throwable $ex){

			   }
			}
		}

		return $this->languages;
	}

	function zeroDateToNull($date){
		if($date){
			if(!trim(str_ireplace(array("0","-"," ","T","Z",":"),"", $date))){
				return null;
			}else{
				if(strpos($date,"1970-") === 0)
					return null;
				return $date;
			}
		}else
			return null;
	}

	function setDebug($do_debug){
		$this->SCMDEBUG = $do_debug;
	}

	function db_sqlQuery($query){
		global $sc_last_sql_query;
		$sc_last_sql_query = $query;

		$this->QUERIES[]  = $query;
		$this->db->setQuery($query);
	}

	function db_quote($val){
		if($val === NULL)
			return "NULL";
		else if(trim(strtoupper($val)) == "NOW()")
		    return "NOW()";
        else
			return
				$this->db->quote($val);
	}

	function db_query($sql = null){
		if($sql){
			$this->db_sqlQuery($sql);
		}
		return $this->db->execute();
	}

	function parseSeparatedParameters($src){
		if(is_string($src)){
			$src = str_getcsv($src,"|");
			$dst = array();
			foreach( $src as $token){
				$token = str_getcsv($token,"=");
				if(isset($token[0])){
					if($token[0]){
						$dst[$token[0]] = $token[1];
					}
				}
			}
			return $dst;
		}else
			return $src;
	}

	function is_intval($val){
		if(is_integer(trim($val)))
			return true;
		else{
			if(is_numeric(trim($val)) && strpos("".$val,".") === false)
				return true;
		}
		return false;
	}

	//RETURNS TABLE KEY AS PLACED INTO DATA
	function loadTableDefinition($table){
		if(stripos($table,"#__") === false){
			$pref  = str_ireplace("_","",$this->db->getPrefix());
			$table = str_ireplace($pref ."_","#__",$table);
		}

		if(!isset($this->tbl[$table])){
			$this->db_sqlQuery("SHOW COLUMNS FROM $table;");
			$this->tbl[$table] = $this->db->loadObjectList("Field");

			if($table == "#__virtuemart_product_customfields"){
				$this->custom_field_value_name = isset($this->tbl["#__virtuemart_product_customfields"]["customfield_value"]) ? "customfield_value" : "custom_value";
				$this->custom_field_price_name = isset($this->tbl["#__virtuemart_product_customfields"]["customfield_price"]) ? "customfield_price" : "custom_price";
				$this->custom_field_param_name = isset($this->tbl["#__virtuemart_product_customfields"]["customfield_params"]) ? "customfield_params" : "custom_param";
			}
		}


		return $table;
	}

	function jsnum($val){
		if($val)
			return floatval($val);
		else
			return null;
	}

	function toLoweCaseDB($str){
		global $db_case;
		if(!isset($db_case))
			$db_case   = JFactory::getDBO();
		$db_case->setQuery("SELECT LOWER(" . $db_case->quote($str) . ") as res");
		return $db_case->loadResult();
	}

	function fullTrim($str){
		return str_replace(array('  ','  ','  ','  '),array(' ', ' ', ' ', ' '),trim($str));
	}

	function normalizedLowercase($str){
		return $this->fullTrim($this->toLoweCaseDB($str));
	}

	function normalizedLowercaseHash($str){
		return str_replace(' ','',$this->toLoweCaseDB($str));
	}

	function translate($str, $arg1 = null, $arg2 = null, $arg3 = null){
		$res = "";

		$str = str_replace('% ','%% ',$str);

		if($arg3)
			$res = addslashes(JText::sprintf($str,$arg1,$arg2,$arg3));
		elseif($arg2)
			$res = addslashes(JText::sprintf($str,$arg1,$arg2));
		elseif($arg1)
			$res = addslashes(JText::sprintf($str,$arg1));
		else
			$res = addslashes(JText::sprintf($str));

		if(!$res)
			return addslashes($str);
		else
			return $res;
	}

	function saveSettings($data = null, $datascope = null){
		try{

			if(!$datascope)
				$datascope = $this->datascope;

			if(!$datascope)
				throw new Exception("DATASCOPE MISSING");

			$this->db_sqlQuery("SELECT params FROM #__extensions WHERE element LIKE 'com_sellingcommanderconnector'");
			$dbsettings = $this->db->loadResult();
			if($dbsettings){
				$dbsettings = json_decode($dbsettings);
			}

			if(!$dbsettings){
				$dbsettings = new stdClass;
			}

			if(!isset($dbsettings->{$datascope}))
				$dbsettings->{$datascope} = new stdClass;

			if($data){
				foreach($data as $sprop => $svalue){
					$dbsettings->{$datascope}->{$sprop} = $svalue;
				}
			}

			$this->prepareSessionForUpdateTask();
			$this->db_sqlQuery("UPDATE #__extensions SET params = " . $this->db_quote(json_encode($dbsettings)) . " WHERE element LIKE 'com_sellingcommanderconnector'");
			$this->db_query();

			return true;
		}catch(Throwable $ex){
			return $ex->getMessage();
		}
	}

	function getSettings($datascope = null){
		$scope = $datascope;
		if(!$scope)
			$scope = $this->datascope;

		if(!$scope)
			return null;

		$this->db_sqlQuery("SELECT params FROM #__extensions WHERE element LIKE 'com_sellingcommanderconnector'");
		$dbsettings = $this->db->loadResult();
		if($dbsettings){
			$dbsettings = json_decode($dbsettings);
			if($dbsettings){
				if(isset($dbsettings->{$scope})){
					return $dbsettings->{$scope};
				}
			}
		}
		return new stdClass;
	}

	function getProduct($id, $isolated_record = false){

		if($isolated_record){
			$res = $this->getProducts(1,1000,array("qwhere" => " p.virtuemart_product_id = " .$id . " "));
			if(isset($res->products[0]))
				return $res->products[0];
			return null;
		}else{
			$q  = "SELECT
					coalesce(
					  p4.virtuemart_product_id,
					  p3.virtuemart_product_id,
					  p2.virtuemart_product_id,
					  p1.virtuemart_product_id
					) as id
					FROM
					#__virtuemart_products as p1
					LEFT JOIN
					#__virtuemart_products as p2 on p2.product_parent_id = p1.virtuemart_product_id
					LEFT JOIN
					#__virtuemart_products as p3 on p3.product_parent_id = p2.virtuemart_product_id
					LEFT JOIN
					#__virtuemart_products as p4 on p4.product_parent_id = p3.virtuemart_product_id
					WHERE
					p1.virtuemart_product_id = " . $id;

			$this->db_sqlQuery($q);
            $ids = $this->db->loadColumn();
			$ids[] = $id;

			return $this->getProducts(1,1000,array("qwhere" => " p.virtuemart_product_id IN (" . implode(",",$ids) . ") "));
		}
	}


	public function checkAuxTables(){
		if(!isset($this->checked_aux_tables)){
			$this->checked_aux_tables = true;
			$pref = $this->db->getPrefix();
			if( substr($pref, strlen($pref) - 1) != "_"){
				$pref.= "_";
			}
			/*
			$this->db_sqlQuery("SHOW TABLES LIKE '%".$pref."sellingcommander_vm_pp_cache%'");
			if(!count($this->db->loadObjectList())){
				$this->db_sqlQuery(  "CREATE TABLE ".$pref."sellingcommander_vm_pp_cache (
								  id bigint(20) NOT NULL AUTO_INCREMENT,
								  virtuemart_product_id bigint(20) NOT NULL,
								  phash varchar(256) NOT NULL,
								  pdata varchar(8192) NOT NULL,
								  PRIMARY KEY (id),
								  INDEX virtuemart_product_id_index (virtuemart_product_id)
								) DEFAULT CHARSET=utf8;");
				$this->db->execute();
			}
			*/
		}
	}

	function getProductsSalePriceDeprecated($target, $virtuemart_product_id){
		$pr = $this->productModel->getProduct($virtuemart_product_id,false,false,false);
		$calsPrices = $this->calculator->getProductPrices($pr);

		if(is_object($target)){

			$target->product_basePriceWithTax   = $calsPrices["basePriceWithTax"];
			$target->product_sales_price        = $calsPrices["salesPriceTemp"];
			$target->product_discountAmount     = $calsPrices["discountAmount"];
			$target->product_taxAmount          = $calsPrices["taxAmount"];

		}elseif(is_array($target)){
			$target["product_basePriceWithTax"] = $calsPrices["basePriceWithTax"];
			$target["product_sales_price"]      = $calsPrices["salesPriceTemp"];
			$target["product_discountAmount"]   = $calsPrices["discountAmount"];
			$target["product_taxAmount"]        = $calsPrices["taxAmount"];
		}
	}

	/*
	function getProductPrices($pr){
		$pp_cache = null;
		if($pr->virtuemart_product_id){
			if(!isset($this->products_price_hash_checkpoint)){
				$this->db_sqlQuery("SELECT MAX(modified_on) as point FROM #__virtuemart_calcs;");
				$this->products_price_hash_checkpoint = $this->db->loadResult();
			}

			$this->checkAuxTables();
			$this->db_sqlQuery("SELECT * FROM #__sellingcommander_vm_pp_cache WHERE virtuemart_product_id = " . $pr->virtuemart_product_id);
			$pp_cache = $this->db->loadObject();
			if($pp_cache){
				if($pp_cache->phash == $this->products_price_hash_checkpoint . "-" . $pr->modified_on){
					return unserialize($pp_cache->pdata);
				}
			}
		}

		$prices = new stdClass();

		$allPrices = null;

		//if(!isset($pr->allPrices)){
			$pric_sql = "SELECT
							vpp.*
						 FROM
							#__virtuemart_product_prices as vpp
						 WHERE
							 vpp.virtuemart_product_id = {$pr->virtuemart_product_id}"

						 //AND
						//	 coalesce(vpp.price_quantity_start,0) + coalesce(vpp.price_quantity_end,0) = 0
						 //AND
						  //  (coalesce(vpp.virtuemart_shoppergroup_id,0) = 0 OR coalesce(vpp.virtuemart_shoppergroup_id,0) = {$this->default_shopper_group_id})

						 . " ORDER BY vpp.price_quantity_start, vpp.price_quantity_end, vpp.virtuemart_shoppergroup_id, vpp.virtuemart_product_price_id ASC LIMIT 0,999";
			$this->db_sqlQuery($pric_sql);
			$allPrices = $this->db->loadObjectList();
		//}else{
		//	$allPrices = $pr->allPrices;
		//}



		ob_start();

		if(!empty($allPrices)){
			foreach ($allPrices as $k => $sPrices) {

				if(SC_VM_RUNV < 3)
					$sPrices = (array)$sPrices;

				$price = null;

				if(SC_VM_RUNV < 3){
					if(count($sPrices) == 0)
						continue;

					if (empty($sPrices['virtuemart_product_price_id'])) {
						$sPrices['virtuemart_product_price_id'] = '';
					}

					$tmp_pr = (object)array_merge ((array)$pr, $sPrices);
					$calsPrices = $this->calculator->getProductPrices($pr);
					$price = array_merge($sPrices,(array)$calsPrices);
				}else{
					$pr->selectedPrice = $k;
					$calsPrices = $this->calculator->getProductPrices($pr);
					$price = array_merge($pr->allPrices[$k],$calsPrices);
				}

				if(!is_array($price))
					continue;

				if(!isset($price["virtuemart_product_price_id"]))
					continue;

				if(!$price["virtuemart_product_price_id"])
					continue;

				$p = new stdClass;
				$p->virtuemart_product_price_id      = $price["virtuemart_product_price_id"];
				$p->virtuemart_shoppergroup_id       = $price["virtuemart_shoppergroup_id"];
				$p->product_price                    = $price["product_price"];
				$p->product_override_price           = $price["product_override_price"];
				$p->price_quantity_start             = $price["price_quantity_start"];
				$p->price_quantity_end               = $price["price_quantity_end"];
				$p->product_sales_price              = $price["salesPriceTemp"];
				$p->product_tax_id                   = $price["product_tax_id"] ? $this->jsnum($price["product_tax_id"]) : 0;
				$p->product_discount_id              = $price["product_discount_id"] ? $this->jsnum($price["product_discount_id"]) : 0;
				$p->product_currency                 = $price["product_currency"] ? $this->jsnum($price["product_currency"]) : null;
				$p->product_price_publish_up         = $price["product_price_publish_up"];
				$p->product_price_publish_down       = $price["product_price_publish_down"];

				$p->product_price           = $this->jsnum($p->product_price);
				$p->product_override_price  = $this->jsnum($p->product_override_price);
				$p->product_sales_price     = $this->jsnum($p->product_sales_price);

				$prices->{$p->virtuemart_product_price_id}     = $p;

			}
		}
		ob_end_clean();



		if($pr->virtuemart_product_id){
			if($pp_cache){
				$this->db_sqlQuery("UPDATE #__sellingcommander_vm_pp_cache
										SET
										pdata = " . $this->db_quote(serialize($prices)) . " ,
										phash = " . $this->db_quote($this->products_price_hash_checkpoint . "-" . $pr->modified_on) . "
									WHERE
										virtuemart_product_id = " . $pr->virtuemart_product_id);
				$this->db->execute();
			}else{
				$this->db_sqlQuery("INSERT INTO #__sellingcommander_vm_pp_cache(id,virtuemart_product_id,phash,pdata)
									VALUES
									(NULL, ".$pr->virtuemart_product_id." , " . $this->db_quote($this->products_price_hash_checkpoint . "-" . $pr->modified_on) . ", " . $this->db_quote(serialize($prices)) . "  );");
				$this->db->execute();
			}
		}


		return $prices;
	}
	*/

	private function loadVmUser(){
		if(isset($this->_loadVmUserDone))
			return;

		$this->_loadVmUserDone = true;
		$this->vmuser = null;
		if($this->user_id){
			$this->db_sqlQuery("SELECT virtuemart_vendor_id, user_is_vendor FROM #__virtuemart_vmusers WHERE virtuemart_user_id = {$this->user_id}");
			//$this->vmuser = $this->db->loadObject();
			$this->vmuser = $this->getShopper($this->user_id, true);
		}
	}

	function getSiteInfo($for_orders = false){
		$info = new stdClass;

		$front_languages = JLanguageHelper::getLanguages();
		$site_languages  = array();
		foreach($front_languages as $lng){
			$site_languages[$lng->lang_code] = $lng->sef;
		}
		$info->languages = array();
	    $vml = VmConfig::get('active_languages',array());
		if(empty($vml)){
			$vml[] = $this->default_language;
		}

		foreach($vml as $lng){
		   $dblng = str_replace("-","_",strtolower($lng));
		   try{

				$this->db_sqlQuery("SELECT 1 FROM #__virtuemart_products_$dblng;");
				$res = $this->db->loadResult();
				if($res){
					if(isset($site_languages[$lng]) || $dblng == $this->default_language)
						$info->languages[$lng] = isset($site_languages[$lng]) ? $site_languages[$lng] : $dblng;
				}
		   }catch(Throwable $ex){
			   //
		   }
		}

		//if(count($info->languages))
		//	$info->languages["en-GB"] = "en";
		$info->root_url         = $this->root_url;
		$info->settings         = $this->settings;
		$info->SCMANAGER_VER    = SCMANAGER_VER;
		$info->SCPLATFORM       = SCPLATFORM;
		
		if(defined('JVERSION'))
			$info->JOOMLA_VER       = JVERSION;

		$info->current_lng      = $this->db_lng_suffix;
		$info->vendors          = $this->getVendors();
		$info->default_language = $this->default_language;

		$info->default_shopper_group_id = $this->default_shopper_group_id;
		$info->guest_shopper_group_id   = $this->guest_shopper_group_id;

		$info->media_category_path      = $this->media_category_path;
		$info->media_product_path       = $this->media_product_path;
		$info->media_manufacturer_path  = $this->media_manufacturer_path;
		$info->media_vendor_path        = $this->media_vendor_path;
		$info->post_max_size            = ini_get('post_max_size');
		global $sc_luid;
		$user                     = JFactory::getUser($sc_luid);

		$info->site_user = array(
			'username' => $user->username,
			'email'    => $user->email,
			'name'     => $user->name
		);

		if($user)
			$this->user_id = $user->id;

		$info->user_id = $this->user_id;
		$info->vmuser  = null;
		$this->loadVmUser();
		$info->vmuser = $this->vmuser;

		$info->default_currency    = null;
		$info->accepted_currencies = null;

		if($info->vmuser){
			if(intval($info->vmuser->virtuemart_vendor_id)){
				if(isset($info->vendors[$info->vmuser->virtuemart_vendor_id])){
					$info->default_currency    = intval($info->vendors[$info->vmuser->virtuemart_vendor_id]->vendor_currency);
					$info->accepted_currencies = explode(",",$info->vendors[$info->vmuser->virtuemart_vendor_id]->vendor_accepted_currencies);
				}
			}else{
				$v = reset($info->vendors);
				if($v){
					$info->default_currency    = intval($v->vendor_currency);
					$info->accepted_currencies = explode(",",$v->vendor_accepted_currencies);
				}
			}
		}

		if(!$info->site_user['username'])
			$info->site_user['error'] = 404;
		else if($user->block)
			$info->site_user['error'] = 403;

		if($for_orders || $this->datascope == "orders" || $this->datascope == "b2b"){
			try{
				$this->db_sqlQuery("SELECT f.virtuemart_userfield_id,
										   f.virtuemart_vendor_id,
										   f.userfield_jplugin_id,
										   f.name,
										   f.title,
										   f.description,
										   f.type,
										   f.maxlength,
										   f.required,
										   f.value,
										   f.default,
										   f.registration,
										   f.shipment,
										   f.account,
										   f.cart,
										   f.readonly,
										   f.calculated,
										   f.sys,
										   f.published
										   FROM
										   #__virtuemart_userfields as f ORDER BY f.ordering
										   ");

				$info->ufields = $this->db->loadObjectList("virtuemart_userfield_id");
				$this->db_sqlQuery("SELECT virtuemart_userfield_value_id, virtuemart_userfield_id, fieldtitle, fieldvalue FROM #__virtuemart_userfield_values");
				$fvalues = $this->db->loadObjectList();

				foreach($fvalues as $fvalue){
					if(isset($info->ufields[$fvalue->virtuemart_userfield_id])){
						if(!isset($info->ufields[$fvalue->virtuemart_userfield_id]->values))
							$info->ufields[$fvalue->virtuemart_userfield_id]->values = array();
						$info->ufields[$fvalue->virtuemart_userfield_id]->values[$fvalue->fieldvalue] = JText::sprintf($fvalue->fieldtitle);
					}
				}

				foreach($info->ufields as $index => $ufiled){
					$info->ufields[$index]->title = str_replace(array("COM_VIRTUEMART_","_"),array(""," "),JText::sprintf($info->ufields[$index]->title));
				}


				$this->db_sqlQuery("SELECT max(st_adr_count) + 1 FROM
										(
											SELECT
												virtuemart_user_id,
												count(virtuemart_userinfo_id) as st_adr_count
											FROM #__virtuemart_userinfos
											WHERE address_type = 'ST'
											GROUP BY virtuemart_user_id
										) as t");
				$info->max_shipping_adresses = $this->db->loadResult();
				if(!$info->max_shipping_adresses)
					$info->max_shipping_adresses = 2;
			}catch(Throwable $ex){
				$info->info_load_error = $ex->getMessage();
			}
		}

		return $info;
	}

	function getVendors(){
		if(!isset($this->vendors)){
			$this->db_sqlQuery("SELECT * FROM #__virtuemart_vendors;");
			$this->vendors = $this->db->loadObjectList("virtuemart_vendor_id");
		}
		return $this->vendors;
	}

	function coalesce() {
	  $args = func_get_args();
	  foreach ($args as $arg) {
		if ($arg) {
		  return $arg;
		}
	  }
	  return NULL;
	}

	function getShopper($id, $include_all_data = false){
		$res = $this->getShoppers(1,1, array("qwhere" => " vu.virtuemart_user_id = " . $this->db_quote($id)));
		if(!empty($res->shoppers)){
			$shopper = reset($res->shoppers);
			if($shopper && $include_all_data){
				if(isset($shopper->BT)){
					if(intval($shopper->BT->virtuemart_country_id)){
						$shopper->BT->country = $this->getCountry($shopper->BT->virtuemart_country_id);
					}
					if(intval($shopper->BT->virtuemart_state_id)){
						$shopper->BT->state = $this->getState($shopper->BT->virtuemart_state_id);
					}
				}

				for($i = 1; $i < 10;$i++){
					if(isset($shopper->{"ST{$i}"})){
						if(intval($shopper->{"ST{$i}"}->virtuemart_country_id)){
							$shopper->{"ST{$i}"}->country = $this->getCountry($shopper->{"ST{$i}"}->virtuemart_country_id);
						}
						if(intval($shopper->{"ST{$i}"}->virtuemart_state_id)){
							$shopper->{"ST{$i}"}->state = $this->getState($shopper->{"ST{$i}"}->virtuemart_state_id);
						}
					}else
						break;
				}
			}
			return $shopper;
		}else
			return null;
	}

	function getShoppers($page, $limit, $additional_loaddata = null){
		if(!$page)
			$page = 1;

		if(!$limit)
			$limit = 999999999;

		$response = new stdClass;
		$response->shoppers = array();
		$offset = ($page - 1) * $limit;

		$add_q  = "";
		$vendor = "";

		if($additional_loaddata){
			if(sc_get_object_value($additional_loaddata,"qwhere"))
				$add_q   = " and (" . sc_get_object_value($additional_loaddata,"qwhere") . ") ";

			if(sc_get_object_value($additional_loaddata,"vendor"))
				$vendor  = " and vu.virtuemart_vendor_id = " . sc_get_object_value($additional_loaddata,"vendor") . " ";
		}

		if($page == 1){
			$this->db_sqlQuery("SELECT count(vu.virtuemart_user_id) as shopper_count FROM #__virtuemart_vmusers as vu WHERE 1 = 1 {$add_q} {$vendor}");
			$response->shopper_count = $this->db->loadResult();
			$response->item_count  = $response->shopper_count;
		}

		$this->db_sqlQuery("SELECT
								vu.virtuemart_user_id,
								vu.virtuemart_vendor_id,
								vu.user_is_vendor,
								vu.customer_number,
								vu.virtuemart_paymentmethod_id,
								vu.virtuemart_shipmentmethod_id,
								vu.agreed,
								u.email,
								u.name,
								u.username
							FROM
								#__virtuemart_vmusers as vu
								LEFT JOIN
								#__users as u on u.id = vu.virtuemart_user_id
							WHERE
								1 = 1 {$add_q} {$vendor}
							ORDER BY vu.virtuemart_user_id ASC LIMIT {$offset}, {$limit} ");

		$response->shoppers = $this->db->loadObjectList("virtuemart_user_id");

        $first_id = 0;
		$last_id  = 0;

		if(isset($response->shoppers)){
			if(!empty($response->shoppers)){
				reset($response->shoppers);
				$last_id = key($response->shoppers);
				end($response->shoppers);
				$first_id = key($response->shoppers);
				if($first_id > $last_id){
					$tmp      = $first_id;
					$first_id = $last_id;
					$last_id  = $tmp;
				}
			}
		}

		if(!$first_id)
			$first_id = 0;

		if(!$last_id)
			$last_id  = 0;

		$response->first_id = $first_id;
		$response->last_id  = $last_id;

		if(!empty($response->shoppers)){
			$this->db_sqlQuery("SELECT
								*
								FROM #__virtuemart_userinfos
								WHERE virtuemart_user_id >= {$first_id} AND virtuemart_user_id <= {$last_id}
								ORDER BY virtuemart_user_id ASC");
			$userinfos = $this->db->loadObjectList();

			$this->db_sqlQuery("SELECT
									virtuemart_user_id,
									virtuemart_shoppergroup_id
								FROM #__virtuemart_vmuser_shoppergroups
								WHERE virtuemart_user_id >= {$first_id} AND virtuemart_user_id <= {$last_id}
								ORDER BY virtuemart_user_id ASC");
			$usershoppergroups = $this->db->loadObjectList();

			$this->db_sqlQuery("SELECT
									user_id,
									group_id
								FROM #__user_usergroup_map
								WHERE user_id >= {$first_id} AND user_id <= {$last_id}
								ORDER BY user_id ASC");

			$userjoomlagroups = $this->db->loadObjectList();


			if(!empty($userinfos)){
				foreach($userinfos as $userinfo){
					if(isset($response->shoppers[$userinfo->virtuemart_user_id])){
						if($userinfo->address_type){
							if($userinfo->address_type == "BT"){
								$response->shoppers[$userinfo->virtuemart_user_id]->{$userinfo->address_type} = $userinfo;
							}else{
								$n = 1;
								while(isset($response->shoppers[$userinfo->virtuemart_user_id]->{$userinfo->address_type . $n})){
									$n++;
								}
								$response->shoppers[$userinfo->virtuemart_user_id]->{$userinfo->address_type . $n} = $userinfo;
							}
						}
					}
				}
			}

			if(!empty($usershoppergroups)){
				foreach($usershoppergroups as $usershoppergroup){
					if(isset($response->shoppers[$usershoppergroup->virtuemart_user_id])){
						if(!isset($response->shoppers[$usershoppergroup->virtuemart_user_id]->shoppergroups)){
							$response->shoppers[$usershoppergroup->virtuemart_user_id]->shoppergroups = array(intval($usershoppergroup->virtuemart_shoppergroup_id));
						}else{
							$response->shoppers[$usershoppergroup->virtuemart_user_id]->shoppergroups[] = intval($usershoppergroup->virtuemart_shoppergroup_id);
						}
					}
				}
			}

			if(!empty($userjoomlagroups)){
				foreach($userjoomlagroups as $userjoomlagroup){
					if(isset($response->shoppers[$userjoomlagroup->user_id])){
						if($userjoomlagroup->group_id == 7 || $userjoomlagroup->group_id == 8){
							$response->shoppers[$userjoomlagroup->user_id]->is_admin = 1;
						}
						if(!isset($response->shoppers[$userjoomlagroup->user_id]->jgroups)){
							$response->shoppers[$userjoomlagroup->user_id]->jgroups = array(intval($userjoomlagroup->group_id));
						}else{
							$response->shoppers[$userjoomlagroup->user_id]->jgroups[] = intval($userjoomlagroup->group_id);
						}
					}
				}
			}
		}

		$response->lng = $this->db_lng_suffix;
		return $response;
	}

	function getVendor($id){
		if(!$id)
			return null;

		$vendors = $this->getVendors();
		if(isset($vendors[$id]))
			return $vendors[$id];
		else
			return null;
	}

	function getCurrency($id){
		if(!$id)
			return null;
		$this->db_sqlQuery("SELECT virtuemart_currency_id , currency_code_3, currency_exchange_rate
							FROM #__virtuemart_currencies
							WHERE virtuemart_currency_id = " . $this->db_quote($id));
		return $this->db->loadObject();
	}

	function getCountry($id){
		if(!$id)
			return null;
		$this->db_sqlQuery("SELECT m.virtuemart_country_id,  m.country_name, m.country_3_code, m.country_2_code FROM #__virtuemart_countries as m WHERE m.virtuemart_country_id = " . $this->db_quote($id));
		$country = $this->db->loadObject();
		$country->country_name = JText::sprintf($country->country_name);
		return $country;
	}

	function getState($id){
		if(!$id)
			return null;

		$this->db_sqlQuery("SELECT  m.virtuemart_state_id,
									m.virtuemart_country_id,
									m.state_name,
									m.state_3_code,
									m.state_2_code FROM #__virtuemart_states as m WHERE m.virtuemart_state_id = " . $this->db_quote($id));
		$state = $this->db->loadObject();
		$state->state_name = JText::sprintf($state->state_name);
		return $state;
	}

	function getStatusObject($id){
		$this->db_sqlQuery("SELECT * FROM #__virtuemart_orderstates WHERE virtuemart_orderstate_id = " . $this->db_quote($id));
		$status = $this->db->loadObject();
		if($status){
			$status->order_status_name = JText::sprintf($status->order_status_name);
		}
		return $status;
	}

	function getStatusObjectByCode($status_code, $vendor_id = null){
		$vendor ="";
		if($vendor_id)
			$vendor = " AND virtuemart_vendor_id = " . $this->db_quote($vendor_id);
		$this->db_sqlQuery("SELECT * FROM #__virtuemart_orderstates WHERE order_status_code = " . $this->db_quote($status_code) . $vendor);
		$status = $this->db->loadObject();
		if($status){
			$status->order_status_name = JText::sprintf($status->order_status_name);
		}
		return $status;
	}

	function getPaymentMethod($id){
		$this->db_sqlQuery("SELECT m.*, l.* FROM #__virtuemart_paymentmethods as m LEFT JOIN #__virtuemart_paymentmethods_{$this->db_lng_suffix} as l ON l.virtuemart_paymentmethod_id = m.virtuemart_paymentmethod_id
							WHERE m.virtuemart_paymentmethod_id = " . $this->db_quote($id));
		$paymentmethod = $this->db->loadObject();
		if($paymentmethod){
			$paymentmethod->payment_params = $this->parseSeparatedParameters($paymentmethod->payment_params);
		}
		return $paymentmethod;
	}

	function getShipmentMethod($id){
		$this->db_sqlQuery("SELECT m.*, l.* FROM #__virtuemart_shipmentmethods as m LEFT JOIN #__virtuemart_shipmentmethods_{$this->db_lng_suffix} as l ON l.virtuemart_shipmentmethod_id = m.virtuemart_shipmentmethod_id
							WHERE m.virtuemart_shipmentmethod_id = "  . $this->db_quote($id));
		$shipmentmethod = $this->db->loadObject();

		if($shipmentmethod){
			$shipmentmethod->shipment_params = $this->parseSeparatedParameters($shipmentmethod->shipment_params);
		}
		return $shipmentmethod;
	}

	function getProductCustomfileds($virtuemart_product_id){
		$this->loadTableDefinition("#__virtuemart_product_customfields");

		if(!isset($this->virtuemart_customs)){
			$this->loadCustomfieldsDefinitions();
		}

		$this->db_sqlQuery("SELECT virtuemart_product_id, virtuemart_customfield_id, virtuemart_custom_id, {$this->custom_field_value_name} as custom_value , {$this->custom_field_price_name} as custom_price , {$this->custom_field_param_name} as custom_param
						  FROM #__virtuemart_product_customfields
						  WHERE virtuemart_product_id = " . $this->db_quote($virtuemart_product_id));

		$product_custom_fields = $this->db->loadObjectList();

		$pcfs = new stdClass;

		if(!empty($product_custom_fields)){
			for($pcf_cur = 0; $pcf_cur < count($product_custom_fields);$pcf_cur++){
				$cid = $product_custom_fields[$pcf_cur]->virtuemart_custom_id;
				if(!isset($pcfs->{ $cid })){
					$pcfs->{ $cid } = new stdClass;
				}
				$cf = new stdClass;
				$cf->id    = $product_custom_fields[$pcf_cur]->virtuemart_customfield_id;
				$cf->value = $product_custom_fields[$pcf_cur]->custom_value;
				$cf->price = $product_custom_fields[$pcf_cur]->custom_price;
				$cf->param = $product_custom_fields[$pcf_cur]->custom_param;

				$pcfs->{ $cid }->{ $cf->id } = $cf;
			}
		}
		return $pcfs;
	}

	function parseOrderItemAttributes(&$order_item, &$order){
		if(!$order_item->product_attribute){
			return;
		}

		$attr_non_parsed = null;

		if(is_string($order_item->product_attribute)){
			$attr_non_parsed = $order_item->product_attribute;
			$order_item->product_attribute = json_decode($attr_non_parsed, true);
		}

		if($order_item->product_attribute){
			$pcfs = null;
			foreach($order_item->product_attribute as $cid => $pcid){
				if(is_array($pcid)){//WHEN NO VALUE THERE IS EMPTY ARRAY SET
					continue;
				}

				$set = false;
				if(isset($order->additional_pcfs)){
					if(isset($order->additional_pcfs[$pcid])){
						$order_item->product_attribute[$cid] = $order->additional_pcfs[$pcid];
						$set = true;
					}
				}
				if(!$set){
					if(!$pcfs && intval($order_item->virtuemart_product_id)){
						$pcfs = $this->getProductCustomfileds($order_item->virtuemart_product_id);
					}
					if(isset($pcfs->{ $cid })){
						if(isset($pcfs->{ $cid }->{ $pcid })){
							$order_item->product_attribute[ $cid ] = (array)$pcfs->{ $cid }->{ $pcid };
						}
					}
				}
			}
		}else if($attr_non_parsed){
			$order_item->product_attribute = $attr_non_parsed;
		}
	}

	function getOrder($id, $include_all_data = false){
		$res = $this->getOrders(null,null,1,1, array("qwhere" => " O.virtuemart_order_id = " . $this->db_quote($id)));
		if(!empty($res->orders)){
			$order = reset($res->orders);
			if($order && $include_all_data){

				$order->shopper          = $this->getShopper($order->virtuemart_user_id, true);
				$order->currency         = $this->getCurrency($order->order_currency);
				$order->user_currency    = $this->getCurrency($order->user_currency_id);
				$order->payment_currency = $this->getCurrency($order->payment_currency_id);
				$order->status 		     = $this->getStatusObjectByCode($order->order_status,$order->virtuemart_vendor_id);
				$order->vendor 		     = $this->getVendor($order->virtuemart_vendor_id);
				$order->payment_method   = $this->getPaymentMethod($order->virtuemart_paymentmethod_id);
				$order->shipment_method  = $this->getShipmentMethod($order->virtuemart_shipmentmethod_id);

				if(isset($order->BT)){
					if(intval($order->BT->virtuemart_country_id)){
						$order->BT->country = $this->getCountry($order->BT->virtuemart_country_id);
					}
					if(intval($order->BT->virtuemart_state_id)){
						$order->BT->state   = $this->getState($order->BT->virtuemart_state_id);
					}
				}

				if(isset($order->ST)){
					if(intval($order->ST->virtuemart_country_id)){
						$order->ST->country = $this->getCountry($order->ST->virtuemart_country_id);
					}

					if(intval($order->ST->virtuemart_state_id)){
						$order->ST->state = $this->getCountry($order->ST->virtuemart_state_id);
					}
				}

				foreach($order->order_items as $oi_id => $order_item){
					$this->parseOrderItemAttributes($order->order_items[$oi_id], $order);
				}
			}
			return $order;
		}else
			return null;
	}

	function getOrders($from_date, $to_date, $page, $limit, $additional_loaddata = null){
		global $sc_luid;
		if(!$page)
			$page = 1;

		if(!$limit)
			$limit = 999999999;

		if(!isset($this->virtuemart_customs)){
			$this->loadCustomfieldsDefinitions();
		}

		$response = new stdClass;
		$response->orders = array();
		$offset = ($page - 1) * $limit;

		$add_q  = "";
		$vendor = "";

		if($additional_loaddata){
			if(sc_get_object_value($additional_loaddata,"qwhere"))
				$add_q   = " and (" . sc_get_object_value($additional_loaddata,"qwhere") . ") ";

			if(sc_get_object_value($additional_loaddata,"vendor"))
				$vendor  = " and O.virtuemart_vendor_id = " . sc_get_object_value($additional_loaddata,"vendor") . " ";
		}

		if($this->datascope == "b2b"){
			$add_q .= " and (O.virtuemart_vendor_id = " . $this->db_quote($sc_luid) . " OR O.virtuemart_user_id = " . $this->db_quote($sc_luid) . " ) ";
		}

		$response->order_count = 0;

		if($from_date){
			$add_q .= " AND DATE_FORMAT(O.created_on, '%Y-%m-%d') >= " . $this->db_quote($from_date) . " ";
		}

		if($to_date){
			$add_q .= " AND DATE_FORMAT(O.created_on, '%Y-%m-%d') <= " . $this->db_quote($to_date) . " ";
		}

		if($page == 1){
			$this->db_sqlQuery("SELECT count(O.virtuemart_order_id) FROM
								  #__virtuemart_orders as O
							    WHERE
							      1 = 1
								  ". $add_q . $vendor);
			$response->order_count = $this->db->loadResult();
			$response->item_count  = $response->order_count;
		}

		$this->db_sqlQuery("SELECT * FROM
								  #__virtuemart_orders as O
							WHERE
							      1 = 1
								  ". $add_q . $vendor ."
							ORDER BY O.virtuemart_order_id DESC LIMIT {$offset}, {$limit} ");

		$response->orders = $this->db->loadObjectList("virtuemart_order_id");

		$order_calc_rules      = null;
		$order_histories       = null;
		$order_items           = null;
		$order_additional_pcfs = null;
		$order_userinfos       = null;

		$first_id = 0;
		$last_id  = 0;

		if(isset($response->orders)){
			if(!empty($response->orders)){
				reset($response->orders);
				$last_id = key($response->orders);
				end($response->orders);
				$first_id = key($response->orders);
				if($first_id > $last_id){
					$tmp      = $first_id;
					$first_id = $last_id;
					$last_id  = $tmp;
				}
			}
		}

		if(!$first_id)
			$first_id = 0;

		if(!$last_id)
			$last_id  = 0;

		$response->first_id = $first_id;
		$response->last_id  = $last_id;

		if(!empty($response->orders)){
			////////////////////////////////////////////////////////////////////////////////////////////////
			$this->db_sqlQuery("SELECT * FROM #__virtuemart_order_histories
								WHERE
							      virtuemart_order_id >= {$first_id} AND virtuemart_order_id <= {$last_id}
								ORDER BY virtuemart_order_id, virtuemart_order_history_id");
			$order_histories = $this->db->loadObjectList();
			////////////////////////////////////////////////////////////////////////////////////////////////
			$this->db_sqlQuery("SELECT * FROM #__virtuemart_order_items
								WHERE
							      virtuemart_order_id >= {$first_id} AND virtuemart_order_id <= {$last_id}
								ORDER BY virtuemart_order_id, virtuemart_order_item_id");
			$order_items = $this->db->loadObjectList();
			////////////////////////////////////////////////////////////////////////////////////////////////
			$this->db_sqlQuery("SELECT * FROM #__virtuemart_order_userinfos
								WHERE
							      virtuemart_order_id >= {$first_id} AND virtuemart_order_id <= {$last_id}
							    ORDER BY virtuemart_order_id, virtuemart_order_userinfo_id");
			$order_userinfos = $this->db->loadObjectList();
			////////////////////////////////////////////////////////////////////////////////////////////////
			$this->loadTableDefinition("#__virtuemart_product_customfields");


			$this->db_sqlQuery("SELECT
									virtuemart_customfield_id  as id,
									{$this->custom_field_value_name} as value,
									{$this->custom_field_price_name} as price,
									{$this->custom_field_param_name} as param,
									-virtuemart_product_id     as virtuemart_order_id,
									virtuemart_custom_id       as cid
								FROM #__virtuemart_product_customfields WHERE virtuemart_product_id >= (-{$last_id}) AND virtuemart_product_id <= -{$first_id} ORDER BY -virtuemart_product_id");
			$order_additional_pcfs = $this->db->loadObjectList();

			////////////////////////////////////////////////////////////////////////////////////////////////
			if(!empty($order_histories)){
				for($i = 0; $i < count($order_histories);$i++){
					$virtuemart_order_id = $order_histories[$i]->virtuemart_order_id;
					if(isset($response->orders[$virtuemart_order_id])){
						if(!isset($response->orders[$virtuemart_order_id]->order_histories))
							$response->orders[$virtuemart_order_id]->order_histories = array();
						$response->orders[$virtuemart_order_id]->order_histories[$order_histories[$i]->virtuemart_order_history_id] = $order_histories[$i];
					}
				}
			}
			////////////////////////////////////////////////////////////////////////////////////////////////
			if(!empty($order_items)){
				for($i = 0; $i < count($order_items);$i++){
					$virtuemart_order_id = $order_items[$i]->virtuemart_order_id;
					if(isset($response->orders[$virtuemart_order_id])){
						if(!isset($response->orders[$virtuemart_order_id]->order_items))
							$response->orders[$virtuemart_order_id]->order_items = array();
						$response->orders[$virtuemart_order_id]->order_items[$order_items[$i]->virtuemart_order_item_id] = $order_items[$i];
					}
				}
			}
			////////////////////////////////////////////////////////////////////////////////////////////////
			if(!empty($order_userinfos)){
				for($i = 0; $i < count($order_userinfos);$i++){
					$virtuemart_order_id = $order_userinfos[$i]->virtuemart_order_id;
					if(isset($response->orders[$virtuemart_order_id])){
						if($order_userinfos[$i]->address_type == "ST"){
							$response->orders[$virtuemart_order_id]->ST = $order_userinfos[$i];
						}else if($order_userinfos[$i]->address_type == "BT"){
							$response->orders[$virtuemart_order_id]->BT = $order_userinfos[$i];
						}else{
							if(!isset($response->orders[$virtuemart_order_id]->order_userinfos))
								$response->orders[$virtuemart_order_id]->order_userinfos = array();
							$response->orders[$virtuemart_order_id]->order_userinfos[$order_userinfos[$i]->virtuemart_order_userinfo_id] = $order_userinfos[$i];
						}
					}
				}
			}
			////////////////////////////////////////////////////////////////////////////////////////////////
			if(!empty($order_additional_pcfs)){
				for($i = 0; $i < count($order_additional_pcfs);$i++){
					$virtuemart_order_id = $order_additional_pcfs[$i]->virtuemart_order_id;
					if(!isset($response->orders[$virtuemart_order_id]->additional_pcfs))
							$response->orders[$virtuemart_order_id]->additional_pcfs = new stdClass();
					$response->orders[$virtuemart_order_id]->additional_pcfs->{$order_additional_pcfs[$i]->id} = $order_additional_pcfs[$i];
				}
			}
		}
		
		if($this->datascope == "orders"){
			$udf_settings_prop = "udf_settings";
			if(isset($this->settings)){
				if(isset($this->settings->{$udf_settings_prop})){
					if(count($this->settings->{$udf_settings_prop})){
						foreach($this->settings->{$udf_settings_prop} as $udf){
							if($udf->udf_enabled && isset($udf->udf_get)){
								if(isset($udf->query_single)){
									if($udf->query_single){
										continue;
									}
								}
								if($udf->udf_get){
									$this->udfOrdersGet($response->orders,$response->first_id,$response->last_id,$udf);
								}
							}
						}
					}
				}
			}
		}

		$response->lng = $this->db_lng_suffix;

		return $response;
	}

	private function assocDataToUpdQuery($data, $table){
		if(!$data)
			return null;

		if(empty($data))
			return null;

		$this->loadTableDefinition($table);

		$data = (array)$data;

		if(isset($this->tbl[$table]["modified_on"])) $data["modified_on"] = "NOW()";
		if(isset($this->tbl[$table]["modified_by"])) $data["modified_by"] = $this->user_id;

		$upd = array();
		foreach($data as $key => $value){
			if(!isset($this->tbl[$table][$key]))
				continue;

			if(stripos(trim($value),"NOW()") === 0){
				$upd[] = (" `{$key}` = NOW() ");
			}else{
				if($value == null && stripos($this->tbl[$table][$key]->Null,"No") === 0){
					if($this->tbl[$table][$key]->Default === null){
						if(in_array($this->tbl[$table][$key]->Type,array("int","long","bigint","tinyint"))){
							$value = 0;
						}else
							$value = "";
					}else
						$value = $this->tbl[$table][$key]->Default;
				}
				$upd[] = (" `{$key}` = " . $this->db_quote($value) . " ");
			}
		}
		return implode(", ", $upd);
	}

	private function assocDataToInsQuery($data, $table){
		if(!$data)
			return null;

		if(empty($data))
			return null;

		$this->loadTableDefinition($table);

		$data = (array)$data;

		if(isset($this->tbl[$table]["modified_on"])) $data["modified_on"] = "NOW()";
		if(isset($this->tbl[$table]["created_on"])) $data["created_on"]  = "NOW()";
		if(isset($this->tbl[$table]["modified_by"])) $data["modified_by"] = $this->user_id;
		if(isset($this->tbl[$table]["created_by"])) $data["created_by"]  = $this->user_id;

		$ins = array(
			"columns" => array(),
			"values"  => array()
		);

		foreach($data as $key => $value){
			if(!isset($this->tbl[$table][$key]))
				continue;

			$ins["columns"][] = "`{$key}`";
			if(stripos(trim($value),"NOW()") === 0){
				$ins["values"][]  = "NOW()";
			}else{
				if($value == null && stripos($this->tbl[$table][$key]->Null,"No") === 0){
					if($this->tbl[$table][$key]->Default === null){
						if(in_array($this->tbl[$table][$key]->Type,array("int","long","bigint","tinyint"))){
							$value = 0;
						}else
							$value = "";
					}else
						$value = $this->tbl[$table][$key]->Default;
				}
				$ins["values"][]  = $this->db_quote($value);
			}
		}

		$ins["columns"] = implode(", ",$ins["columns"]);
		$ins["values"] = implode(", ",$ins["values"]);

		return $ins;
	}

	public function delete_shoppers($data,&$err){
		global $scerr;
		if(!SCvmAccess::manager('user.edit')){
			$scerr[0]           = "The account you use to access site is not permitted to edit shoppers!";
			return null;
		}

		if(isset($data->shoppers)){
			foreach($data->shoppers as $shpInd => $sdata){
				$data->shoppers->{$shpInd} = $this->delete_shoppers($sdata,$err);
			}
			return $data;
		}

		if($data){
			try{
				if(isset($data->virtuemart_user_id)){
					$this->db_sqlQuery("SELECT virtuemart_user_id FROM #__virtuemart_vmusers WHERE user_is_vendor > 0 AND virtuemart_user_id = " . $this->db_quote($data->virtuemart_user_id));

					if($this->db->loadResult()){
						$data->error = "You can not delete vendors from S.C.";
						return $data;
					}

					$this->db_sqlQuery("DELETE FROM #__virtuemart_vmuser_shoppergroups WHERE virtuemart_user_id = " . $this->db_quote($data->virtuemart_user_id));
					$this->db_query();

					$this->db_sqlQuery("DELETE FROM #__virtuemart_userinfos WHERE virtuemart_user_id = " . $this->db_quote($data->virtuemart_user_id));
					$this->db_query();

					$this->db_sqlQuery("DELETE FROM #__virtuemart_vmusers WHERE virtuemart_user_id = " . $this->db_quote($data->virtuemart_user_id));
					$this->db_query();

					$this->db_sqlQuery("SELECT group_id FROM #__user_usergroup_map WHERE group_id in (7,8) AND user_id = " . $this->db_quote($data->virtuemart_user_id));

					if(!$this->db->loadResult()){
						$this->db_sqlQuery("DELETE FROM #__users WHERE id = " . $this->db_quote($data->virtuemart_user_id));
						$this->db_query();

						$this->db_sqlQuery("DELETE FROM #__user_usergroup_map WHERE user_id = " . $this->db_quote($data->virtuemart_user_id));
						$this->db_query();
					}

					$data->deleted = 1;
				}
			}catch(Throwable $ex){
				$err[] = $ex->getMessage();
				$data->error = $ex->getMessage();
			}
		}
		return $data;
	}

	public function update_shoppers($data,&$err){

		global $scerr;
		if(!SCvmAccess::manager('user.edit')){
			$scerr[0]           = "The account you use to access site is not permitted to edit shoppers!";
			return null;
		}

		if(isset($data->shoppers)){
			foreach($data->shoppers as $shpInd => $sdata){
				$data->shoppers->{$shpInd} = $this->update_shoppers($sdata,$err);
			}
			return $data;
		}
		
		$this->prepareSessionForUpdateTask();

		if($data){
			try{
				$shopper = null;
				$virtuemart_user_id = intval(sc_get_object_value($data, "virtuemart_user_id",null));
				if($virtuemart_user_id){
					$shopper = $this->getShopper($virtuemart_user_id, true);
				}

				$update_u  = array();
				$update_vu = array();
				$update_bt = array();

				$update_st = null;
				$update_sg = -1;

				foreach($data as $key => $value){
					if(strpos($key,"_") === 0)
						continue;

					if($key == "email" || $key == "name" || $key == "username"){
						$update_u[$key] = $value;
					}else if($key == "customer_number" || $key == "virtuemart_paymentmethod_id" || $key == "virtuemart_shipmentmethod_id"){
						$update_vu[$key] = $value;
					}else if ($key == "shoppergroups"){
						$update_sg = $value;
					}else if($key == "BT"){
						$update_bt = (array)$value;
					}else if(strpos($key,"ST") === 0){
						if($update_st === null)
							$update_st = array();

						if($value){
							$st = (array)$value;
							if(!isset($st["virtuemart_userinfo_id"])){
								if(isset($shopper->{$key})){
									$st["virtuemart_userinfo_id"] = $shopper->{$key}->virtuemart_userinfo_id;
								}
							}else if(!$st["virtuemart_userinfo_id"]){
								if(isset($shopper->{$key})){
									$st["virtuemart_userinfo_id"] = $shopper->{$key}->virtuemart_userinfo_id;
								}
							}
							$update_st[] = $st;
						}else if($shopper){
							if(isset($shopper->{$key})){
								$this->db_sqlQuery("DELETE FROM #__virtuemart_userinfos WHERE virtuemart_userinfo_id = " . $this->db_quote( $shopper->{$key}->virtuemart_userinfo_id));
								$this->db_query();
							}
						}
					}
				}

				if($shopper){
					$is_admin = false;
					if(isset($shopper->jgroups)){
						if(in_array(7, $shopper->jgroups) || in_array(8, $shopper->jgroups)){
							$is_admin = true;
						}
					}

					if(!$is_admin){
						if(!empty($update_u)){
							$this->db_sqlQuery("UPDATE #__users SET " . $this->assocDataToUpdQuery($update_u,"#__users") . " WHERE id = " . $shopper->virtuemart_user_id);
							$this->db_query();
						}
					}

					if(!empty($update_vu)){
						$this->db_sqlQuery("UPDATE #__virtuemart_vmusers SET " . $this->assocDataToUpdQuery($update_vu,"#__virtuemart_vmusers") . " WHERE virtuemart_user_id = " . $shopper->virtuemart_user_id);
						$this->db_query();
					}
				}else{

					$udata = array(
						"email"    => $update_u["email"],
						"username" => $update_u["username"],
						"name"     => $update_u["name"]
					);

					$this->db_sqlQuery("SELECT id FROM #__users WHERE email LIKE " . $this->db_quote($update_u["email"]));
					$virtuemart_user_id = $this->db->loadResult();
					$shopper_juser = null;

					if(!$virtuemart_user_id){
						$shopper_juser = JFactory::getUser(-1);
						$shopper_juser->bind($udata);
						if($shopper_juser->save()){
							$virtuemart_user_id = $shopper_juser->id;
						}else{
							$data->error = $shopper_juser->getError();
							return $data;
						}
					}else{
						if(!empty($update_u)){
							$this->db_sqlQuery("UPDATE #__users SET " . $this->assocDataToUpdQuery($update_u, "#__users") . " WHERE id = " . $virtuemart_user_id);
							$this->db_query();
						}
						$shopper_juser = JFactory::getUser(intval($virtuemart_user_id));
					}

					if(!$shopper_juser){
						$data->error = "Could not create user object";
						return $data;
					}

					$this->loadVmUser();

					$update_vu["virtuemart_user_id"] = $virtuemart_user_id;
					if(!isset($update_vu["customer_number"]))
					 		$update_vu["customer_number"] = "C" . date('YmdHis') . rand(1000,9999);
					else if(!$update_vu["customer_number"]){
						  $update_vu["customer_number"] = "C" . date('YmdHis') . rand(1000,9999);
					}
					if($this->vmuser)
						$update_vu["virtuemart_vendor_id"] = $this->vmuser->virtuemart_vendor_id;
					else
					  $update_vu["virtuemart_vendor_id"] = 1;

					$ins = $this->assocDataToInsQuery($update_vu, "#__virtuemart_vmusers");
					if($ins){
							$this->db_sqlQuery("INSERT INTO #__virtuemart_vmusers(" . $ins["columns"] . ") VALUES (" . $ins["values"] .  ")");
							$this->db_query();
					}

					$shopper = $this->getShopper($virtuemart_user_id, true);
				}

				if(!empty($update_bt)){
					if(isset($shopper->BT)){
						if(isset($update_bt["virtuemart_userinfo_id"]))
							unset($update_bt["virtuemart_userinfo_id"]);

						$update_bt["virtuemart_user_id"] = $shopper->virtuemart_user_id;
						$update_bt["address_type"] = "BT";

						$upd_str = $this->assocDataToUpdQuery($update_bt,"#__virtuemart_userinfos");
						if($upd_str){
							$this->db_sqlQuery("UPDATE #__virtuemart_userinfos SET " . $upd_str . " WHERE virtuemart_userinfo_id = " . $shopper->BT->virtuemart_userinfo_id);
							$this->db_query();
						}
					}else{


						$update_bt["virtuemart_user_id"] = $shopper->virtuemart_user_id;
						$update_bt["address_type"] = "BT";
						$ins = $this->assocDataToInsQuery($update_bt,"#__virtuemart_userinfos");
						if($ins){
							$this->db_sqlQuery("INSERT INTO #__virtuemart_userinfos(" . $ins["columns"] . ") VALUES (" . $ins["values"] .  ")");
							$this->db_query();
						}
					}
				}

				if($update_st !== null){
					$shopper_sts = array();
					$shopper_sts_ids = array();

					foreach($shopper as $prop => $val){
						if(strpos($prop,"ST") === 0){
							$shopper_sts[$val->virtuemart_userinfo_id] = $val;
							$shopper_sts_ids[] = $val->virtuemart_userinfo_id;
						}
					}

					foreach($update_st as $st){
						$st["virtuemart_user_id"] = $shopper->virtuemart_user_id;
						$st["address_type"] 	  = "ST";

						if(isset($st["virtuemart_userinfo_id"])){
							if(intval($st["virtuemart_userinfo_id"])){
								if(in_array(intval($st["virtuemart_userinfo_id"]),$shopper_sts_ids)){

									$stid = intval($st["virtuemart_userinfo_id"]);
									unset($st["virtuemart_userinfo_id"]);
									$upd_str = $this->assocDataToUpdQuery($st,"#__virtuemart_userinfos");

									if($upd_str){
										$this->db_sqlQuery("UPDATE #__virtuemart_userinfos SET " . $upd_str . " WHERE virtuemart_userinfo_id = " . $stid);
										$this->db_query();
									}
									continue;
								}
							}
							unset($st["virtuemart_userinfo_id"]);
						}

						$ins = $this->assocDataToInsQuery($st,"#__virtuemart_userinfos");

						if($ins){
							$this->db_sqlQuery("INSERT INTO #__virtuemart_userinfos(" . $ins["columns"] . ") VALUES (" . $ins["values"] .  ")");
							$this->db_query();
						}
					}
				}

				if($update_sg != -1){
					if(!isset($shopper->shoppergroups))
						$shopper->shoppergroups = array();

					if(!$update_sg)
						$update_sg = array();

					foreach($shopper->shoppergroups as $sgid){
						if(!in_array($sgid,$update_sg)){
							$this->db_sqlQuery("DELETE FROM #__virtuemart_vmuser_shoppergroups WHERE virtuemart_user_id = " . $this->db_quote($shopper->virtuemart_user_id) . " AND virtuemart_shoppergroup_id = " . $this->db_quote($sgid));
							$this->db_query();
						}
					}

					foreach($update_sg as $sgid){
						if($sgid > 0){
							if(!in_array($sgid,$shopper->shoppergroups)){
								$this->db_sqlQuery("INSERT INTO #__virtuemart_vmuser_shoppergroups(`virtuemart_user_id`, `virtuemart_shoppergroup_id`)  VALUES(".$this->db_quote($shopper->virtuemart_user_id)."," . $this->db_quote($sgid) . ")");
								$this->db_query();
							}
						}
					}
				}

				$data = $this->getShopper($virtuemart_user_id, true);
			}catch(Throwable $ex){
				$err[] = $ex->getMessage();
				$data->error = $ex->getMessage();
			}
		}
		return $data;
	}

	function orderItemUpdateAPCF($virtuemart_order_id, $id, $cid, $value, $price, $param){
		
		$this->prepareSessionForUpdateTask();
		
		if($id){
			$this->db_sqlQuery("UPDATE #__virtuemart_product_customfields
								SET
									virtuemart_product_id            = -" . $this->db_quote($virtuemart_order_id) . ",
									virtuemart_custom_id             =  " . $this->db_quote($cid) . ",
									{$this->custom_field_value_name} =  " . $this->db_quote($value) . ",
									{$this->custom_field_price_name} =  " . $this->db_quote($price) . ",
									{$this->custom_field_param_name} =  " . $this->db_quote($param) . ",
									modified_on                      = NOW(),
									modified_by                      =  " . $this->db_quote( $this->user_id ?  $this->user_id : 0) . "
								WHERE
									virtuemart_customfield_id = " .  $this->db_quote($id)
							);
			$this->db->execute();
		}else{

			$keys = array(
				"virtuemart_product_id",
				"virtuemart_custom_id",
				$this->custom_field_value_name,
				$this->custom_field_price_name,
				$this->custom_field_param_name,
				"created_on",
				"created_by",
				"modified_on",
				"modified_by"
			);

			$values = array(
				-$virtuemart_order_id,
				$cid,
				$value,
				$price,
				$param,
				"NOW()",
				( $this->user_id ?  $this->user_id : 0),
				"NOW()",
				( $this->user_id ?  $this->user_id : 0)
			);

			if(isset($this->tbl["#__virtuemart_product_customfields"]["disabler"])){
				$keys[] = "disabler";
				$values[] = 0;
			}

			if(isset($this->tbl["#__virtuemart_product_customfields"]["override"])){
				$keys[] = "override";
				$values[] = 0;
			}

			if(isset($this->tbl["#__virtuemart_product_customfields"]["published"])){
				$keys[] = "published";
				$values[] = 0;
			}

			if(isset($this->tbl["#__virtuemart_product_customfields"]["ordering"])){
				$keys[] = "ordering";
				$values[] = 0;
			}

			for($i = 0; $i < count($values); $i++){
				$values[$i] = $this->db_quote($values[$i]);
			}

			$this->db_sqlQuery("INSERT INTO #__virtuemart_product_customfields (" . implode(",",$keys) . ") values (" . implode(",",$values) . ");");
			$this->db->execute();
			$id = $this->db->insertid();
		}

		return (object) array(
			"id"    => $id,
			"cid"   => $cid,
			"value" => $value,
			"price" => $price,
			"param" => $param,
			"virtuemart_order_id" => $virtuemart_order_id
		);
	}

	function priv__tryRepairTCPPDF(){
		$possible_locations = array(
			JPATH_BASE . DIRECTORY_SEPARATOR . "libraries" . DIRECTORY_SEPARATOR . "tcpdf" . DIRECTORY_SEPARATOR . "tcpdf.php",
			JPATH_BASE . DIRECTORY_SEPARATOR . "libraries" . DIRECTORY_SEPARATOR . "vendor" . DIRECTORY_SEPARATOR . "tecnickcom" . DIRECTORY_SEPARATOR . "tcpdf" . DIRECTORY_SEPARATOR . "tcpdf.php"
		);
		foreach($possible_locations as $tcpdfpath){
			if(file_exists($tcpdfpath)){
				$fcontent = @file_get_contents($tcpdfpath);
				if($fcontent){
					if(stripos($fcontent,'public function Error($msg) {') !== false){
						$fcontent = str_ireplace('public function Error($msg) {','public function Error($msg) { return;', $fcontent);
						@file_put_contents($tcpdfpath,$fcontent);
					}
				}
			}
		}
	}

	function update_order($data,&$err){
		
		global $scerr;
		if(!SCvmAccess::manager('orders.edit') && $this->datascope != "b2b"){
			$scerr[0]           = "The account you use to access site is not permitted to edit orders!";
			return null;
		}

		if(isset($data->orders)){
			foreach($data->orders as $odrInd => $odata){
				$data->orders->{$odrInd} = $this->update_order($odata,$err);
			}
			return $data;
		}
		
		$this->prepareSessionForUpdateTask();

		if($data){
			try{
				$virtuemart_vendor_id = sc_get_object_value($data, "virtuemart_vendor_id",null);
				$virtuemart_order_id  = sc_get_object_value($data, "virtuemart_order_id",null);

				if($virtuemart_order_id){
					if(strpos($virtuemart_order_id . "","_") !== false){
						$virtuemart_order_id = null;
					}
				}

				$orderModel = VmModel::getModel('orders');

				$this->loadTableDefinition("#__virtuemart_orders");

				if(!$virtuemart_order_id){
					$cart = VirtueMartCart::getCart(true);
					$virtuemart_order_id = $orderModel->CreateOrderHead();
				}

				if(!$virtuemart_order_id){
					$err[] = "Unable to create new order!";
					return null;
				}

				$update_status      = false;
				$update_status_data = array();
				
				$upd_udf = array();

				$oupd = array();
				foreach($data as $order_property_name => $order_property_value){
					if($order_property_name == "virtuemart_order_id")
						continue;

					if($order_property_name == "order_items"){
						$this->loadTableDefinition("#__virtuemart_order_items");

						$this->db_sqlQuery("SELECT virtuemart_order_item_id FROM #__virtuemart_order_items WHERE virtuemart_order_id = " . $this->db_quote($virtuemart_order_id));
						$current_ids = $this->db->loadColumn();
						$request_ids = array();

						foreach($order_property_value as $oiind => $order_item){
							if(isset($order_item->virtuemart_order_item_id)){
								if(stripos("".$order_item->virtuemart_order_item_id,"_") !== false){
									$order_item->virtuemart_order_item_id = null;
								}else{
									$request_ids[] = $order_item->virtuemart_order_item_id;
								}
							}else
								$order_item->virtuemart_order_item_id = null;
						}

						if(!empty($current_ids)){
							foreach($current_ids as $current_id){
								if(!in_array($current_id, $request_ids)){
									$this->db_sqlQuery("DELETE FROM #__virtuemart_order_items WHERE virtuemart_order_item_id = " . $this->db_quote($current_id));
									$this->db_query();
								}
							}
						}

						foreach($order_property_value as $oiind => $order_item){

							$order_item->virtuemart_order_id = $virtuemart_order_id;
							$order_item->modified_on = "NOW()";
							if($this->user_id){
								$order_item->modified_by = $this->user_id;
							}else
								$order_item->modified_by = 0;

							$order_item_attributes = null;

							if(!$order_item->virtuemart_order_item_id){

								$order_item->created_on = "NOW()";
								if($this->user_id){
									$order_item->created_by = $this->user_id;
								}else
									$order_item->created_by = 0;

								$keys = array();
								$values = array();
								foreach($order_item as $t_prop => $t_val){
									if($t_prop == "product_attribute"){
										$order_item_attributes = $t_val;
										continue;
									}
									if(isset($this->tbl["#__virtuemart_order_items"][$t_prop])){
										$keys[]   = $t_prop;
										$values[] = $this->db_quote($t_val);
									}
								}

								if(!empty($values)){
									$uquery = "INSERT INTO #__virtuemart_order_items(" . implode(",",$keys) . ") VALUES (" . implode(",",$values) . ");";
									$this->db_sqlQuery( $uquery );
									$this->db_query();
									$order_item->virtuemart_order_item_id = $this->db->insertid();
								}

							}else{
								$uquery = "UPDATE #__virtuemart_order_items SET ";
								$comma  = "";

								foreach($order_item as $t_prop => $t_val){
									if($t_prop != "virtuemart_order_item_id"){
										if($t_prop == "product_attribute"){
											$order_item_attributes = $t_val;
											continue;
										}
										if(isset($this->tbl["#__virtuemart_order_items"][$t_prop])){
											$uquery .= "\n{$comma} {$t_prop} = " . $this->db_quote($t_val);
											$comma = ", ";
										}
									}
								}

								if($comma){
									$uquery .= "\n WHERE virtuemart_order_item_id = " . $this->db_quote($order_item->virtuemart_order_item_id);
									$this->db_sqlQuery( $uquery );
									$this->db_query();
								}
							}

							if($order_item_attributes){

								$this->loadTableDefinition("#__virtuemart_product_customfields");

								$additional_pcfs = array();
								if($virtuemart_order_id){
									$this->db_sqlQuery("SELECT virtuemart_customfield_id, virtuemart_custom_id, {$this->custom_field_value_name}, {$this->custom_field_price_name}, {$this->custom_field_param_name} FROM #__virtuemart_product_customfields WHERE virtuemart_product_id = " . $this->db_quote(-$virtuemart_order_id));
									$additional_pcfs = $this->db->loadObjectList("virtuemart_customfield_id");
								}

								$this->db_sqlQuery("SELECT product_attribute FROM #__virtuemart_order_items WHERE virtuemart_order_item_id = " . $this->db_quote($order_item->virtuemart_order_item_id));
								$current_attr = $this->db->loadResult();

								if($current_attr){
									$current_attr = json_decode($current_attr, true);
								}

								if(!$current_attr)
									$current_attr = array();

								$new_attr = array();

								$pcfids = array();
								foreach($order_item_attributes as $order_item_attribute){
									if(isset($order_item_attribute->id)){
										if(!isset($additional_pcfs[$order_item_attribute->id])){
											$pcfids[] = $order_item_attribute->id;
										}else{
											$additional_pcfs[$order_item_attribute->id]->is_set = true;
										}
									}
								}

								$real_pcfs = array();
								if(!empty($pcfids)){
									$this->db_sqlQuery("SELECT virtuemart_customfield_id, virtuemart_custom_id, {$this->custom_field_value_name}, {$this->custom_field_price_name}, {$this->custom_field_param_name} FROM #__virtuemart_product_customfields WHERE virtuemart_customfield_id IN (". implode(",",$pcfids) .") ");
									$real_pcfs = $this->db->loadObjectList("virtuemart_customfield_id");
								}

								foreach($order_item_attributes as $order_item_attribute){
									if(isset($order_item_attribute->id)){
										if(isset($additional_pcfs[$order_item_attribute->id])){
											$new_attr[$order_item_attribute->cid] = $this->orderItemUpdateAPCF($virtuemart_order_id,$order_item_attribute->id,$order_item_attribute->cid,$order_item_attribute->value, $order_item_attribute->price, $order_item_attribute->param);
										}else if(isset($real_pcfs[$order_item_attribute->id])){
											if(
												strtolower(trim($real_pcfs[$order_item_attribute->id]->{$this->custom_field_value_name})) != strtolower(trim($order_item_attribute->value))
												||
											    round(floatval($real_pcfs[$order_item_attribute->id]->{$this->custom_field_price_name}),2) != round(floatval($order_item_attribute->price),2)
											){
												$new_attr[$order_item_attribute->cid] = $this->orderItemUpdateAPCF($virtuemart_order_id,NULL,$order_item_attribute->cid,$order_item_attribute->value, $order_item_attribute->price, "");
											}else{
												$new_attr[$order_item_attribute->cid] = $order_item_attribute;
											}
										}else{
											$new_attr[$order_item_attribute->cid] = $this->orderItemUpdateAPCF($virtuemart_order_id,NULL,$order_item_attribute->cid,$order_item_attribute->value, $order_item_attribute->price, "");
										}
									}else{
										if(!empty($real_pcfs)){
											foreach($real_pcfs as $pcf_id => $real_pcf){
												if(strtolower(trim($real_pcfs[$pcf_id]->{$this->custom_field_value_name})) == strtolower(trim($order_item_attribute->value))
													&&
												   round(floatval($real_pcfs[$pcf_id]->{$this->custom_field_price_name}),2) == round(floatval($order_item_attribute->price),2)){
													   $new_attr[$order_item_attribute->cid] = array(
															"cid"   => $order_item_attribute->cid,
															"id"    => $pcf_id,
															"value" => $real_pcfs[$pcf_id]->{$this->custom_field_value_name},
															"price" => $real_pcfs[$pcf_id]->{$this->custom_field_price_name},
															"param" => $real_pcfs[$pcf_id]->{$this->custom_field_param_name}
													   );
													   break;
												}
											}
										}

										if(!isset($new_attr[$order_item_attribute->cid])){
											$new_attr[$order_item_attribute->cid] = $this->orderItemUpdateAPCF($virtuemart_order_id,NULL,$order_item_attribute->cid,$order_item_attribute->value, $order_item_attribute->price, "");
										}
									}
								}

								if(!empty($additional_pcfs)){
									$del_apcf = array();
									foreach($additional_pcfs as $additional_pcf){
										if(!isset($additional_pcf->is_set)){
											if(isset($additional_pcf->id))
												if($additional_pcf->id)
													$del_apcf[] = $additional_pcf->id;
										}
									}
									if(!empty($del_apcf)){
										$this->db_sqlQuery("DELETE FROM #__virtuemart_order_items WHERE virtuemart_customfield_id IN (" . implode(",", $del_apcf) . ")");
										$this->db_query();
									}
								}

								$pat = new stdClass();
								foreach($new_attr as $new_att){
									$pat->{$new_att->cid} = $new_att->id;
								}

								$pat = json_encode($pat);
								$uquery = "UPDATE #__virtuemart_order_items SET product_attribute = " . $this->db_quote($pat) . " WHERE virtuemart_order_item_id = " . $this->db_quote($order_item->virtuemart_order_item_id) . ";";
								$this->db_sqlQuery( $uquery );
								$this->db_query();
							}
						}
					}else if($order_property_name == "order_histories"){
						$this->loadTableDefinition("#__virtuemart_order_histories");

						$this->db_sqlQuery("SELECT virtuemart_order_history_id FROM #__virtuemart_order_histories WHERE virtuemart_order_id = " . $this->db_quote($virtuemart_order_id));
						$current_ids = $this->db->loadColumn();
						$request_ids = array();

						foreach($order_property_value as $hind => $hitem){
							if(isset($hitem->virtuemart_order_history_id)){
								if(stripos("".$hitem->virtuemart_order_history_id,"_") !== false){
									$hitem->virtuemart_order_history_id = null;
								}else{
									$request_ids[] = $hitem->virtuemart_order_history_id;
								}
							}else
								$hitem->virtuemart_order_history_id = null;
						}

						foreach($current_ids as $current_id){
							if(!in_array($current_id, $request_ids)){
								$this->db_sqlQuery("DELETE FROM #__virtuemart_order_histories WHERE virtuemart_order_history_id = " . $this->db_quote($current_id));
								$this->db_query();
							}
						}

						foreach($order_property_value as $hind => $hitem){

							$hitem->virtuemart_order_id = $virtuemart_order_id;
							$hitem->modified_on = "NOW()";
							if($this->user_id){
								$hitem->modified_by = $this->user_id;
							}else
								$hitem->modified_by = 0;

							if(!isset($hitem->virtuemart_order_history_id)){
								$update_status_data[] = $hitem;

								/*
								$hitem->created_on = "NOW()";
								if($this->user_id){
									$hitem->created_by = $this->user_id;
								}else
									$hitem->created_by = 0;

								$keys = array();
								$values = array();
								foreach($hitem as $t_prop => $t_val){
									if(isset($this->tbl["#__virtuemart_order_histories"][$t_prop])){
										$keys[]   = $t_prop;
										$values[] = $this->db_quote($t_val);
									}
								}

								if(!empty($values)){
									$uquery = "INSERT INTO #__virtuemart_order_histories(" . implode(",",$keys) . ") VALUES (" . implode(",",$values) . ");";
									$this->db_sqlQuery( $uquery );
									$this->db_query();

									$hitem->virtuemart_order_history_id = $this->db->insertid();
								}
								*/


							}else{
								$uquery = "UPDATE #__virtuemart_order_histories SET ";
								$comma  = "";

								foreach($hitem as $t_prop => $t_val){
									if($t_prop != "virtuemart_order_history_id"){
										if(isset($this->tbl["#__virtuemart_order_histories"][$t_prop])){
											$uquery .= "\n{$comma} {$t_prop} = " . $this->db_quote($t_val);
											$comma = ", ";
										}
									}
								}

								if($comma){
									$uquery .= "\n WHERE virtuemart_order_history_id = " . $this->db_quote($hitem->virtuemart_order_history_id);
									$this->db_sqlQuery( $uquery );
									$this->db_query();
								}

							}
						}
					}else if($order_property_name == "BT" || $order_property_name == "ST"){
						$this->loadTableDefinition("#__virtuemart_order_userinfos");

						if($order_property_value){
							$virtuemart_order_userinfo_id = sc_get_object_value($order_property_value, "virtuemart_order_userinfo_id",null);
							if(stripos($virtuemart_order_userinfo_id."","_") !== false)
								$virtuemart_order_userinfo_id = null;

							if(!$virtuemart_order_userinfo_id){
								$this->db_sqlQuery( "SELECT virtuemart_order_userinfo_id FROM #__virtuemart_order_userinfos
														WHERE
															virtuemart_order_id = " . $this->db_quote($virtuemart_order_id)
															. " AND address_type = " . $this->db_quote($order_property_name));
								$virtuemart_order_userinfo_id = $this->db->loadResult();
								if(!$virtuemart_order_userinfo_id)
									$virtuemart_order_userinfo_id = null;
							}

							$order_property_value->virtuemart_order_id = $virtuemart_order_id;
							$order_property_value->address_type        = $order_property_name;

							if(!isset($order_property_value->virtuemart_user_id) && isset($data->virtuemart_user_id)){
								$order_property_value->virtuemart_user_id = $data->virtuemart_user_id;
							}

							$order_property_value->modified_on = "NOW()";
							if($this->user_id){
								$order_property_value->modified_by = $this->user_id;
							}else
								$order_property_value->modified_by = 0;

							if(!$virtuemart_order_userinfo_id){
								$order_property_value->created_on = "NOW()";
								if($this->user_id){
									$order_property_value->created_by = $this->user_id;
								}else
									$order_property_value->created_by = 0;

								foreach($this->tbl["#__virtuemart_order_userinfos"] as $field => $def){
									if($field == "modified_by" || $field == "modified_on" || $field == "virtuemart_order_userinfo_id")
										continue;
									if($def->{"Null"} == "NO" && !isset($order_property_value->{$field})){
										$order_property_value->{$def->Field} = $def->{"Default"};
										if(!isset($order_property_value->{$def->Field}))
											$order_property_value->{$def->Field} = "";
									}
								}

								$keys = array();
								$values = array();
								foreach($order_property_value as $adr_prop => $adr_val){
									if(isset($this->tbl["#__virtuemart_order_userinfos"][$adr_prop])){
										$keys[]   = $adr_prop;
										$values[] = $this->db_quote($adr_val);
									}
								}

								$uquery = "INSERT INTO #__virtuemart_order_userinfos(" . implode(",",$keys) . ") VALUES (" . implode(",",$values) . ");";
								$this->db_sqlQuery( $uquery );
								$this->db_query();
								$virtuemart_order_userinfo_id = $this->db->insertid();

							}else{
								$uquery = "UPDATE #__virtuemart_order_userinfos SET ";
								$comma = "";
								foreach($order_property_value as $adr_prop => $adr_val){
									//$adr_upd[$adr_prop] = $this->db_quote($adr_val);
									if(isset($this->tbl["#__virtuemart_order_userinfos"][$adr_prop])){
										$uquery .= "\n{$comma} {$adr_prop} = " . $this->db_quote($adr_val);
										$comma = ", ";
									}
								}
								$uquery .= "\n WHERE virtuemart_order_userinfo_id = " . $this->db_quote($virtuemart_order_userinfo_id);
								$this->db_sqlQuery( $uquery );
								$this->db_query();
							}

						}else{
							if($virtuemart_order_id){
								$this->db_sqlQuery( "DELETE FROM #__virtuemart_order_userinfos
														WHERE
															virtuemart_order_id = " . $this->db_quote($virtuemart_order_id)
															. " AND address_type = " . $this->db_quote($order_property_name));
								$this->db_query();
							}
						}
					}else if($order_property_name == "order_status"){

						$update_status = $order_property_value;

					}else{
						
						if(strpos($prop,"udf_") === 0){
							$upd_udf[$prop] = $order_property_name;
							continue;
						}else if(isset($this->tbl["#__virtuemart_orders"][$order_property_name])){
							//JUST STORE
							$oupd[$order_property_name] = $this->db_quote($order_property_value);
						}
					}
				}

				if(!empty($oupd)){
					$uquery = "UPDATE #__virtuemart_orders SET \n";
					$comma = "";
					foreach($oupd as $oprop => $oprop_value){
						$uquery .= ( "\n {$comma}{$oprop} = {$oprop_value}");
						$comma = ", ";
					}
					$uquery .= "\n ,modified_on = NOW() ";
					if($this->user_id){
						$uquery .= "\n ,modified_by = " . $this->db_quote($this->user_id);
					}
					$uquery .= "\n WHERE virtuemart_order_id = " . $this->db_quote($virtuemart_order_id);

					$this->db_sqlQuery( $uquery );
					$this->db_query();
				}

				if($update_status || !empty($update_status_data)){
					//OVDE
					//FILL #__virtuemart_order_item_histories
					//I update status za order_item  mora da se zove specijalno

					if($update_status && empty($update_status_data)){
						$update_status_data[] = (object)array(
							'order_status_code' => $update_status,
							'customer_notified' => true,
							'comments'          => ''
						);
					}

					$orderModel = VmModel::getModel('orders');

					$do_triggers   = true;
					$nofify_vendor = false;

					if(isset($this->settings->vm_plugins_no_trigger)){
						if($this->settings->vm_plugins_no_trigger == false)
							$do_triggers = false;
					}

					if(isset($this->settings->nofify_vendor)){
						if($this->settings->nofify_vendor)
							$do_triggers = true;
					}

					foreach($update_status_data as $usdata){
						try{
							$orderData = (array)$orderModel->getOrder(intval($virtuemart_order_id));
							$orderData["comments"] = $usdata->comments;
							if(!$usdata->customer_notified){
								$orderData["customer_notified"] = 1;//REVERSE
							}
							$orderData["order_status"] = $usdata->order_status_code;
							if($nofify_vendor){
								$orderData["doVendor"] = true;
							}
							$orderModel->updateStatusForOneOrder($virtuemart_order_id, $orderData, $do_triggers);
						}catch(Throwable $ex){
							$err[] = $ex->getMessage();
							if(stripos($ex->getMessage(),"TCPDF ERROR") !== false){
								$this->priv__tryRepairTCPPDF();
							}
						}
					}
				}
				
				$updated = $this->getOrder($virtuemart_order_id);
				
				if(count($upd_udf)){
					if(isset($this->settings)){
						
						$update_data = is_array($data) ? ((object)$data) : $data;
						
						foreach($updated as $key => $val){
							$update_data->{$key} = $val;
						}
						
						$udf_settings_prop = "udf_settings";
						
						$udf_updated = false;
						if(isset($this->settings->{$udf_settings_prop})){
							if(count($this->settings->{$udf_settings_prop})){
								foreach($this->settings->{$udf_settings_prop} as $udf){
									if(isset($udf->udf_update)){
										if($udf->udf_update){
											if(array_key_exists($udf->udf_name, $upd_udf)){
												$this->udfEntityUpdate($update_data,$udf,$upd_udf[$udf->udf_name],$updated);
												$udf_updated = true;
											}
										}
									}
								}
							}
						}
						
						if($udf_updated){
							$updated = $this->getOrder($virtuemart_product_id);
							foreach($updated as $key => $val){
								$update_data->{$key} = $val;
							}
						}
					}
				}
				
				return $updated;
				
			}catch(Throwable $ex){
				$err[] = $ex->getMessage();
			}
		}else{
			$err[] = "No valid order data provided in request!";
			return null;
		}
		return $data;
	}

	function get_order_print($data,&$err){

		if(!$data)
			$data = new stdClass;

		if(isset($data->virtuemart_order_id)){
			try{
				if(!class_exists('VirtueMartControllerInvoice'))
					require(JPATH_BASE. DIRECTORY_SEPARATOR .'components' . DIRECTORY_SEPARATOR . 'com_virtuemart' . DIRECTORY_SEPARATOR . 'controllers' . DIRECTORY_SEPARATOR . "invoice.php");

				$orderModel = VmModel::getModel('orders');
				$cInvoice = new VirtueMartControllerInvoice();
				if(method_exists($cInvoice,"getViewWithTemplate")){
					$view = $cInvoice->getViewWithTemplate("invoice", "html");
					$view->orderDetails = $orderModel->getOrder(intval($data->virtuemart_order_id));
					$view->headFooter = false;
					$view->setModel($orderModel);
					$view->setLayout('invoice');
					$view->uselayout = "invoice";
					ob_start();
					$view->display();
					$outo = ob_get_clean();

					$data->output = $outo;
				}
			}catch(Throwable $odex){
				$data->output = $odex->getMessage();

				if(stripos($odex->getMessage(),"TCPDF ERROR") !== false){
					$this->priv__tryRepairTCPPDF();
				}
			}
		}
		return $data;
	}

	function get_delivery_note($data,&$err){
		if(!$data)
			$data = new stdClass;

		if(isset($data->virtuemart_order_id)){
			try{
				if(!class_exists('VirtueMartControllerInvoice'))
					require(JPATH_BASE. DIRECTORY_SEPARATOR .'components' . DIRECTORY_SEPARATOR . 'com_virtuemart' . DIRECTORY_SEPARATOR . 'controllers' . DIRECTORY_SEPARATOR . "invoice.php");

				vRequest::setVar('format', "pdf");

				$orderModel = VmModel::getModel('orders');
				$cInvoice = new VirtueMartControllerInvoice();
				if(method_exists($cInvoice,"getViewWithTemplate")){
					$view = $cInvoice->getViewWithTemplate("invoice", "html");
					$view->orderDetails = $orderModel->getOrder(intval($data->virtuemart_order_id));
					$view->headFooter = false;
					$view->setModel($orderModel);
					$view->setLayout('deliverynote');
					$view->uselayout = "deliverynote";
					ob_start();
					$view->display();
					$outo = ob_get_clean();

					$data->output = $outo;
				}
			}catch(Throwable $odex){
				$data->output = $odex->getMessage();

				if(stripos($odex->getMessage(),"TCPDF ERROR") !== false){
					$this->priv__tryRepairTCPPDF();
				}
			}
		}
		return $data;
	}

	function get_invoice($data,&$err){
		if(!$data)
			$data = new stdClass;

		if(isset($data->virtuemart_order_id)){
			try{
				if(!class_exists('VirtueMartControllerInvoice'))
					require(JPATH_BASE. DIRECTORY_SEPARATOR .'components' . DIRECTORY_SEPARATOR . 'com_virtuemart' . DIRECTORY_SEPARATOR . 'controllers' . DIRECTORY_SEPARATOR . "invoice.php");

				vRequest::setVar('format', "pdf");
				vRequest::setVar('invoiceNumber', $data->order_create_invoice_pass);

				$orderModel = VmModel::getModel('orders');
				$cInvoice = new VirtueMartControllerInvoice();
				if(method_exists($cInvoice,"getViewWithTemplate")){
					$view = $cInvoice->getViewWithTemplate("invoice", "html");
					$view->orderDetails = $orderModel->getOrder(intval($data->virtuemart_order_id));
					$view->headFooter = false;
					$view->setModel($orderModel);
					$view->setLayout('invoice');
					$view->uselayout = "invoice";
					ob_start();
					$view->isPdf  =true;
					$view->display();
					$outo = ob_get_clean();

					$data->output = $outo;
				}
			}catch(Throwable $odex){
				$data->output = $odex->getMessage();

				if(stripos($odex->getMessage(),"TCPDF ERROR") !== false){
					$this->priv__tryRepairTCPPDF();
				}
			}
		}
		return $data;
	}

	function get_shipment_and_payment_info($data,&$err){
		//vmLanguage::setLanguageByTag($this->lng, true);
		try{
			
			$this->initJoomlaDispatcher();

			$p_args = array(
				 $data->virtuemart_order_id,
				 $data->virtuemart_paymentmethod_id
			);

			if(isset($data->virtuemart_paymentmethod_name)){
				$p_args[] = $data->virtuemart_paymentmethod_name;
			}

			$data->response_payment = $this->joomla_dispatcher_trigger('plgVmOnShowOrderBEPayment',$p_args);

			if(!empty($data->response_payment)){
				for($i = 0; $i < count($data->response_payment); $i++){
					$data->response_payment[$i] = str_replace("COM_VIRTUEMART_","",$data->response_payment[$i]);
					$data->response_payment[$i] = str_replace("_LBL","",$data->response_payment[$i]);
				}
			}

			require_once( JPATH_PLUGINS . DIRECTORY_SEPARATOR . "vmshipment/weight_countries/weight_countries.php");
			$shipment_config = json_decode('{"type":"vmshipment","name":"weight_countries","params":"","id":"10018"}',true);
			$shp = new plgVmShipmentWeight_countries($dispatcher, $shipment_config);//WE NEED INSTANCE

			$s_args = array(
				 $data->virtuemart_order_id,
				 $data->virtuemart_shipmentmethod_id
			);

			if(isset($data->virtuemart_shipmentmethod_name)){
				$s_args[] = $data->virtuemart_shipmentmethod_name;
			}

			$data->response_shipment = $this->joomla_dispatcher_trigger('plgVmOnShowOrderBEShipment',$s_args);

			for($i = 0; $i < count($data->response_shipment); $i++){
				$data->response_shipment[$i] = str_replace("COM_VIRTUEMART_","",$data->response_shipment[$i]);
				$data->response_shipment[$i] = str_replace("_LBL","",$data->response_shipment[$i]);
				$data->response_shipment[$i] = str_replace(strtoupper($shipment_config["name"]) . "_","",$data->response_shipment[$i]);
			}

			$data->lng_files = JFactory::getLanguage()->getPaths();

			
		}catch(Throwable $ex){
			$err[] = $ex->getMessage();
		}
		return $data;
	}

	function getProducts($page, $limit, $additional_loaddata = null, $for_order_managment = false){
		global $sc_luid;

		if(!$page)
			$page = 1;

		if(!$limit)
			$limit = 999999999;

		if(!isset($this->virtuemart_customs)){
			$this->loadCustomfieldsDefinitions();
		}

		$response = new stdClass;
		$response->products = array();

		$offset = ($page - 1) * $limit;

		$add_q  = "";
		$vendor = "";

		if($additional_loaddata){
			if(sc_get_object_value($additional_loaddata,"qwhere"))
				$add_q  = " and (" . sc_get_object_value($additional_loaddata,"qwhere") . ") ";

			if(strpos($add_q, " p.modified_on > ") !== false){
				$this->db_sqlQuery("SELECT max(modified_on) FROM #__virtuemart_calcs");
				$max_calc_modified_on = $this->db->loadResult();
				if($max_calc_modified_on){
					$add_q = str_replace(" p.modified_on > "," GREATEST(p.modified_on, '{$max_calc_modified_on}' ) > ",$add_q);
				}
			}

			if(sc_get_object_value($additional_loaddata,"vendor"))
				$vendor  = " and p.virtuemart_vendor_id = " . sc_get_object_value($additional_loaddata,"vendor") . " ";
		}

		if($this->datascope == "b2b"){
			$add_q .= " and p.published = 1 ";
		}

		if($page == 1){
			$this->db_sqlQuery("SELECT count(p.virtuemart_product_id) FROM
								  #__virtuemart_products as p
							     LEFT JOIN
							      #__virtuemart_products_". $this->db_lng_suffix ." as pl on pl.virtuemart_product_id = p.virtuemart_product_id
							     WHERE
							      1 = 1
								  ". $add_q. $vendor);

			$response->product_count = $this->db->loadResult();
			$response->item_count    = $response->product_count;
		}

		$this->db_sqlQuery("  SELECT " .

								(
								  $for_order_managment ?
								" p.virtuemart_product_id, p.product_sku, p.virtuemart_vendor_id, p.product_parent_id as parent_id, p.product_gtin as gtin, product_mpn as mpn, pl.product_name "
								  :
								" p.*,
								  p.product_parent_id as parent_id,
								  pl.product_s_desc,
								  pl.product_desc,
								  pl.product_name,
								  pl.metadesc,
								  pl.metakey,
								  pl.customtitle,
								  pl.slug"
								) ."
							   FROM
								  #__virtuemart_products as p
							   LEFT JOIN
							      #__virtuemart_products_". $this->db_lng_suffix ." as pl on pl.virtuemart_product_id = p.virtuemart_product_id
							   WHERE
							      1 = 1
								  ". $add_q. $vendor ."
							   ORDER BY p.virtuemart_product_id LIMIT $offset, $limit ");

		$response->products = $this->db->loadObjectList();

		$product_prices        = null;
		$product_categories    = null;
		$product_manufacturers = null;
		$product_custom_fields = null;
		$product_images        = null;
		$product_shoppergroups = null;

		$pcf_cur               = 0;
		$img_cur               = 0;

		$first_id = 0;
		$last_id  = 0;


		if(isset($response->products)){
			if(isset($response->products[0])){
				$first_id = $response->products[0]->virtuemart_product_id ;
				$last_id  = $response->products[count($response->products) - 1]->virtuemart_product_id;
			}
		}

		if(!$first_id)
			$first_id = 0;

		if(!$last_id)
			$last_id  = 0;

		$response->first_id = $first_id;
		$response->last_id  = $last_id;


		if(count($response->products)){

			$this->sessionGroupConcat();

			$this->db_sqlQuery("SELECT
				pric.virtuemart_product_id,

				GROUP_CONCAT(
					concat(
						'\"',pric.virtuemart_product_price_id,'\":{',
							'\"virtuemart_product_price_id\":',COALESCE(pric.virtuemart_product_price_id,'null'),',',
							'\"virtuemart_shoppergroup_id\":',COALESCE(pric.virtuemart_shoppergroup_id,'0'),',',
							'\"product_price\":',COALESCE(pric.product_price,'null'),',',
							'\"product_override_price\":',COALESCE(pric.product_override_price,'null'),',',
							'\"override\":', COALESCE(pric.override,'null'),',',
							'\"price_quantity_start\":', COALESCE(pric.price_quantity_start,'0'),',',
							'\"price_quantity_end\":',COALESCE(pric.price_quantity_end,'0'),',',
							'\"product_tax_id\":',COALESCE(pric.product_tax_id,'0'),',',
							'\"product_discount_id\":',COALESCE(pric.product_discount_id,'0'),',',
							'\"product_currency\":',COALESCE(pric.product_currency,'null'),',',
							'\"product_price_publish_up\":\"',COALESCE(pric.product_price_publish_up,'0000-00-00 00:00:00'),'\"',',',
							'\"product_price_publish_down\":\"',COALESCE(pric.product_price_publish_down,'0000-00-00 00:00:00'),'\"',
						'}'
					)
				) as prices_json

			FROM
				#__virtuemart_product_prices as pric
			WHERE
				pric.virtuemart_product_id >= $first_id AND pric.virtuemart_product_id <= $last_id
			GROUP BY
				pric.virtuemart_product_id");

			$product_prices = $this->db->loadObjectList("virtuemart_product_id");

			$this->sessionGroupConcat();

			$this->db_sqlQuery("SELECT
									cat.virtuemart_product_id,
									GROUP_CONCAT(cat.virtuemart_category_id) as categories_json
								FROM
									#__virtuemart_product_categories as cat
								WHERE
									cat.virtuemart_product_id >= $first_id AND cat.virtuemart_product_id <= $last_id
								GROUP BY
									cat.virtuemart_product_id");

			$product_categories = $this->db->loadObjectList("virtuemart_product_id");

			$this->db_sqlQuery("SELECT
									man.virtuemart_product_id,
									GROUP_CONCAT(man.virtuemart_manufacturer_id) as manufacturers_json
								FROM
									#__virtuemart_product_manufacturers as man
								WHERE
									man.virtuemart_product_id >= $first_id AND man.virtuemart_product_id <= $last_id
								GROUP BY
									man.virtuemart_product_id");

			$product_manufacturers = $this->db->loadObjectList("virtuemart_product_id");

			$this->loadTableDefinition("#__virtuemart_product_customfields");


			//ovde customfiled kad nema ni jednu verdnost se neubacije u json , problem je kod refresa product-a

			$this->db_sqlQuery("SELECT 
										pcf.virtuemart_product_id, 
										pcf.virtuemart_customfield_id, 
										pcf.virtuemart_custom_id, 
										pcf.{$this->custom_field_value_name} as custom_value ,
										pcf.{$this->custom_field_price_name} as custom_price , 
										pcf.{$this->custom_field_param_name} as custom_param
								  FROM 
										#__virtuemart_product_customfields as pcf
								  LEFT JOIN
										#__virtuemart_products as p on p.virtuemart_product_id = pcf.virtuemart_product_id
							      LEFT JOIN
										#__virtuemart_products_". $this->db_lng_suffix ." as pl on pl.virtuemart_product_id = p.virtuemart_product_id
								  WHERE 
										p.virtuemart_product_id >= $first_id AND p.virtuemart_product_id <= $last_id
										" . $add_q . $vendor . "
								  ORDER BY pcf.virtuemart_product_id, pcf.ordering;");


			$product_custom_fields = $this->db->loadObjectList();
			$product_custom_fields_ranges = array();
			
			$curr_pid = null;
			foreach($product_custom_fields as $index => $pcf){
				if(!isset($pcf->virtuemart_product_id))
					continue;
				
				if($pcf->virtuemart_product_id != $curr_pid){
					if(!isset($product_custom_fields_ranges[$pcf->virtuemart_product_id])){
						$curr_pid = $pcf->virtuemart_product_id;
						$product_custom_fields_ranges[$pcf->virtuemart_product_id] = array($index, $index);
					}
				}else{
					if(isset($product_custom_fields_ranges[$pcf->virtuemart_product_id])){
						$product_custom_fields_ranges[$pcf->virtuemart_product_id][1] = $index;
					}
				}
			}
			
			
			if(!$for_order_managment){
				$this->sessionGroupConcat();
				try{
					$q = "  SELECT
								pm.virtuemart_product_id,
								concat('[', GROUP_CONCAT(concat('{\"id\":', id, ',\"virtuemart_media_id\": ', virtuemart_media_id,',\"ordering\":', ordering  ,'}') ORDER BY ordering SEPARATOR ','),']') as images_json
							FROM
								#__virtuemart_product_medias as pm
							WHERE
								pm.virtuemart_product_id >= $first_id AND pm.virtuemart_product_id <= $last_id
							GROUP BY
								pm.virtuemart_product_id
							ORDER BY
								pm.virtuemart_product_id ASC";

					$this->db_sqlQuery($q);
					$product_images = $this->db->loadObjectList("virtuemart_product_id");

				}catch(Throwable $ex){

					if(!$response->errors)
						$response->errors = array();
					$response->errors[] = $ex->getMessage();

				}

				try{
					$this->sessionGroupConcat();
					$this->db_sqlQuery("SELECT
									sgroup.virtuemart_product_id,
									GROUP_CONCAT(sgroup.virtuemart_shoppergroup_id) as shoppergroups_list
								FROM
									#__virtuemart_product_shoppergroups as sgroup
								WHERE
									sgroup.virtuemart_product_id >= $first_id AND sgroup.virtuemart_product_id <= $last_id
								GROUP BY
									sgroup.virtuemart_product_id");

					$product_shoppergroups = $this->db->loadObjectList("virtuemart_product_id");
				}catch(Throwable $ex){

					if(!$response->errors)
						$response->errors = array();
					$response->errors[] = $ex->getMessage();

				}
			}
		}

		foreach($response->products as $prod){
			 $virtuemart_product_id = $prod->virtuemart_product_id;

			 // $pr = null;
			 // if(SC_VM_RUNV > 2)
				// $pr = $this->productModel->getProduct($virtuemart_product_id,false,false,false);
			 // else
				// $pr = $this->productModel->getProduct($virtuemart_product_id,false,false,false);

			// if(!$pr)
				// continue;
			// if(!$pr->virtuemart_product_id)
				// continue;



			//$prod->product_url                 = $pr->product_url;


			// $prod->product_s_desc = $this->coalesce($prod->product_s_desc, $pr->product_s_desc);
			// $prod->product_desc   = $this->coalesce($prod->product_desc, $pr->product_desc);
			// $prod->product_name   = $this->coalesce($prod->product_name, $pr->product_name);
			// $prod->metadesc       = $this->coalesce($prod->metadesc, $pr->metadesc);
			// $prod->metakey        = $this->coalesce($prod->metakey, $pr->metakey);
			// $prod->customtitle    = $this->coalesce($prod->customtitle, $pr->customtitle);
			// $prod->slug           = $this->coalesce($prod->slug, $pr->slug);
			if(!$for_order_managment){
				$pparms = explode("|",$prod->product_params);
				$prod->product_params = array();
				foreach($pparms as $pparm){
					$pparm = explode("=",$pparm);

					if(!$pparm[0])
						continue;

					$param = new stdClass;
					$param->name  = $pparm[0];
					$param->value = $pparm[1];

					$prod->product_params[] = $param;
				}
			}

			// foreach($this->virtuemart_customs as $cf_id => $cf_def){
				// if(!isset($prod->{ $cf_def->property_name}))
					// $prod->{ $cf_def->property_name } = array();
			// }

			if(!empty($product_custom_fields)){
				
				if(isset($product_custom_fields_ranges[$virtuemart_product_id])){
					for($index = $product_custom_fields_ranges[$virtuemart_product_id][0]; $index <= $product_custom_fields_ranges[$virtuemart_product_id][1]; $index++){
						$cf_def = $this->virtuemart_customs[$product_custom_fields[$index]->virtuemart_custom_id];

						if(!isset($prod->{ $cf_def->property_name})){
							if($for_order_managment)
								$prod->{ $cf_def->property_name } = new stdClass;
							else
								$prod->{ $cf_def->property_name } = array();
						}

						$cf = new stdClass;

						$cf->id    = $product_custom_fields[$index]->virtuemart_customfield_id;
						$cf->value = $product_custom_fields[$index]->custom_value;
						$cf->price = $product_custom_fields[$index]->custom_price;
						$cf->param = $product_custom_fields[$index]->custom_param;

						if($for_order_managment)
							$prod->{ $cf_def->property_name }->{$cf->id} = $cf;
						else
							$prod->{ $cf_def->property_name }[] = $cf;
					}
				}
				
				/*
				if(isset($product_custom_fields[$pcf_cur])){

					while($product_custom_fields[$pcf_cur]->virtuemart_product_id == $virtuemart_product_id){
						if(!isset($this->virtuemart_customs[$product_custom_fields[$pcf_cur]->virtuemart_custom_id])){
							$pcf_cur++;
							if(!isset($product_custom_fields[$pcf_cur]))
								break;
							continue;
						}

						$cf_def = $this->virtuemart_customs[$product_custom_fields[$pcf_cur]->virtuemart_custom_id];

						if(!isset($prod->{ $cf_def->property_name})){
							if($for_order_managment)
								$prod->{ $cf_def->property_name } = new stdClass;
							else
								$prod->{ $cf_def->property_name } = array();
						}

						$cf = new stdClass;

						$cf->id    = $product_custom_fields[$pcf_cur]->virtuemart_customfield_id;
						$cf->value = $product_custom_fields[$pcf_cur]->custom_value;
						$cf->price = $product_custom_fields[$pcf_cur]->custom_price;
						$cf->param = $product_custom_fields[$pcf_cur]->custom_param;

						if($for_order_managment)
							$prod->{ $cf_def->property_name }->{$cf->id} = $cf;
						else
							$prod->{ $cf_def->property_name }[] = $cf;

						$pcf_cur++;
						if(!isset($product_custom_fields[$pcf_cur]))
							break;
					}
				}
				*/
				
			}

			//$prod->product_prices = $pr->prices;



			// if(is_array($pr->prices)){
				// $prod->product_price          = isset($pr->prices["costPrice"]) ? $pr->prices["costPrice"] : $pr->prices["product_price"];
				// $prod->product_tax_id         = isset($pr->prices["product_tax_id"]) ? $pr->prices["product_tax_id"] : 0;
				// $prod->product_discount_id    = isset($pr->prices["product_discount_id"]) ? $pr->prices["product_discount_id"] : 0;
				// $prod->product_currency       = isset($pr->prices["product_currency"]) ? $pr->prices["product_currency"] : null;
			// }else{
				// $prod->product_price          = $pr->product_price;
				// if(!$prod->product_price){

					// if(isset($prod->product_prices->product_price))
						// $prod->product_price = $prod->product_prices["costPrice"];
					// else if(isset($prod->prices[0]))
						// $prod->product_price = $prod->prices[0]->price;
				// }

				// $prod->product_tax_id         = $pr->product_tax_id ? $pr->product_tax_id : 0;
				// $prod->product_discount_id    = $pr->product_discount_id ? $pr->product_discount_id : 0;
				// $prod->product_currency       = $pr->product_currency ? $pr->product_currency : null;
			// }

			// $prod->price_id            = NULL;
			// if(isset($pr->prices)){
				// if(isset($pr->prices["virtuemart_product_price_id"]))
					// $prod->price_id                   = $pr->prices["virtuemart_product_price_id"];
			// }

			//OVDE: mnogo je sporo!
			//$prod->prices         = $this->getProductPrices($pr);

			$prod->categories                  = null;
			if(!empty($product_categories)){
				if(isset($product_categories[$virtuemart_product_id])){
					$prod->categories = json_decode("[" . $product_categories[$virtuemart_product_id]->categories_json . "]");
				}
			}

			$prod->virtuemart_manufacturer_id  = null;
			if(!empty($product_manufacturers)){
				if(isset($product_manufacturers[$virtuemart_product_id])){
					$prod->virtuemart_manufacturer_id = json_decode("[" . $product_manufacturers[$virtuemart_product_id]->manufacturers_json . "]");
				}
			}

			$prod->prices = new stdClass();
			if(!empty($product_prices)){
				if(isset($product_prices[$virtuemart_product_id])){
					$prod->prices_json = "{" . $product_prices[$virtuemart_product_id]->prices_json . "}";
					$prod->prices = json_decode("{" . $product_prices[$virtuemart_product_id]->prices_json . "}");
				}
			}

			$prod->shoppergroups = null;
			if($product_shoppergroups){
				if(isset($product_shoppergroups[$virtuemart_product_id])){
					if(isset($product_shoppergroups[$virtuemart_product_id]->shoppergroups_list)){
						if($product_shoppergroups[$virtuemart_product_id]->shoppergroups_list)
							$prod->shoppergroups = explode(",",$product_shoppergroups[$virtuemart_product_id]->shoppergroups_list);
					}
				}
			}

			if($prod->prices){
				foreach($prod->prices as $price){

					if(!intval($price->price_quantity_end) && !intval($price->price_quantity_start) && (!intval($price->virtuemart_shoppergroup_id) || $price->virtuemart_shoppergroup_id == $this->default_shopper_group_id || $price->virtuemart_shoppergroup_id == $this->guest_shopper_group_id)){
						$prod->price_id                   = $price->virtuemart_product_price_id;

						$prod->product_tax_id             = $price->product_tax_id;
						$prod->product_discount_id        = $price->product_discount_id;
						$prod->product_currency           = $price->product_currency;
						$prod->product_price              = $price->product_price;
						$prod->product_override_price     = $price->product_override_price;
						$prod->virtuemart_shoppergroup_id = $price->virtuemart_shoppergroup_id;
						$prod->price_quantity_end         = $price->price_quantity_end;
						$prod->price_quantity_start       = $price->price_quantity_start;

						if(sc_read_sanitized_get_parm("deprecated_sales_price")){
							$this->getProductsSalePriceDeprecated($prod, $virtuemart_product_id);
						}

						continue;
					}

					if(intval($price->virtuemart_shoppergroup_id) || intval($price->price_quantity_start) || intval($price->price_quantity_end)){
						$price_suff = intval($price->price_quantity_start) . "_" . intval($price->price_quantity_end) . "_" .  intval($price->virtuemart_shoppergroup_id);

						$prod->{"price_id_$price_suff"}                   = $price->virtuemart_product_price_id;
						$prod->{"product_tax_id_$price_suff"}             = $price->product_tax_id;
						$prod->{"product_discount_id_$price_suff"}        = $price->product_discount_id;
						$prod->{"product_currency_$price_suff"}           = $price->product_currency;
						$prod->{"product_price_$price_suff"}              = $price->product_price;
						$prod->{"product_override_price_$price_suff"}     = $price->product_override_price;
						$prod->{"virtuemart_shoppergroup_id_$price_suff"} = $price->virtuemart_shoppergroup_id;
						$prod->{"price_quantity_end_$price_suff"}         = $price->price_quantity_end;
						$prod->{"price_quantity_start_$price_suff"}       = $price->price_quantity_start;
					}
				}
			}

			if(!$for_order_managment && !empty($product_images)){
				$prod->images = array();
				if(isset($product_images[$virtuemart_product_id])){
					$prod->images = json_decode( $product_images[$virtuemart_product_id]->images_json );
				}
			}

			if(!$prod->product_parent_id)
				unset($prod->product_parent_id);
			
			$udf_settings_prop = "udf_settings";
			if($this->datascope == "b2b"){
				$udf_settings_prop = "udf_settings_products";
			}
			
			if($this->datascope != "orders"){
				if(isset($this->settings)){
					if(isset($this->settings->{$udf_settings_prop})){
						if(count($this->settings->{$udf_settings_prop})){
							foreach($this->settings->{$udf_settings_prop} as $udf){
								if($udf->udf_enabled && isset($udf->udf_get)){
									if(isset($udf->query_single)){
										if($udf->query_single){
											if($udf->udf_get){
												$this->udfProductGet($prod, $udf);
											}
										}
									}
								}
							}
						}
					}
				}
			}

			if(!$for_order_managment){
				if(isset($prod->product_canon_category_id))
					$prod->_url = $this->root_url . JRoute::_('/index.php?option=com_virtuemart&view=productdetails&virtuemart_product_id='.$virtuemart_product_id.'&virtuemart_category_id='.$prod->product_canon_category_id);
				else{
					$use_pcat = null;
					if(isset($prod->categories)){
						if(!empty($prod->categories)){
							$use_pcat = $prod->categories[0];
						}
					}
					if($use_pcat){
						$prod->_url = $this->root_url . JRoute::_('/index.php?option=com_virtuemart&view=productdetails&virtuemart_product_id='.$virtuemart_product_id.'&virtuemart_category_id='.$use_pcat);
					}else{
						$prod->_url = $this->root_url . JRoute::_('/index.php?option=com_virtuemart&view=productdetails&virtuemart_product_id='.$virtuemart_product_id);
					}
				}

			}
		}
		
		$udf_settings_prop = "udf_settings";
		if($this->datascope == "b2b"){
			$udf_settings_prop = "udf_settings_products";
		}

		if($this->datascope != "orders"){
			if(isset($this->settings)){
				if(isset($this->settings->{$udf_settings_prop})){
					if(count($this->settings->{$udf_settings_prop})){
						foreach($this->settings->{$udf_settings_prop} as $udf){
							if($udf->udf_enabled && isset($udf->udf_get)){
								if(isset($udf->query_single)){
									if($udf->query_single){
										continue;
									}
								}
								if($udf->udf_get){
									$this->udfProductsGet($response->products,$response->first_id,$response->last_id,$udf);
								}
							}
						}
					}
				}
			}
		}

		$response->lng = $this->db_lng_suffix;
		return $response;
	}


	function getProductsMedia($page, $limit, $additional_loaddata = null){

		if(!$page)
			$page = 1;

		if(!$limit)
			$limit = 999999999;

		$response = new stdClass;
		$response->product_images = array();



		$offset = ($page - 1) * $limit;

		$add_q  = "";
		$vendor = "";

		if($additional_loaddata){
			if(sc_get_object_value($additional_loaddata,"qwhere"))
				$add_q  = " and (" . sc_get_object_value($additional_loaddata,"qwhere") . ") ";

			if(sc_get_object_value($additional_loaddata,"vendor"))
				$vendor  = " and m.virtuemart_vendor_id = " . sc_get_object_value($additional_loaddata,"vendor") . " ";
		}

		if($page == 1){
			$this->db_sqlQuery("SELECT count(m.virtuemart_media_id) FROM
									#__virtuemart_medias as m
									LEFT JOIN
									#__virtuemart_product_medias as pm on pm.virtuemart_media_id = m.virtuemart_media_id
								WHERE
									1 = 1 ". $add_q . $vendor);

			$response->media_images_count = $this->db->loadResult();
			$response->item_count = $response->media_images_count;
		}

		try{
			$this->sessionGroupConcat();

			$q = "  SELECT
						m.*,
						concat('[',GROUP_CONCAT(pm.virtuemart_product_id),']') As ref_products
					FROM
						#__virtuemart_medias as m
						LEFT JOIN
						#__virtuemart_product_medias as pm on pm.virtuemart_media_id = m.virtuemart_media_id
					WHERE
						1 = 1 ". $add_q . $vendor . "
					GROUP BY
						m.virtuemart_media_id
					ORDER BY
						pm.virtuemart_product_id
					LIMIT $offset, $limit";

			$this->db_sqlQuery($q);

		}catch(Throwable $ex){
			if(!$response->errors)
				$response->errors = array();
			$response->errors[] = $ex->getMessage();
		}

		$response->product_images = $this->db->loadObjectList("virtuemart_media_id");
		$response->lng = $this->db_lng_suffix;
		return $response;

	}

	function getCategories($key = null, $virtuemart_vendor_id = null){

		if(!isset($this->categories))
			$this->categories = array();

		if($key == NULL){
			if(isset($this->categories["default"]))
				return $this->categories["default"];
		}else{
			if(isset($this->categories[$key]))
				return $this->categories[$key];
		}

		$add_query_condition = "";
		if($this->datascope == "b2b"){
			$add_query_condition = " AND c.published = 1 ";
		}

		$this->db_sqlQuery("SELECT
				catn.virtuemart_category_id as virtuemart_category_id,
				catn.category_name as category_name,
				LOWER(REPLACE(catn.category_name,' ','')) as category_name_sanitized,
				catp.category_parent_id,
				catn.slug as slug,
				concat(
				   coalesce( concat(catn5.category_name,'/')  ,''),
					 coalesce( concat(catn4.category_name,'/')  ,''),
					 coalesce( concat(catn3.category_name,'/')  ,''),
					 coalesce( concat(catn2.category_name,'/')  ,''),
					 coalesce( concat(catn1.category_name,'/')  ,''),
					 coalesce(catn.category_name,'')
				) as category_pathway,
				REPLACE(LOWER(concat(
				     coalesce( concat(catn5.category_name,'/')  ,''),
					 coalesce( concat(catn4.category_name,'/')  ,''),
					 coalesce( concat(catn3.category_name,'/')  ,''),
					 coalesce( concat(catn2.category_name,'/')  ,''),
					 coalesce( concat(catn1.category_name,'/')  ,''),
					 coalesce(catn.category_name,'')
				)),' ','') as category_pathway_key,
				concat(
				   coalesce( IF(NOT catn5.category_name IS NULL,'-','')  ,''),
					 coalesce( IF(NOT catn4.category_name IS NULL,'-','')  ,''),
					 coalesce( IF(NOT catn3.category_name IS NULL,'-','')  ,''),
					 coalesce( IF(NOT catn2.category_name IS NULL,'-','')  ,''),
					 coalesce( IF(NOT catn1.category_name IS NULL,'-','')  ,''),
					 coalesce(catn.category_name,'')
				) as category_path
				FROM
				#__virtuemart_categories as c
				LEFT JOIN
				#__virtuemart_categories_". $this->db_lng_suffix ." as catn on catn.virtuemart_category_id = c.virtuemart_category_id AND catn.virtuemart_category_id > 0
				LEFT JOIN
				#__virtuemart_category_categories as catp on catn.virtuemart_category_id = catp.category_child_id
				LEFT JOIN
				#__virtuemart_categories_". $this->db_lng_suffix ." as catn1 on catn1.virtuemart_category_id = catp.category_parent_id AND catn1.virtuemart_category_id > 0
				LEFT JOIN
				#__virtuemart_category_categories as catp1 on catn1.virtuemart_category_id = catp1.category_child_id
				LEFT JOIN
				#__virtuemart_categories_". $this->db_lng_suffix ." as catn2 on catn2.virtuemart_category_id = catp1.category_parent_id AND catn2.virtuemart_category_id > 0
				LEFT JOIN
				#__virtuemart_category_categories as catp2 on catn2.virtuemart_category_id = catp2.category_child_id
				LEFT JOIN
				#__virtuemart_categories_". $this->db_lng_suffix ." as catn3 on catn3.virtuemart_category_id = catp2.category_parent_id AND catn3.virtuemart_category_id > 0
				LEFT JOIN
				#__virtuemart_category_categories as catp3 on catn3.virtuemart_category_id = catp3.category_child_id
				LEFT JOIN
				#__virtuemart_categories_". $this->db_lng_suffix ." as catn4 on catn4.virtuemart_category_id = catp3.category_parent_id AND catn4.virtuemart_category_id > 0
				LEFT JOIN
				#__virtuemart_category_categories as catp4 on catn4.virtuemart_category_id = catp4.category_child_id
				LEFT JOIN
				#__virtuemart_categories_". $this->db_lng_suffix ." as catn5 on catn5.virtuemart_category_id = catp4.category_parent_id AND catn5.virtuemart_category_id > 0
				LEFT JOIN
				#__virtuemart_category_categories as catp5 on catn5.virtuemart_category_id = catp5.category_child_id
				WHERE
					c.virtuemart_category_id > 0
					AND
					NOT catn.category_name IS NULL {$add_query_condition}
				ORDER BY category_pathway, c.ordering");

		  $keys = array(
				  'virtuemart_category_id',
				  'category_name_sanitized',
				  'slug',
				  'category_pathway_key',
				  'category_pathway'
		  );

		  if($key == NULL)
			  $key = "default";

          if($key == "default" || in_array($key, $keys)){
			  $this->categories["default"] = $this->db->loadObjectList();

			  foreach($keys as $fkey){
				 $this->categories[$fkey] = array();
			  }


			  foreach($this->categories["default"] as $cat){
				  foreach($keys as $fkey){
					  if($cat->{$fkey})
						$this->categories[$fkey][$cat->{$fkey}] = $cat;
				  }
			  }

			  return $this->categories[$key];
		  }else{
			  $this->categories[$key] = $this->db->loadObjectList($key);
			  return $this->categories[$key];
		  }
	}

	function loadCustomfieldsDefinitions(){
		if(!isset($this->virtuemart_customs)){
			$this->virtuemart_customs_by_prop = array();
			$this->db_sqlQuery("SELECT * FROM #__virtuemart_customs ORDER BY ordering");
			$this->virtuemart_customs = $this->db->loadObjectList("virtuemart_custom_id");
			foreach($this->virtuemart_customs as $cf){
				$cf->custom_title  = str_replace("_"," ",str_replace("COM_VIRTUEMART_","",$this->translate( $cf->custom_title )));
				$cf->property_name = "cfield_" . url_slug(str_ireplace("COM_VIRTUEMART_","",$cf->custom_title), array('delimiter' => '_'));
				$this->virtuemart_customs_by_prop[$cf->property_name] = $cf;
			}
		}
		return $this->virtuemart_customs;
	}

	function getCoreAux($additional_loaddata = null){

		  $resp = new stdClass;

		  $resp->currencies    = array();
		  $resp->discounts     = array();
		  $resp->taxes         = array();
		  $resp->shoppergroups = array();
		  $resp->customfields  = array();
		  $resp_errors         = array();
		 
		  try{
			  $this->db_sqlQuery("SELECT virtuemart_currency_id as virtuemart_currency_id, currency_code_3, currency_exchange_rate FROM #__virtuemart_currencies ORDER BY currency_code_3;");
			  $resp->currencies = $this->db->loadObjectList('currency_code_3');
		  }catch(Throwable $ex){
			  $resp_errors["auxload_currencies"] = $ex->getMessage();
		  }
		  
		  try{
			  $this->db_sqlQuery("SELECT virtuemart_shoppergroup_id as virtuemart_shoppergroup_id, shopper_group_name FROM #__virtuemart_shoppergroups ORDER BY shopper_group_name;");
			  $resp->shoppergroups = $this->db->loadObjectList();
			  if(!empty($resp->shoppergroups)){
				  foreach($resp->shoppergroups as $index => $sg){
					  $resp->shoppergroups[$index]->shopper_group_name = str_replace("COM_VIRTUEMART_SHOPPERGROUP_","",$resp->shoppergroups[$index]->shopper_group_name);
				  }
			  }
		  }catch(Throwable $ex){
			  
			  $resp_errors["auxload_shoppergroups"] = $ex->getMessage();
		  }
		  
		  $has_dsg = false;
		  if(isset($resp->shoppergroups)){
			  
			  foreach($resp->shoppergroups as $sg){
				  if(!$sg->virtuemart_shoppergroup_id || $sg->virtuemart_shoppergroup_id == "0")
					  $has_dsg = true;
				  $sg->shopper_group_name = $this->translate( $sg->shopper_group_name );
			  }
		  }
		  
		  if(!$has_dsg){
			  $dsg = new stdClass;
			  $dsg->virtuemart_shoppergroup_id = 0;
			  $dsg->shopper_group_name         = "";
			  array_unshift($resp->shoppergroups, $dsg);
		  }

		  try{	
			  $resp->customfields = $this->loadCustomfieldsDefinitions();
		  }catch(Throwable $ex){
			  $resp->customfields = new stdClass;
			  $resp_errors["auxload_customfields"] = $ex->getMessage();
		  }
		  
		  $calcs =  array();
		  try{	
			  $this->db_sqlQuery("SELECT virtuemart_calc_id, calc_name, calc_kind FROM #__virtuemart_calcs ORDER BY calc_value");
			  $calcs = $this->db->loadObjectList();
		  }catch(Throwable $ex){
			  $resp_errors["auxload_calcs"] = $ex->getMessage();
		  }
		  
		  $no_calc = new stdClass;
		  $no_calc->virtuemart_calc_id = -1;
		  $no_calc->calc_name          = $this->translate("No rule");
		  $no_calc->calc_kind          = "";

		  $def_calc = new stdClass;
		  $def_calc->virtuemart_calc_id = 0;
		  $def_calc->calc_name          = $this->translate("Default");
		  $def_calc->calc_kind          = "";


		  $resp->discounts[] = $no_calc;
		  $resp->taxes[]     = $no_calc;

		  $resp->discounts[] = $def_calc;
		  $resp->taxes[]     = $def_calc;

		  foreach($calcs as $calc){
			  if(strpos(strtolower($calc->calc_kind),"da") !== false || strpos(strtolower($calc->calc_kind),"db") !== false){
				$resp->discounts[] = $calc;
			  }elseif( strpos(strtolower($calc->calc_kind),"tax") !== false){
				$resp->taxes[]     = $calc;
			  }
		  }

		  $this->sessionGroupConcat();
		  $rules = array();
		  
		  try{
			  $this->db_sqlQuery("SELECT
									calc.virtuemart_calc_id,
									calc.virtuemart_vendor_id,
									calc.calc_name,
									calc.calc_kind,
									calc.calc_value_mathop,
									calc.calc_value,
									calc.calc_currency,
									calc.for_override,
									calc.calc_params,
									calc.ordering,
									calc.publish_up,
									calc.publish_down,
									GROUP_CONCAT(sg.virtuemart_shoppergroup_id)  as shoppergroups,
									GROUP_CONCAT(cat.virtuemart_category_id)     as categories,
									GROUP_CONCAT(man.virtuemart_manufacturer_id) as manufacturers,
									GROUP_CONCAT(country.virtuemart_country_id)  as countries,
									GROUP_CONCAT(state.virtuemart_state_id)      as states,
									calc.modified_on
									FROM
									#__virtuemart_calcs as calc
									LEFT JOIN
									#__virtuemart_calc_shoppergroups as sg      ON sg.virtuemart_calc_id = calc.virtuemart_calc_id
									LEFT JOIN
									#__virtuemart_calc_categories    as cat     ON cat.virtuemart_calc_id = calc.virtuemart_calc_id
									LEFT JOIN
									#__virtuemart_calc_manufacturers as man     ON man.virtuemart_calc_id = calc.virtuemart_calc_id
									LEFT JOIN
									#__virtuemart_calc_countries     as country ON country.virtuemart_calc_id = calc.virtuemart_calc_id
									LEFT JOIN
									#__virtuemart_calc_states        as state  ON state.virtuemart_calc_id = calc.virtuemart_calc_id
									WHERE
									calc.published > 0
									AND
									coalesce(calc.calc_jplugin_id,0) = 0
									AND
									(calc.calc_kind = 'Tax' OR calc.calc_kind = 'VatTax' OR calc.calc_kind = 'DBTax' OR calc.calc_kind = 'DATax')
									GROUP BY calc.ordering, calc.virtuemart_calc_id");

			  $rules = $this->db->loadObjectList();
		  
		  }catch(Throwable $ex){
			  
			  $resp_errors["auxload_rules"] = $ex->getMessage();
		  }
		  
		  $resp->active_calc_rules = array();

		  $current_d = date('Y-m-d H:i:s');
		  $max_modified_on = "";

		  for($i = 0;$i < count($rules);$i++){

			  $rules[$i]->publish_up   = $this->zeroDateToNull($rules[$i]->publish_up);
			  $rules[$i]->publish_down = $this->zeroDateToNull($rules[$i]->publish_down);

			  if($rules[$i]->publish_up){
				  if($rules[$i]->publish_up > $current_d){
					  continue;
				  }
			  }

			  if($rules[$i]->publish_down){
				 if($rules[$i]->publish_down < $current_d){
					  continue;
				 }
			  }

			  if($rules[$i]->shoppergroups)
				  $rules[$i]->shoppergroups = json_decode("[{$rules[$i]->shoppergroups}]");
			  if($rules[$i]->categories)
				  $rules[$i]->categories = json_decode("[{$rules[$i]->categories}]");
			  if($rules[$i]->manufacturers)
				  $rules[$i]->manufacturers = json_decode("[{$rules[$i]->manufacturers}]");
		      if($rules[$i]->countries)
				  $rules[$i]->countries = json_decode("[{$rules[$i]->countries}]");
			  if($rules[$i]->states)
				  $rules[$i]->states = json_decode("[{$rules[$i]->states}]");

			   $resp->active_calc_rules[] = $rules[$i];
		  }

		  $response = new stdClass;
		  $response->data = $resp;
		  
		  if(!empty($resp_errors)){
			  $response->errors = $resp_errors; 
		  }

		  return $response;
	}


	function getOrderAux($additional_loaddata = null){

		$add_q  = "";
		$vendor = "";

		if($additional_loaddata){
			if(sc_get_object_value($additional_loaddata,"vendor"))
				$vendor  = " and m.virtuemart_vendor_id = " . sc_get_object_value($additional_loaddata,"vendor") . " ";
		}

		$resp_errors = array();
		
		$response = $this->getCoreAux($additional_loaddata);
		
		try{
			$this->db_sqlQuery("SELECT * FROM #__virtuemart_orderstates WHERE 1 {$vendor} ORDER BY published ASC");
			$response->data->orderstates = $this->db->loadObjectList("virtuemart_orderstate_id");
		}catch(Throwable $ex){
			$response->data->orderstates = new stdClass;
			$resp_errors["auxload_orderstates"] = $ex->getMessage();
		}
		
		$response->data->orderstatesbycode = array();

		try{
			if(!empty($response->data->orderstates)){
				foreach($response->data->orderstates as $ostate_id => $ostate){
					$response->data->orderstates[$ostate_id]->order_status_name = JText::sprintf($response->data->orderstates[$ostate_id]->order_status_name);
					$response->data->orderstates[$ostate_id]->order_status_name = str_ireplace("COM_VIRTUEMART_ORDER_STATUS_","",$response->data->orderstates[$ostate_id]->order_status_name);
					$response->data->orderstatesbycode[$response->data->orderstates[$ostate_id]->order_status_code] = $response->data->orderstates[$ostate_id];
				}
			}
		}catch(Throwable $ex){
			$resp_errors["auxload_orderstatesbycode"] = $ex->getMessage();
		}
		
		if(empty($response->data->orderstatesbycode)){
			$response->data->orderstatesbycode = new stdClass;
		}
		
		try{
			$this->db_sqlQuery("SELECT m.*, l.* FROM #__virtuemart_shipmentmethods as m LEFT JOIN #__virtuemart_shipmentmethods_{$this->db_lng_suffix} as l ON l.virtuemart_shipmentmethod_id = m.virtuemart_shipmentmethod_id WHERE 1 {$vendor}");
			$response->data->shipmentmethods = $this->db->loadObjectList("virtuemart_shipmentmethod_id");
			if(!empty($response->data->shipmentmethods)){
				foreach($response->data->shipmentmethods as $smid => $sm){
					$response->data->shipmentmethods[$smid]->shipment_params = $this->parseSeparatedParameters($response->data->shipmentmethods[$smid]->shipment_params);
				}
			}
		}catch(Throwable $ex){
			if(!isset($response->data->shipmentmethods))
				$response->data->shipmentmethods = new stdClass;
			$resp_errors["auxload_shipmentmethods"] = $ex->getMessage();
		}
		
		try{
			$this->db_sqlQuery("SELECT m.*, l.* FROM #__virtuemart_paymentmethods as m LEFT JOIN #__virtuemart_paymentmethods_{$this->db_lng_suffix} as l ON l.virtuemart_paymentmethod_id = m.virtuemart_paymentmethod_id WHERE 1 {$vendor}");
			$response->data->paymentmethods = $this->db->loadObjectList("virtuemart_paymentmethod_id");
			if(!empty($response->data->paymentmethods)){
				foreach($response->data->paymentmethods as $pmid => $pm){
					$response->data->paymentmethods[$pmid]->payment_params = $this->parseSeparatedParameters($response->data->paymentmethods[$pmid]->payment_params);
				}
			}
		}catch(Throwable $ex){
			if(!isset($response->data->paymentmethods))
				$response->data->paymentmethods = new stdClass;
			$resp_errors["auxload_paymentmethods"] = $ex->getMessage();
		}
		
		
		try{
			$this->db_sqlQuery("SELECT m.virtuemart_country_id,  m.country_name, m.country_3_code, m.country_2_code FROM #__virtuemart_countries as m WHERE 1 {$vendor}");
			$response->data->countries = $this->db->loadObjectList("virtuemart_country_id");
		}catch(Throwable $ex){
			if(!isset($response->data->countries))
				$response->data->countries = new stdClass;
			$resp_errors["auxload_countries"] = $ex->getMessage();
		}

		if(!empty($response->data->countries)){
			foreach($response->data->countries as $country_id => $country){
				$response->data->countries[ $country_id]->country_name = JText::sprintf($response->data->countries[ $country_id]->country_name);
			}
		}
		
		try{
			$this->db_sqlQuery("SELECT  m.virtuemart_state_id,
										m.virtuemart_country_id,
										m.state_name,
										m.state_3_code,
										m.state_2_code FROM #__virtuemart_states as m WHERE 1 {$vendor}");

			$response->data->states = $this->db->loadObjectList("virtuemart_state_id");
		}catch(Throwable $ex){
			if(!isset($response->data->states))
				$response->data->states = new stdClass;
			$resp_errors["auxload_states"] = $ex->getMessage();
		}

		if(!empty($response->data->states)){
			foreach($response->data->states as $state_id => $state){
				$response->data->states[ $state_id]->state_name = JText::sprintf($response->data->states[ $state_id]->state_name);
			}
		}
		
		if(!empty($resp_errors)){
			if(isset($response->errors)){
				$response->errors = array_merge($response->errors, $resp_errors);
			}else{
				$response->errors = $resp_errors;
			}
		}

		return $response;
	}

	function getProductAux($additional_loaddata = null){


		$virtuemart_vendor_id = NULL;

		if($additional_loaddata){
			if(sc_get_object_value($additional_loaddata,"vendor"))
				$virtuemart_vendor_id =  sc_get_object_value($additional_loaddata,"vendor");
		}
		
		$resp_errors = array();

		$response = $this->getCoreAux($additional_loaddata);

		$response->data->categories    = array();
		$response->data->manufacturers = array();

		try{
			//OVDE MOZE BITI MNOGO!
			$response->data->categories = $this->getCategories(null,$virtuemart_vendor_id);
		}catch(Throwable $ex){
			if(!isset($response->data->categories))
				$response->data->categories = array();
			$resp_errors["auxload_categories"] = $ex->getMessage();
		}
		
		try{
			$this->db_sqlQuery("SELECT virtuemart_manufacturer_id as virtuemart_manufacturer_id, mf_name as mf_name FROM #__virtuemart_manufacturers_". $this->db_lng_suffix ." ORDER BY mf_name;");
			$response->data->manufacturers = $this->db->loadObjectList();
		}catch(Throwable $ex){
			if(!isset($response->data->manufacturers))
				$response->data->manufacturers = array();
			$resp_errors["auxload_manufacturers"] = $ex->getMessage();
		}
	

		try{
			$response->data->udf_data      = new stdClass;
			$udf_settings_prop = "udf_settings";
			if($this->datascope == "b2b"){
				$udf_settings_prop = "udf_settings_products";
			}
			if(isset($this->settings)){
				if(isset($this->settings->{$udf_settings_prop})){
					if(count($this->settings->{$udf_settings_prop})){
						foreach($this->settings->{$udf_settings_prop} as $udf){
							if($udf->udf_enabled && isset($udf->udf_sql_get_options)){
								if($udf->udf_sql_get_options){
									try{

										$q = str_ireplace('@db.','#__', $udf->udf_sql_get_options);
										$q = str_ireplace('$lngsuff',$this->db_lng_suffix, $q);

										$this->db_sqlQuery( $q );

										$tbl = $this->db->loadAssocList();
										$response->data->udf_data->{$udf->udf_name} = array();

										if(count($tbl)){
											$valueC = "";
											$nameC  = "";
											if(isset($tbl[0]["value"]))
												$valueC = "value";
											if(isset($tbl[0]["name"]))
												$nameC = "name";

											if(!$valueC || !$nameC){
												$cls = array_keys($tbl[0]);
												if(!$valueC)
													$valueC = $cls[0];
												if(!$nameC && isset($cls[1]))
													$nameC = $cls[1];
												if(!$nameC)
													$nameC = $valueC;
											}

											foreach($tbl as $row){
												$response->data->udf_data->{$udf->udf_name}[] = array("value" => $row[$valueC], "name" => $row[$nameC] ? $row[$nameC] : $row[$valueC]);
											}
										}
										
									}catch(Throwable $uex){
										$resp_errors["auxload_{$udf->udf_name}"] = $uex->getMessage();
									}
								}else{
									$response->data->udf_data->{$udf->udf_name} = array();
								}
							}
						}
					}
				}
			}
		}catch(Throwable $ex){
			if(!isset($response->data->udf_data))
				$response->data->udf_data = new stdClass();
			$resp_errors["auxload_udf_data"] = $ex->getMessage();
		}
		
		
		if(!empty($resp_errors)){
			if(isset($response->errors)){
				$response->errors = array_merge($response->errors, $resp_errors);
			}else{
				$response->errors = $resp_errors;
			}
		}

		return $response;
	}

	function createCategoryFromPath($catpath, $catdata = null, $virtuemart_vendor_id = null){
		global $scerr;
		if(!SCvmAccess::manager('product.edit') && $this->datascope != "b2b"){
			$scerr[0]           = "The account you use to access site is not permitted to edit products!";
			return null;
		}

		if(!$catpath)
			return null;

		$this->prepareSessionForUpdateTask();

		$catpath = str_replace("\\","/",$catpath);
		$catpath = str_replace(" /","/",$catpath);
		$catpath = str_replace("/ ","/",$catpath);
		$catpath = $this->fullTrim($catpath);

		if(substr($catpath,0,1) == '/')
			$catpath = substr($catpath,1);

		if(substr($catpath,-1) == '/')
			$catpath = substr($catpath,0, strlen($catpath) - 1);

		$catpath     = explode('/',$catpath);
		$drillpath   = '';
		$prev_parent = 0;
		$cid         = -1;

		$categories          = $this->getCategories(null, $virtuemart_vendor_id);
		$catway_asoc         = $this->getCategories("virtuemart_category_id", $virtuemart_vendor_id);
		$catway_asoc_reverse = $this->getCategories("category_pathway_key", $virtuemart_vendor_id);
		$catway_pathway      = $this->getCategories("category_pathway", $virtuemart_vendor_id);

		for($cI = 0; $cI < count($catpath); $cI++){

			$drillpath .= ( ($cI > 0 ? "/" : "") . $catpath[$cI] ) ;
			$drillpath_n = $this->normalizedLowercaseHash($drillpath);

			if(!isset($catway_asoc_reverse[$drillpath_n])){

				$csql = "   INSERT INTO
							#__virtuemart_categories(virtuemart_category_id,virtuemart_vendor_id,category_template,category_layout,category_product_layout,products_per_row,limit_list_step,limit_list_initial,hits,metarobot,metaauthor,ordering,shared,published,created_on,created_by,modified_on,modified_by,locked_on,locked_by)
							VALUES ( NULL,1,0,0,0,0,0,0,0,'','',0,0,1,NOW(),{$this->user_id},NOW(),{$this->user_id},'0000-00-00 00:00:00',0 );";

				$this->db_query($csql);
				$cid = $this->db->insertid();
				if(!$cid)
					return null;

				$cpsql = "INSERT INTO #__virtuemart_category_categories(
							   id
							  ,category_parent_id
							  ,category_child_id
							  ,ordering
							) VALUES (
							   NULL
							  ,$prev_parent
							  ,$cid
							  ,0
							)";

				$this->db_query($cpsql);

				$slug = strtolower($this->fullTrim($catpath[$cI]));
				$slug = str_replace(array('@','*',' ','_','.','$','#',"'",'"'),
									array('' ,'' ,'-','-','-','-','-',"" ,"" ),
									$slug);

				$lngs = $this->getDBLanguages();
				foreach($lngs as $lsuff){
					try{

							$this->db_sqlQuery("SELECT count(*) FROM #__virtuemart_categories_$lsuff WHERE slug = " . $this->db_quote( $slug));

							if($this->db->loadResult()){
								$slug .= "-$cid";
							}

							$this->db_query("INSERT INTO #__virtuemart_categories_$lsuff(
											   virtuemart_category_id
											  ,category_name
											  ,slug
											) VALUES (
											   $cid
											  ," . $this->db_quote( $this->fullTrim($catpath[$cI])) . "
											  ," . $this->db_quote( $slug) . "
											)");
					}catch(Throwable $ic_ex){
						return null;
					}
				}



				$cat = new stdClass();
				$cat->virtuemart_category_id  = $cid;
				$cat->category_name           = $this->fullTrim($catpath[$cI]);
				$cat->category_name_sanitized = strtolower(str_replace(" ","",$cat->category_name));
				$cat->category_parent_id      = $prev_parent;

				$cat->category_path           = explode("/",$drillpath);

				for($j = 0; $j < count($cat->category_path) - 1; $j++)
					$cat->category_path[$j] = "-";
				$cat->category_path = implode("",$cat->category_path);


				$cat->category_pathway        = $drillpath;
				$cat->category_pathway_key    = $drillpath_n;
				$cat->slug                    = $slug;


				$categories[] = $cat;
				$catway_asoc_reverse[$drillpath_n]   = &$categories[count($categories) - 1];
				$catway_asoc[$cid]                   = &$categories[count($categories) - 1];
				$catway_pathway[$drillpath]          = &$categories[count($categories) - 1];

				global $added_aux;
				if(!isset($added_aux))
					$added_aux = new stdClass;

				if(!isset($added_aux->categories))
					$added_aux->categories      = array();
				if(!isset($added_aux->categories))
					$added_aux->categories_dict = array();

				$added_aux->categories[] = $cat;
				$added_aux->categories_dict[$cat->virtuemart_category_id] = $cat;

			}

			if(!isset($catway_asoc_reverse[$drillpath_n]))
				return null;

			$prev_parent = $catway_asoc_reverse[$drillpath_n]->virtuemart_category_id;
			$drillpath   = $catway_asoc_reverse[$drillpath_n]->category_pathway;
		}


		if($cid == -1)
			$cid = null;
		return $cid;
	}


	function addPrice($virtuemart_product_id, $update_data){
		$this->prepareSessionForUpdateTask();
		
		$this->loadTableDefinition("#__virtuemart_product_prices");
		$update_data->virtuemart_product_id = $virtuemart_product_id;

		$ins_fld = array();
		$ins_vls = array();

		if(isset($update_data->{"product_sales_price"})){
			$pdata = array();
			$pdata["salesPrice"] = floatval($update_data->{"product_sales_price"});
			ob_start();
			$update_data->product_price = $this->calculator->calculateCostprice ($virtuemart_product_id, $pdata);
			ob_end_clean();
		}

		if(!isset($update_data->product_currency)){
			$this->getVendors();
			if($this->vendor_id)
				$update_data->product_currency = $this->vendors[ $this->vendor_id ]->vendor_currency;
			else{
				foreach($this->vendors as $vendor_id => $vendor){
					$update_data->product_currency = $this->vendors[ $vendor_id ]->vendor_currency;
					break;
				}
			}
		}

		foreach($update_data as $prop => $value){
			if(isset($this->tbl["#__virtuemart_product_prices"][$prop])){
				$type      = $this->tbl["#__virtuemart_product_prices"][$prop]->Type;
				$nullable  = stripos($this->tbl["#__virtuemart_product_prices"][$prop]->Null,"NO") === false;
				
				if(is_object($update_data->{$prop}) || is_array($update_data->{$prop})){
					$update_data->{$prop} = json_decode($update_data->{$prop});
				}
				if(stripos($type,"int(") !== false){
					if(stripos($update_data->{$prop},"false") !== false)
						$update_data->{$prop} = 0;
					else if(stripos($update_data->{$prop},"true") !== false)
						$update_data->{$prop} = 1;
					else{
						if(!$nullable && $update_data->{$prop} === null){
							$update_data->{$prop} = 0;
						}
					}
					
					$ins_fld[] = $prop;
					$ins_vls[] = $this->db_quote($update_data->{$prop});
				}else if(stripos($type,"date") !== false){
					
					if(!$nullable && $update_data->{$prop} === null){
						$update_data->{$prop} = "0000-00-00 00:00:00";
					}
					
					$ins_fld[] = $prop;
					$ins_vls[] = $this->db_quote($update_data->{$prop});
					
				}else{
					if(!$nullable && $update_data->{$prop} === null){
						$update_data->{$prop} = "";
					}
					
					$ins_fld[] = $prop;
					$ins_vls[] = $this->db_quote($update_data->{$prop});
				}

			}
		}

		foreach($this->tbl["#__virtuemart_product_prices"] as $prop => $field){

			if($field->Default && !isset($update_data->{$prop})){
				$ins_fld[] = $prop;
				$ins_vls[] = $this->db_quote($field->Default);
			}

		}

		$this->db_query("INSERT INTO #__virtuemart_product_prices(".implode(",", $ins_fld ).")
						 VALUES(". implode(",", $ins_vls ) .");");

	}

	function updatePrice($virtuemart_product_id, $update_data){
		$this->prepareSessionForUpdateTask();
		
		$this->loadTableDefinition("#__virtuemart_product_prices");
		$pp_upd = array();

		if(isset($update_data->{"product_sales_price"})){

			$pdata = array();
			$pdata["salesPrice"] = floatval($update_data->{"product_sales_price"});
			ob_start();
			$update_data->product_price = $this->calculator->calculateCostprice ($virtuemart_product_id, $pdata);
			ob_end_clean();



		}

		if(!isset($update_data->product_currency)){
			$this->getVendors();
			if($this->vendor_id)
				$update_data->product_currency = $this->vendors[ $this->vendor_id ]->vendor_currency;
			else{
				foreach($this->vendors as $vendor_id => $vendor){
					$update_data->product_currency = $this->vendors[ $vendor_id ]->vendor_currency;
					break;
				}
			}
		}

		foreach($update_data as $prop => $value){
			if($prop == "virtuemart_product_price_id")
				continue;

			if(isset($this->tbl["#__virtuemart_product_prices"][$prop])){
				$type = $this->tbl["#__virtuemart_product_prices"][$prop]->Type;
				$nullable  = stripos($this->tbl["#__virtuemart_product_prices"][$prop]->Null,"NO") === false;
				
				if(is_object($update_data->{$prop}) || is_array($update_data->{$prop})){
					$update_data->{$prop} = json_decode($update_data->{$prop});
				}

				if(stripos($type,"int(") !== false){
					if(stripos($update_data->{$prop},"false") !== false)
						$update_data->{$prop} = 0;
					else if(stripos($update_data->{$prop},"true") !== false)
						$update_data->{$prop} = 1;
					else{
						if(!$nullable && $update_data->{$prop} === null){
							$update_data->{$prop} = 0;
						}
					}
					$pp_upd[] = (" pp.{$prop} = " . $this->db_quote($update_data->{$prop}) . " ");
				}else if(stripos($type,"date") !== false){
					if(!$nullable && $update_data->{$prop} === null){
						$update_data->{$prop} = "0000-00-00 00:00:00";
					}
					$pp_upd[] = (" pp.{$prop} = " . $this->db_quote($update_data->{$prop}) . " ");
				}else{
					if(!$nullable && $update_data->{$prop} === null){
						$update_data->{$prop} = "";
					}
					$pp_upd[] = (" pp.{$prop} = " . $this->db_quote($update_data->{$prop}) . " ");
				}
			}
		}

		if(!empty($pp_upd)){
			$this->db_query("UPDATE
								#__virtuemart_product_prices as pp
								LEFT JOIN
								#__virtuemart_products as p on p.virtuemart_product_id = pp.virtuemart_product_id
							 SET
								". implode(" , ",$pp_upd) .",
								pp.modified_on = NOW(),
								p.modified_on = NOW()
							 WHERE virtuemart_product_price_id = ". $update_data->virtuemart_product_price_id);
		}
	}


	function updateProductImages($virtuemart_product_id, $images){
		global $scerr;
		if(!SCvmAccess::manager('product.edit') && $this->datascope != "b2b"){
			$scerr[0]           = "The account you use to access site is not permitted to edit products!";
			return null;
		}
		
		$this->prepareSessionForUpdateTask();

		$ids = array();
		foreach($images as $img){
			if(isset($img->id)){
				if($img->id){
					$ids[] = $img->id;
				}
			}
		}

		if($virtuemart_product_id){
			if(!empty($ids))
				$this->db_query("DELETE FROM #__virtuemart_product_medias WHERE virtuemart_product_id = {$virtuemart_product_id} AND NOT id IN (".implode(",",$ids).");");
			else
				$this->db_query("DELETE FROM #__virtuemart_product_medias WHERE virtuemart_product_id = {$virtuemart_product_id};");
		}

		if($images){
			foreach($images as $img){
				$updated = false;

				if(isset($img->id)){
					if($img->id){
						$this->db_query("UPDATE #__virtuemart_product_medias
										 SET
											virtuemart_media_id = ".$this->db_quote($img->virtuemart_media_id).",
											ordering            = ".$this->db_quote(intval($img->ordering))."
										 WHERE
										 id = ".$img->id."
										 AND
										 virtuemart_product_id = $virtuemart_product_id;");
						$updated = true;
					}
				}

				if(!$updated){
					$this->db_query("INSERT INTO #__virtuemart_product_medias (id, virtuemart_product_id, virtuemart_media_id, ordering)
									 VALUES(NULL,$virtuemart_product_id,".$img->virtuemart_media_id.",". intval($img->ordering) ."  );");
				}
			}
		}

		if(!isset($this->tbl["#__virtuemart_products"]))
			$this->loadTableDefinition("#__virtuemart_products");

		if(isset($this->tbl["#__virtuemart_products"]["has_medias"])){
			$has_medias = empty($images) ? 0 : 1;
			$this->db_query("UPDATE #__virtuemart_products SET has_medias = {$has_medias} WHERE virtuemart_product_id = {$virtuemart_product_id}");
		}
	}

	function createProduct($parent_id, $name = ''){
		//OVDE!
		
		$this->prepareSessionForUpdateTask();
		$virtuemart_product_id  = NULL;
		$dflt = $this->productModel->getTable ('products');

		if($parent_id){
			$virtuemart_product_id = $this->productModel->createChild($parent_id);
		}else{

			$pr = $this->productModel->getProductSingle(NULL,false);
			$pr->product_name = $name;
			$virtuemart_product_id = $this->productModel->store($pr);
			/*
			$this->loadTableDefinition("#__virtuemart_products");
			$ptbl = $this->tbl["#__virtuemart_products"];

			$cols = array();
			$vals = array();

			foreach($ptbl as $pcol){

				if($pcol->Field == "virtuemart_product_id"){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote(NULL);
				}else if($pcol->Field == "created_on" || $pcol->Field == "modified_on"){
					$cols[] = $pcol->Field;
					$vals[] = "NOW()";
				}else if($pcol->Field == "created_by" || $pcol->Field == "modified_by"){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote($this->user_id);
				}else if($pcol->Field == "product_params"){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote('min_order_level=""|max_order_level=""|step_order_level=""|product_box=""|');
				}else if($pcol->Default !== NULL){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote($pcol->Default);
				}else if(isset($dflt->{$pcol->Field})){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote($dflt->{$pcol->Field});
				}
			}

			$this->db_sqlQuery("INSERT INTO #__virtuemart_products(".implode(",",$cols).") VALUES (".implode(",",$vals).");");
			$this->db->execute();
			$virtuemart_product_id  = $this->db->insertid();
			*/
		}

		/*
		if($virtuemart_product_id && !$parent_id){
			$lngs = $this->getDBLanguages();

			$this->loadTableDefinition("#__virtuemart_products_".$lngs[0]);
			$pltbl = $this->tbl["#__virtuemart_products_".$lngs[0]];

			$cols = array();
			$vals = array();

			foreach($pltbl as $pcol){

				if($pcol->Field == "virtuemart_product_id"){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote($virtuemart_product_id);
				}else if($pcol->Field == "created_on" || $pcol->Field == "modified_on"){
					$cols[] = $pcol->Field;
					$vals[] = "NOW()";
				}else if($pcol->Field == "created_by" || $pcol->Field == "modified_by"){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote($this->user_id);
				}else if($pcol->Field == "product_name"){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote($name);
				}else if($pcol->Field == "slug"){
					$cols[] = $pcol->Field;
					if(!$name)
						$name = "product-$virtuemart_product_id";
					$vals[] = $this->db_quote(url_slug($name));
				}else if($pcol->Default !== NULL){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote($pcol->Default);
				}else if(isset($dflt->{$pcol->Field})){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote($dflt->{$pcol->Field});
				}

			}

			foreach($lngs as $lsuff){
				$this->db_sqlQuery("INSERT INTO #__virtuemart_products_$lsuff(".implode(",",$cols).") VALUES (".implode(",",$vals).");");
				$this->db->execute();
			}

			$this->loadTableDefinition("#__virtuemart_product_prices");

			$pptbl = $this->tbl["#__virtuemart_product_prices"];

			$cols = array();
			$vals = array();
			$dflt = $this->productModel->getTable ('product_prices');

			foreach($pptbl as $pcol){

				if($pcol->Field == "virtuemart_product_id"){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote($virtuemart_product_id);
				}else if($pcol->Field == "created_on" || $pcol->Field == "modified_on"){
					$cols[] = $pcol->Field;
					$vals[] = "NOW()";
				}else if($pcol->Field == "created_by" || $pcol->Field == "modified_by"){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote($this->user_id);
				}else if($pcol->Default !== NULL){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote($pcol->Default);
				}else if(isset($dflt->{$pcol->Field})){
					$cols[] = $pcol->Field;
					$vals[] = $this->db_quote($dflt->{$pcol->Field});
				}
			}
		}
		*/
		return $virtuemart_product_id;
	}

	function get_variables_from_expression($exp){
		$pattern = '/((!\$|\$)[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*[0-9a-zA-Z\'\"\$_\[\]]*)/';
		$result = preg_match_all($pattern,$exp,$matches);
		return($matches[0]);
	}

	function queryEmbedUDFParams($product_data, $query, $value = null, $dispersed_by = null, $index = null){
		$vars = $this->get_variables_from_expression($query);
		if($vars){
			if(count($vars)){
				foreach($vars as $v){
					if($v){
						if(trim($v) != "$"){
							$v       = strtolower($v);
							$tmp     = explode("[",$v);
							$prop    = substr(trim(strtolower($tmp[0])),1);
							$subprop = "";

							if(isset($tmp[1])){
								$subprop = trim(strtolower(str_replace( array("]",'"',"'") , array("","","") ,$tmp[1])));
							}

							if($prop == "lngsuff"){
								$query = str_ireplace($v, $this->db_lng_suffix, $query);
							}else if($prop == "value"){
								if($value !== null){
									if(is_object($value)){
										if($subprop){
											$val = NULL;
											if(isset($value->{$subprop}))
												$val = $value->{$subprop};
											$query = str_ireplace($v, $this->db_quote($val), $query);
										}else{
											$a = array();
											foreach($value as $p => $pv)
												$a[] = $this->db_quote($p);//WE TAKE KEYS
											$query = str_ireplace($v, implode(",", $a), $query);
										}
									}else if(is_array($value)){
										if($subprop){
											$val = NULL;
											if(isset($value[$subprop]))
												$val = $value[$subprop];
											$query = str_ireplace($v, $this->db_quote($val), $query);
										}else{
											$a = array();
											foreach($value as $p => $pv)
												$a[] = $this->db_quote($pv);//WE TAKE VALUES
											$query = str_ireplace($v, implode(",", $a), $query);
										}
									}else{
										$query = str_ireplace($v, $this->db_quote($value), $query);
									}
								}else{
									$query = str_ireplace($v, $this->db_quote(NULL), $query);
								}
							}else{
								if(property_exists($product_data,$prop)){
									if($product_data->{$prop} !== null){
										$val = $product_data->{$prop};

										if($dispersed_by && $prop == $dispersed_by){
											if(is_object($val)){
												if(isset($val->{$index}))
													$val = $val->{$index};
												else
													$val = NULL;
											}else if(is_array($val)){
												if(isset($val[$index]))
													$val = $val[$index];
												else
													$val = NULL;
											}
										}

										if($val == NULL){
											$query = str_ireplace($v, $this->db_quote(NULL), $query);
										}else if(is_object($val)){
											if($subprop){
												$set = $this->db_quote(NULL);
												if(isset($val->{$subprop}))
													$set = $this->db_quote($val->{$subprop});
												else if($dispersed_by != $prop){
													$a = array();
													foreach($val as $ind => $itm){
														if(is_object($itm)){
															if(property_exists($itm,$subprop)){
																$a[] = $this->db_quote($itm->{$subprop});
															}
														}else if(is_array($itm)){
															if(array_key_exists($subprop, $itm)){
																$a[] = $this->db_quote($itm[$subprop]);
															}
														}
													}
													$set = implode(",",$a);
												}
												$query = str_ireplace($v, $set, $query);
											}else{
												$a = array();
												foreach($val as $p => $pv)
													$a[] = $this->db_quote($p);//WE TAKE KEYS
												$query = str_ireplace($v, implode(",", $a), $query);
											}
										}else if(is_array($val)){
											if($subprop){
												$set =$this->db_quote(NULL);
												if(isset($val[$subprop]))
													$set = $this->db_quote($val[$subprop]);
												else if($dispersed_by != $prop){
													$a = array();
													foreach($val as $ind => $itm){
														if(is_object($itm)){
															if(property_exists($itm,$subprop)){
																$a[] = $this->db_quote($itm->{$subprop});
															}
														}else if(is_array($itm)){
															if(array_key_exists($subprop, $itm)){
																$a[] = $this->db_quote($itm[$subprop]);
															}
														}
													}
													$set = implode(",",$a);
												}
												$query = str_ireplace($v, $set, $query);
											}else{
												$a = array();
												foreach($val as $p => $pv)
													$a[] = $this->db_quote($pv);//WE TAKE VALUES
												$query = str_ireplace($v, implode(",", $a), $query);
											}
										}else{
											$query = str_ireplace($v, $this->db_quote($val), $query);
										}

									}else{
										$query = str_ireplace($v, $this->db_quote(NULL), $query);
									}
								}else{
									$query = str_ireplace($v, $this->db_quote(NULL), $query);
								}
							}
						}
					}
				}
			}
		}

		return $query;
	}

	function paramSQL($update_data, $sql, $value = null, $udf_prop_name = null, $entity_data_before = null){
		try{
			$qs = explode(";", str_ireplace("@db.","#__",$sql));
			
			$old_val = null;
			if($udf_prop_name && $entity_data_before){
				if(isset($entity_data_before->{$udf_prop_name})){
					$old_val = $entity_data_before->{$udf_prop_name};
				}
			}
			
			for($i = 0 ; $i < count($qs); $i++){
				$q = trim($qs[$i]);
				if($q){
					$disperses = array();
					
					if(strpos($q,"[") === 0){
						$d_end = strpos($q,"]");
						if($d_end !== false){
							$d = substr($q, 0, $d_end + 1);
							$q = substr($q, $d_end + 1);
							$disperses[] = str_replace(" ","",str_replace("$","",trim($d,"[]")));
						}
					}
					
					if(!empty($disperses)){
						if(isset($update_data->{$disperses[0]}) || ($disperses[0] == "value" || $disperses[0] == "value-" || $disperses[0] == "value+")){
							if($disperses[0] == "value" || $disperses[0] == "value-" || $disperses[0] == "value+"){
								
								$v  = $value;
								$ov = $old_val;
								
								if(is_object($v)){
									$v = array_values((array)$v);	
								}else if(!is_array($v)){
									$v = array($v);
								}
								
								if($ov){
									if(is_object($ov)){
										$ov = array_values((array)$ov);	
									}else if(!is_array($old_val)){
										$ov = array($ov);
									}
								}
								
								if($disperses[0] == "value-"){
									if($ov){
										if(!empty($ov)){
											foreach($ov as $index => $oval){
												$do = false;
												if(!$v){
													$do = true;
												}else if(!in_array($oval, $v)){
													$do = true;
												}
												
												if($do){
													$qN = $this->queryEmbedUDFParams($update_data, $q, $oval,'value',null);
													$this->db_sqlQuery($qN);
													$this->db_query();
												}
											}
										}
									}
								}else if($disperses[0] == "value+"){
									if($v){
										if(!empty($v)){
											foreach($v as $index => $nval){
												$do = false;
												if(!$ov){
													$do = true;
												}else if(!in_array($nval,$ov)){
													$do = true;
												}
												if($do){
													$qN = $this->queryEmbedUDFParams($update_data, $q, $nval,'value',$index);
													$this->db_sqlQuery($qN);
													$this->db_query();
												}
											}
										}
									}
								}else{
									if(empty($v)){
										$qN = $this->queryEmbedUDFParams($update_data, $q, null,'value',0);
										$this->db_sqlQuery($qN);
										$this->db_query();
									}else{
										foreach($v as $index => $nval){
											$qN = $this->queryEmbedUDFParams($update_data, $q, $nval,'value',$index);
											$this->db_sqlQuery($qN);
											$this->db_query();
										}
									}
								} 
							}else{
								if(is_array($update_data->{$disperses[0]}) || is_object($update_data->{$disperses[0]})){
									foreach($update_data->{$disperses[0]} as $index => $item){
										$qN = $this->queryEmbedUDFParams($update_data, $q, $value, $disperses[0], $index);
										$this->db_sqlQuery($qN);
										$this->db_query();
									}
								}else{
									$qN = $this->queryEmbedUDFParams($update_data, $q, $value, $disperses[0], null);
									$this->db_sqlQuery($qN);
									$this->db_query();
								}
							}
						}
					}else{
						$q = $this->queryEmbedUDFParams($update_data, $q, $value);
						$this->db_sqlQuery($q);
						$this->db_query();
					}
				}
			}

		}catch(Throwable $ex){
			global $scerr;
			if(!isset($scerr))
				$scerr = array();
			if(!isset($scerr["paramSQL"]))
				$scerr["paramSQL"] = array();
			$scerr["paramSQL"][] = $ex->getMessage();
		}
	}

	//DEPRACTED
	function udfProductGet($product_data, $udf){
		if(!$udf)
			return;
		try{
			if(isset($udf->udf_get)){
				if(trim($udf->udf_get)){
					$q = $this->queryEmbedUDFParams($product_data, str_ireplace("@db.","#__",$udf->udf_get), NULL);
					if($q){
						$this->db_sqlQuery($q);

						$multiple     = false;

						if(isset($udf->udf_multiple)){
							$multiple     = $udf->udf_multiple;
						}
						
						$full_data = false;
						if(isset($udf->udf_full_data)){
							if($udf->udf_full_data){
								$full_data = true;
							}
						}

						if($multiple){
							if($full_data)
								$product_data->{$udf->udf_name } = $this->db->loadObjectList();
							else	
								$product_data->{$udf->udf_name } = $this->db->loadColumn();
						}else{
							if($full_data)
								$product_data->{$udf->udf_name } = $this->db->loadObject();
							else	
								$product_data->{$udf->udf_name } = $this->db->loadResult();
						}
					}
				}
			}
		}catch(Throwable $ex){
			//
		}
	}
	
	function udfProductsGet($products, $first_id, $last_id, $udf){
		return $this->udfEntitiesGet($products, $first_id, $last_id, $udf, 'virtuemart_product_id');
	}
	
	function udfOrdersGet($orders, $first_id, $last_id, $udf){
		return $this->udfEntitiesGet($orders, $first_id, $last_id, $udf, 'virtuemart_order_id');
	}
		
	function udfEntitiesGet($entities, $first_id, $last_id, $udf, $primary_identifier = 'virtuemart_product_id'){
		if(!$udf)
			return;
		try{
			if(isset($udf->udf_get)){
				if(trim($udf->udf_get)){
					$q = $udf->udf_get;

					$q = str_ireplace('@db.',"#__",$q);
					$q = str_ireplace('$first_id',$first_id,$q);
					$q = str_ireplace('$last_id' ,$last_id,$q);
					$q = str_ireplace('$lngsuff' ,$this->db_lng_suffix,$q);

					$res  = null;

					if($q){
						$this->db_sqlQuery($q);
						$multiple     = false;

						if(isset($udf->udf_multiple)){
							$multiple = $udf->udf_multiple;
						}
						
						$full_data = false;
						if(isset($udf->udf_full_data)){
							if($udf->udf_full_data){
								$full_data = true;
							}
						}
						
						$rows      = null;
						$first_key = null;
						
						if($full_data){
							$rows = $this->db->loadAssocList();
						}else
							$rows = $this->db->loadRowList();
						
						if(!empty($rows)){
							$res  = array();
							foreach($rows as $row){
								if($full_data && !$first_key){
									foreach($row as $key => $d){
										$first_key = $key;
										break;
									}
								}
								
								if($multiple){
									if(!isset($res[$row[0]])){
										$res[$row[0]] = array();
									}
									if($full_data)
										$res[$row[$first_key]][] = $row;
									else	
										$res[$row[0]][] = $row[1];
								}else{
									if($full_data)
										$res[$row[$first_key]] = $row;
									else
										$res[$row[0]] = $row[1];
								}
							}
						}

						if($res){
							foreach($entities as $index => $prod){
								if(isset($res[$prod->{$primary_identifier}])){
									$prod->{$udf->udf_name } = $res[$prod->{$primary_identifier}];
								}else{
									if($multiple){
										$prod->{$udf->udf_name } = array();
									}else{
										$prod->{$udf->udf_name } = null;
									}
								}
							}
						}
					}
				}
			}
		}catch(Throwable $ex){
			//
		}
	}

	function udfEntityUpdate($update_data, $udf, $value = null, $entity_data_before = null){
		try{
			if($udf->udf_update){
				$this->paramSQL($update_data, $udf->udf_update, $value, $udf->udf_name, $entity_data_before);
			}
		}catch(Throwable $ex){
			//
		}
	}

	private function get_price_property_scope($price_property, $price_property_scoped){
		$scopes = trim(str_replace($price_property , "", $price_property_scoped));
		$p = new stdClass;
		$p->price_quantity_start       = 0;
		$p->price_quantity_end         = 0;
		$p->virtuemart_shoppergroup_id = 0;

		if($scopes){
			$scopes = explode("_",substr($scopes,1));
			if(count($scopes) == 3){
				$p->price_quantity_start       = intval($scopes[0]);
				$p->price_quantity_end         = intval($scopes[1]);
				$p->virtuemart_shoppergroup_id = intval($scopes[2]);
			}
		}
		return $p;
	}

	private function extractPricesFromProductData($virtuemart_product_id, $update_data, $was_create = null){
		$scoped_prices = array();
		$prices = array();

		foreach($update_data as $price_prop => $price_prop_val){
			if(    strpos($price_prop,"product_sales_price") === 0
				|| strpos($price_prop,"product_price") === 0
				|| strpos($price_prop,"product_override_price") === 0
				|| strpos($price_prop,"product_currency") === 0
				|| strpos($price_prop,"product_tax_id") === 0
				|| strpos($price_prop,"product_discount_id") === 0
				|| strpos($price_prop,"product_tax_id") === 0
				|| strpos($price_prop,"product_price_publish_down") === 0
				|| strpos($price_prop,"product_price_publish_up") === 0
			){

				if(strpos($price_prop,"product_sales_price") === 0){
					$p = $this->get_price_property_scope("product_sales_price",$price_prop);
					$scope = "{$p->price_quantity_start}_{$p->price_quantity_end}_{$p->virtuemart_shoppergroup_id}";
					if(!isset($scoped_prices[$scope])){
						$scoped_prices[$scope] = $p;
					}
					$scoped_prices[$scope]->{"product_sales_price"} = $price_prop_val;
				}else if(strpos($price_prop,"product_price") === 0){
					$p = $this->get_price_property_scope("product_price",$price_prop);
					$scope = "{$p->price_quantity_start}_{$p->price_quantity_end}_{$p->virtuemart_shoppergroup_id}";
					if(!isset($scoped_prices[$scope])){
						$scoped_prices[$scope] = $p;
					}
					$scoped_prices[$scope]->{"product_price"} = $price_prop_val;
				}else if(strpos($price_prop,"product_override_price") === 0){
					$p = $this->get_price_property_scope("product_override_price",$price_prop);
					$scope = "{$p->price_quantity_start}_{$p->price_quantity_end}_{$p->virtuemart_shoppergroup_id}";
					if(!isset($scoped_prices[$scope])){
						$scoped_prices[$scope] = $p;
					}
					$scoped_prices[$scope]->{"product_override_price"} = $price_prop_val;
				}else if(strpos($price_prop,"product_currency") === 0){
					$p = $this->get_price_property_scope("product_currency",$price_prop);
					$scope = "{$p->price_quantity_start}_{$p->price_quantity_end}_{$p->virtuemart_shoppergroup_id}";
					if(!isset($scoped_prices[$scope])){
						$scoped_prices[$scope] = $p;
					}
					$scoped_prices[$scope]->{"product_currency"} = $price_prop_val;
				}else if(strpos($price_prop,"product_tax_id") === 0){
					$p = $this->get_price_property_scope("product_tax_id",$price_prop);
					$scope = "{$p->price_quantity_start}_{$p->price_quantity_end}_{$p->virtuemart_shoppergroup_id}";
					if(!isset($scoped_prices[$scope])){
						$scoped_prices[$scope] = $p;
					}
					$scoped_prices[$scope]->{"product_tax_id"} = $price_prop_val;
				}else if(strpos($price_prop,"product_discount_id") === 0){
					$p = $this->get_price_property_scope("product_discount_id",$price_prop);
					$scope = "{$p->price_quantity_start}_{$p->price_quantity_end}_{$p->virtuemart_shoppergroup_id}";
					if(!isset($scoped_prices[$scope])){
						$scoped_prices[$scope] = $p;
					}
					$scoped_prices[$scope]->{"product_discount_id"} = $price_prop_val;
				}else if(strpos($price_prop,"product_tax_id") === 0){
					$p = $this->get_price_property_scope("product_tax_id",$price_prop);
					$scope = "{$p->price_quantity_start}_{$p->price_quantity_end}_{$p->virtuemart_shoppergroup_id}";
					if(!isset($scoped_prices[$scope])){
						$scoped_prices[$scope] = $p;
					}
					$scoped_prices[$scope]->{"product_tax_id"} = $price_prop_val;
				}else if(strpos($price_prop,"product_price_publish_down") === 0){
					$p = $this->get_price_property_scope("product_price_publish_down",$price_prop);
					$scope = "{$p->price_quantity_start}_{$p->price_quantity_end}_{$p->virtuemart_shoppergroup_id}";
					if(!isset($scoped_prices[$scope])){
						$scoped_prices[$scope] = $p;
					}
					$scoped_prices[$scope]->{"product_price_publish_down"} = $price_prop_val;
				}else if(strpos($price_prop,"product_price_publish_up") === 0){
					$p = $this->get_price_property_scope("product_price_publish_up",$price_prop);
					$scope = "{$p->price_quantity_start}_{$p->price_quantity_end}_{$p->virtuemart_shoppergroup_id}";
					if(!isset($scoped_prices[$scope])){
						$scoped_prices[$scope] = $p;
					}
					$scoped_prices[$scope]->{"product_price_publish_up"} = $price_prop_val;
				}
			}
		}

		if($was_create){
			foreach($scoped_prices as $price){
				$prices["_sur_" . rand(10000,99999)] = $price;
			}
		}else{
			$this->db_query("SELECT concat(coalesce(price_quantity_start,'0'),'_',coalesce(price_quantity_end,'0'),'_',coalesce(virtuemart_shoppergroup_id,'0')) as pscope , virtuemart_product_price_id  FROM #__virtuemart_product_prices WHERE virtuemart_product_id = {$virtuemart_product_id}");
			$exs_prices = $this->db->loadAssocList('pscope', 'virtuemart_product_price_id');
			
			// if(isset($update_data->price_id)){
				// if(intval($update_data->price_id)){
					
				// }
			// }
			
			foreach($scoped_prices as $scp => $price){
				if(isset($exs_prices[$scp])){
					$price->virtuemart_product_price_id = $exs_prices[$scp];
					$prices[$exs_prices[$scp]] = $price;
				}else{
					$prices["_sur_" . rand(10000,99999)] = $price;
				}
			}
		}
		return $prices;
	}

	function updateProduct(&$update_data,&$updates_additional_ids,$parent_id = null){
		global $scerr;

		if(!SCvmAccess::manager('product.edit') && $this->datascope != "b2b"){
			$scerr[0]           = "The account you use to access site is not permitted to edit products!";
			return null;
		}
		
		$this->prepareSessionForUpdateTask();

		if(!$update_data)
			$virtuemart_product_id = null;
		elseif(isset($update_data->{"virtuemart_product_id"}))
			$virtuemart_product_id = $update_data->{"virtuemart_product_id"};
		else
			$virtuemart_product_id = null;

		$virtuemart_vendor_id = sc_get_object_value($update_data, "virtuemart_vendor_id",null);

		try{
			$was_create = false;

			if(!$virtuemart_product_id){

				if(isset($update_data->product_parent_id)){
					$virtuemart_product_id = $this->createProduct($parent_id ? $parent_id : $update_data->product_parent_id);
					$was_create = true;
				}else{
					$name = "Product " . rand(1000000, 9999999);
					if(isset($update_data->product_name)){
						$name = $update_data->product_name;
					}
					$virtuemart_product_id = $this->createProduct(0,$name);
					$was_create = true;
				}

				if(!$virtuemart_product_id){
					if(isset($update_data->product_parent_id)){
						$scerr[0]           = "Create product child failed!";
					}else{
						$scerr[0]           = "Create product failed!";
					}

					return null;
				}
			}

			if(isset($update_data->product_parent_id) && $parent_id){
				$update_data->product_parent_id = $parent_id;
			}

			if($parent_id == null){
				$this->loadTableDefinition("#__virtuemart_products");
				$this->loadTableDefinition("#__virtuemart_products_" . $this->db_lng_suffix);
				$this->loadTableDefinition("#__virtuemart_product_prices");
			}


			$do_triggers = true;
			if(isset($this->settings->vm_plugins_no_trigger)){
				if($this->settings->vm_plugins_no_trigger == false)
					$do_triggers = false;
			}

			$update_data_array   = null;
			$product_table_data  = null;

			if($do_triggers){
				 $this->initJoomlaDispatcher();
				 try{
					$update_data_array = json_decode(json_encode($update_data),true);
					$update_data_array["virtuemart_product_id"] = $virtuemart_product_id;
					$update_data_array["new"] = $was_create ? 1 : 0;

					$product_table_data = $this->productModel->getTable('products');
					$product_table_data->load($virtuemart_product_id);

					$this->joomla_dispatcher_trigger('plgVmBeforeStoreProduct',array(&$update_data_array, &$product_table_data));
				 }catch(Throwable $ps_ex){

				 }
			}

			$p_upd  = array();
			$pl_upd = array();
			$pp_upd = array();

			$mf_update            = false;
			$categories_update    = false;
			$prices_update        = false;
			$shoppergroups_update = false;

			$upd_cfs = array();
			$upd_udf = array();
			$updated_properties = array();

			foreach($update_data as $prop => $record_data){
				$updated_properties[] = $prop;

				if($prop == "_variants" || $prop == "virtuemart_product_id" || $prop == "price_id")
					continue;

				if(strpos($prop,"cfield_") === 0){
					$upd_cfs[] = $prop;
					continue;
				}

				if(strpos($prop,"udf_") === 0){
					$upd_udf[$prop] = $record_data;
					continue;
				}

				if($prop == "virtuemart_manufacturer_id"){
					$mf_update = true;
					continue;
				}

				if($prop == "prices"
						|| strpos($prop,"product_sales_price") === 0
						|| strpos($prop,"product_price") === 0
						|| strpos($prop,"product_override_price") === 0
						|| strpos($prop,"product_currency") === 0
						|| strpos($prop,"product_tax_id") === 0
						|| strpos($prop,"product_discount_id") === 0
						|| strpos($prop,"product_price_publish_down") === 0
						|| strpos($prop,"product_price_publish_up") === 0
						){
					$prices_update = true;
					continue;
				}

				if($prop == "shoppergroups"){
					$shoppergroups_update = true;
					continue;
				}

				if($prop == "categories"){
					$categories_update = true;

					if(is_string($update_data->{$prop})){
						if( strpos(trim($update_data->{$prop}),"[") ===0){
							$update_data->{$prop} = json_decode($update_data->{$prop});
						}else{
							$update_data->{$prop} = explode($this->settings->import_multivalue_separator, $update_data->{$prop} );
						}
					}

					$nval = array();

					if(!empty($update_data->{$prop})){
						foreach($update_data->{$prop} as $I => $item){
							if(!$this->is_intval($update_data->{$prop}[$I])){
								$cat_names   = $this->getCategories("category_name_sanitized",$virtuemart_vendor_id);
								$cat_pathway = $this->getCategories("category_pathway_key",$virtuemart_vendor_id);
								$cat_slugs   = $this->getCategories("slug",$virtuemart_vendor_id);

								$serch_name = str_replace("\\","/",str_replace(" ","",strtolower($update_data->{$prop}[$I])));
								if(isset($cat_names[$serch_name]))
									$nval[] = $cat_names[$serch_name]->virtuemart_category_id;
								else if(isset($cat_pathway[$serch_name]))
									$nval[] = $cat_pathway[$serch_name]->virtuemart_category_id;
								else if(isset($cat_slugs[$serch_name]))
									$nval[] = $cat_slugs[$serch_name]->virtuemart_category_id;
								else if(isset($cat_pathway[ substr($serch_name,1)]))
									$nval[] = $cat_pathway[substr($serch_name,1)]->virtuemart_category_id;
								else{
									$newc_id = $this->createCategoryFromPath($update_data->{$prop}[$I]);
									if($newc_id)
										$nval[] = $newc_id;
								}
							}else if(intval($update_data->{$prop}[$I]))
								$nval[] = intval(trim("".$update_data->{$prop}[$I]));
						}
					}

					$update_data->{$prop} = $nval;
					continue;
				}

				if($prop == "images"){
					$this->updateProductImages($virtuemart_product_id, $update_data->{$prop});

					continue;
				}

				if($prop == "product_currency"){
					if(!$this->is_intval($update_data->{$prop})){
						$qval = $update_data->{$prop};

						$this->db_sqlQuery("SELECT virtuemart_currency_id
											FROM #__virtuemart_currencies
											WHERE
												currency_code_3 LIKE " . $this->db_quote($qval));
						$update_data->{$prop} = $this->db->loadResult();
					}
				}

				if($prop == "product_discount_id"){
					if(!$this->is_intval($update_data->{$prop})){
						$qval = $update_data->{$prop};
						$this->db_sqlQuery("SELECT virtuemart_calc_id
											FROM #__virtuemart_calcs
											WHERE
											calc_kind LIKE 'DATax'
											AND
											calc_name LIKE " . $this->db_quote($qval));
						$update_data->{$prop} = $this->db->loadResult();
					}
				}

				if($prop == "product_tax_id"){
					if(!$this->is_intval($update_data->{$prop})){
						$qval = $update_data->{$prop};
						$this->db_sqlQuery("SELECT virtuemart_calc_id
											FROM #__virtuemart_calcs
											WHERE
											calc_kind LIKE 'VatTax'
											AND
											calc_name LIKE " . $this->db_quote($qval));
						$update_data->{$prop} = $this->db->loadResult();
					}
				}

				if($prop == "product_params"){
					$pp_val = "";

					if(!empty($record_data)){
						foreach($record_data as $ppkey => $ppval){
							if(!$ppval->name)
								continue;
							if(!$ppval->value)
								$ppval->value = "null";
							if($pp_val)
								$pp_val .= "|";
							$pp_val .= (trim($ppval->name)."=".trim($ppval->value));
						}
					}

					$update_data->{$prop} = $pp_val;
				}

				if(isset($this->tbl["#__virtuemart_products"][$prop])){
					$type = $this->tbl["#__virtuemart_products"][$prop]->Type;

					if(is_object($update_data->{$prop}) || is_array($update_data->{$prop})){
						$update_data->{$prop} = json_decode($update_data->{$prop});
					}

					if(stripos($type,"int(") !== false){
						if(stripos($update_data->{$prop},"false") !== false)
							$update_data->{$prop} = 0;
						else if(stripos($update_data->{$prop},"true") !== false)
							$update_data->{$prop} = 1;

						$p_upd[] = (" p.$prop = " . $this->db_quote($update_data->{$prop}) . " ");
					}else if(stripos($type,"date") !== false){
						$p_upd[] = (" p.$prop = " . $this->db_quote($update_data->{$prop}) . " ");
					}else{
						$p_upd[] = (" p.$prop = " . $this->db_quote($update_data->{$prop}) . " ");
					}
				}

				if(isset($this->tbl["#__virtuemart_products_" . $this->db_lng_suffix][$prop])){
					$type = $this->tbl["#__virtuemart_products_" . $this->db_lng_suffix][$prop]->Type;

					if(is_object($update_data->{$prop}) || is_array($update_data->{$prop})){
						$update_data->{$prop} = json_decode($update_data->{$prop});
					}

					if(stripos($type,"int(") !== false){
						if(stripos($update_data->{$prop},"false") !== false)
							$update_data->{$prop} = 0;
						else if(stripos($update_data->{$prop},"true") !== false)
							$update_data->{$prop} = 1;

						$pl_upd[] = (" pl.$prop = " . $this->db_quote($update_data->{$prop}) . " ");
					}else if(stripos($type,"date") !== false){
						$pl_upd[] = (" pl.$prop = " . $this->db_quote($update_data->{$prop}) . " ");
					}else{
						$pl_upd[] = (" pl.$prop = " . $this->db_quote($update_data->{$prop}) . " ");
					}
				}
				
				/*
				if(isset($this->tbl["#__virtuemart_product_prices"][$prop])){
					$type = $this->tbl["#__virtuemart_product_prices"][$prop]->Type;

					if(is_object($update_data->{$prop}) || is_array($update_data->{$prop})){
						$update_data->{$prop} = json_decode($update_data->{$prop});
					}

					if(stripos($type,"int(") !== false){
						if(stripos($update_data->{$prop},"false") !== false)
							$update_data->{$prop} = 0;
						else if(stripos($update_data->{$prop},"true") !== false)
							$update_data->{$prop} = 1;
						$pp_upd[] = (" pp.$prop = " . $this->db_quote($update_data->{$prop}) . " ");
					}else if(stripos($type,"date") !== false){
						$pp_upd[] = (" pp.$prop = " . $this->db_quote($update_data->{$prop}) . " ");
					}else{
						$pp_upd[] = (" pp.$prop = " . $this->db_quote($update_data->{$prop}) . " ");
					}
				}
				*/


			}

			$upd_prop = array_merge($p_upd, $pl_upd, $pp_upd);
			$price_id = 0;
			if(isset($update_data->price_id)){
				$price_id = $update_data->price_id;
				if(!$this->is_intval($price_id)){
					$price_id = 0;
				}
			}

			$bind_price_condition = $price_id ?
									" pp.virtuemart_product_id = p.virtuemart_product_id AND pp.virtuemart_product_price_id = {$price_id} " :
									(" pp.virtuemart_product_id = p.virtuemart_product_id AND (coalesce( pp.price_quantity_start,0) + coalesce(pp.price_quantity_end,0) = 0) AND (NOT coalesce(pp.virtuemart_shoppergroup_id,0) > 0 OR coalesce(pp.virtuemart_shoppergroup_id,0) = " . $this->default_shopper_group_id . ") ");

			//FIRST UPDATE GO
			if(count($upd_prop)){

				$u_query = "UPDATE
						   #__virtuemart_products as p
						LEFT JOIN
						   #__virtuemart_product_prices as pp on {$bind_price_condition}
						LEFT JOIN
						   #__virtuemart_products_". $this->db_lng_suffix ." as pl on pl.virtuemart_product_id = p.virtuemart_product_id
						SET

						  ". implode(",",$upd_prop) ."
						  ,p.modified_on  = NOW()
						  ,pp.modified_on = NOW()
						WHERE p.virtuemart_product_id = $virtuemart_product_id;";

				$this->db_sqlQuery($u_query);
				$this->db_query();
				$upd_prop = array();
			}

			if(!empty($upd_cfs)){
				$this->loadTableDefinition("#__virtuemart_product_customfields");

				if(!isset($this->virtuemart_customs)){
					$this->loadCustomfieldsDefinitions();
				}

				$upd_cfs_count = count($upd_cfs);
				for($iCF =0 ; $iCF < $upd_cfs_count;$iCF++){
					$ucf = $upd_cfs[$iCF];

					$virtuemart_custom_id = null;
					if(!isset($this->virtuemart_customs_by_prop[$ucf])){
						$maybe_by_id  = str_ireplace("cfield_","",$ucf);
						if(is_numeric($maybe_by_id)){
							if(isset($this->virtuemart_customs[$maybe_by_id])){
								$virtuemart_custom_id = $this->virtuemart_customs[$maybe_by_id]->virtuemart_custom_id;
							}
						}
					}else
						$virtuemart_custom_id = $this->virtuemart_customs_by_prop[$ucf]->virtuemart_custom_id;

					if(!$virtuemart_custom_id)
						continue;

					$cf_type   = $this->virtuemart_customs[$virtuemart_custom_id]->field_type;

					$cf_values = array();

					if(!$update_data->{$ucf})
						$update_data->{$ucf} = array();

					foreach($update_data->{$ucf} as $pcf){
						if(!isset($pcf->price))
							$pcf->price = null;

						$cf_values[] = $pcf->value;
					}

					$this->db_sqlQuery("SELECT * FROM #__virtuemart_product_customfields
										WHERE
										virtuemart_product_id     = $virtuemart_product_id
										AND
										virtuemart_custom_id      = $virtuemart_custom_id
										ORDER BY ordering,virtuemart_custom_id;");

					$current = $this->db->loadObjectList();
					$maxitems = count($current) > count($update_data->{$ucf}) ?  count($current) : count($update_data->{$ucf});


					//OVO NE VALJA
					for($I = 0; $I < $maxitems; $I++){

						if(isset($current[$I]) && isset($update_data->{$ucf}[$I])){

							$set_param = null;
							if(isset($update_data->{$ucf}[$I]->set_param)){
								$set_param = $update_data->{$ucf}[$I]->set_param;
							}

							//UPDATE
							if(
								$current[$I]->{$this->custom_field_value_name} != $update_data->{$ucf}[$I]->value
								||
								$current[$I]->{$this->custom_field_price_name} != $update_data->{$ucf}[$I]->price
								||
							    ($set_param && $current[$I]->{$this->custom_field_param_name} != $set_param)
								||
								$current[$I]->ordering != $I + 1
							){
								//UPDATE
								$order = $I + 1;
								$this->db_sqlQuery("
								    UPDATE
										#__virtuemart_product_customfields as pcf
									LEFT JOIN
										#__virtuemart_products as p on p.virtuemart_product_id = pcf.virtuemart_product_id
									SET
									    pcf.{$this->custom_field_value_name} = ". $this->db_quote($update_data->{$ucf}[$I]->value) .",
									    pcf.{$this->custom_field_price_name} = ". $this->db_quote($update_data->{$ucf}[$I]->price) .",
										".
										(isset($set_param) ?
										(" pcf.{$this->custom_field_param_name} = " . $this->db_quote($set_param) . "," )
										:
										""
										)
										."
									    pcf.ordering                 = $order,
									    pcf.modified_on              = NOW(),
										p.modified_on                = NOW()
									WHERE
									   virtuemart_customfield_id = ". $current[$I]->virtuemart_customfield_id);

								$this->db_query();
							}
						}else if(!isset($current[$I]) && isset($update_data->{$ucf}[$I])){
							$set_param = null;
							if(isset($update_data->{$ucf}[$I]->set_param)){
								$set_param = $update_data->{$ucf}[$I]->set_param;
							}
							
							$set_param_c = "";
							$set_param_v = "";
							
							if($set_param){
								$set_param_c = ", {$this->custom_field_param_name}";
								$set_param_v = ", " . $this->db_quote($set_param);
							}
							
							//INSERT
							$order = $I + 1;
							$this->db_sqlQuery("INSERT INTO #__virtuemart_product_customfields(
												virtuemart_product_id, virtuemart_custom_id, {$this->custom_field_value_name} ,{$this->custom_field_price_name},ordering {$set_param_c})
												VALUES ({$virtuemart_product_id},{$virtuemart_custom_id},". $this->db_quote($update_data->{$ucf}[$I]->value) .",". $this->db_quote($update_data->{$ucf}[$I]->price) .", {$order} {$set_param_v})");
							$this->db_query();
						}else if(isset($current[$I]) && !isset($update_data->{$ucf}[$I])){
							//DELETE
							$this->db_sqlQuery("DELETE FROM #__virtuemart_product_customfields
												WHERE
												virtuemart_customfield_id = ". $current[$I]->virtuemart_customfield_id);
							$this->db_query();
						}
					}

					if($cf_type == 'G'){
						if(empty($update_data->{$ucf})){
							//DELETE
							$ch_cf = array();

							foreach($this->virtuemart_customs as $cf){
								if($cf->custom_parent_id == $virtuemart_custom_id){
									$ch_cf[] = $cf->virtuemart_custom_id;
								}
							}

							if(!empty($ch_cf)){
								$this->db_sqlQuery("DELETE FROM #__virtuemart_product_customfields
												WHERE
													virtuemart_product_id = $virtuemart_product_id
												AND
													virtuemart_custom_id IN (".implode(",",$ch_cf ).")");
								$this->db_query();
							}
						}else{
							foreach($this->virtuemart_customs as $cf){
								if($cf->custom_parent_id == $virtuemart_custom_id){
									if(!in_array($cf->property_name,$upd_cfs)){
										if(!in_array("cfield_" . $cf->virtuemart_custom_id,$upd_cfs)){
											$upd_cfs[] = $cf->property_name;
											$upd_cfs_count++;
											$update_data->{$cf->property_name} = array();
											$pcfv = new stdClass;
											$pcfv->price = 0;
											$pcfv->value = '';

											if($cf->custom_value){
												$cval = str_replace("\n",";",$cf->custom_value);
												$cval = str_replace("\r",";",$cval);
												$cval = str_replace(array(";;",";;"),array(";",";"),$cval);
												$cval = explode(";",$cf->custom_value);
												$cval = $cval[0];
												$cval = explode(":",$cval);
												$pcfv->value = $cval[0];
												if(isset($cval[1])){
													$pcfv->price = floatval($cval[1]);
												}
											}

											$update_data->{$cf->property_name}[] = $pcfv;
										}
									}
								}
							}
						}
					}else if($cf_type == 'E'){
						//PLUGIN


					}else if($cf_type == "R"){
						$current_rids = array();

						foreach($current as $cur){
							$current_rids[]  = $cur->{$this->custom_field_value_name};
							if(!in_array($cur->{$this->custom_field_value_name},$cf_values)){
								//REMOVE RELATION FROM OTHER PRODUCT

								$this->db_sqlQuery("DELETE pcf
													FROM
													#__virtuemart_product_customfields as pcf
													LEFT JOIN
													#__virtuemart_customs as cf on cf.virtuemart_custom_id = pcf.virtuemart_custom_id
													WHERE
													cf.field_type = 'R'
													AND
													pcf.{$this->custom_field_value_name} = $virtuemart_product_id
													AND
													pcf.virtuemart_product_id = ". $cur->{$this->custom_field_value_name});
								$this->db_query();

								if(!isset($updates_additional_ids[$cur->{$this->custom_field_value_name}]))
										$updates_additional_ids[$cur->{$this->custom_field_value_name}] = true;



							}
						}

						foreach($cf_values as $rprid){
							if(!in_array($rprid,$current_rids)){
								//ADD RELATION TO OTHER PRODUCT
								$this->db_sqlQuery("SELECT pcf.*
													FROM
													#__virtuemart_product_customfields as pcf
													LEFT JOIN
													#__virtuemart_customs as cf on cf.virtuemart_custom_id = pcf.virtuemart_custom_id
													WHERE
													cf.field_type = 'R'
													AND
													pcf.{$this->custom_field_value_name} = $virtuemart_product_id
													AND
													pcf.virtuemart_product_id = $rprid");

								if(!$this->db->loadResult()){

									$this->db_sqlQuery("INSERT INTO #__virtuemart_product_customfields(
												virtuemart_product_id, virtuemart_custom_id, {$this->custom_field_value_name} ,{$this->custom_field_price_name},ordering)
												VALUES ($rprid,$virtuemart_custom_id,$virtuemart_product_id,NULL, $order)");
									$this->db_query();

									if(!isset($updates_additional_ids[$rprid]))
										$updates_additional_ids[$rprid] = true;
								}
							}
						}
					}
				}
			}

			//RELATED P
			//RELATED C
			//CF
			//CAT
			//Manufacturer

			if($mf_update){
				$prop = "virtuemart_manufacturer_id";

				//$virtuemart_manufacturer_id = $update_data->{$prop};

				$mfs_val = $update_data->{$prop};
				if(!is_array($mfs_val)){
					$mfs_val = array($mfs_val);
				}

				$mfs_val_final = array();

				foreach($mfs_val as $virtuemart_manufacturer_id){
					if($virtuemart_manufacturer_id){

						if(!$this->is_intval($virtuemart_manufacturer_id)){
							$lngs = $this->getDBLanguages();
							$man = null;

							foreach($lngs as $lng){
								$mf_slug = str_replace(array(' ','"',"'",",","."),array('','','','',''),strtolower($virtuemart_manufacturer_id));
								
								$this->db_sqlQuery("SELECT * FROM #__virtuemart_manufacturers_$lng 
													WHERE 
														mf_name LIKE ".$this->db_quote($virtuemart_manufacturer_id)." 
													OR 
														slug LIKE ".$this->db_quote($mf_slug)."");
								$man = $this->db->loadObject();
								if($man)
									break;
							}

							if($man){
								$virtuemart_manufacturer_id = $man->virtuemart_manufacturer_id;
							}else{
								$mf_name = $virtuemart_manufacturer_id;
								$this->db_sqlQuery("INSERT INTO #__virtuemart_manufacturers(
													   virtuemart_manufacturer_id
													  ,virtuemart_manufacturercategories_id
													  ,metarobot
													  ,metaauthor
													  ,hits
													  ,published
													  ,created_on
													  ,created_by
													  ,modified_on
													  ,modified_by
													  ,locked_on
													  ,locked_by
													) VALUES (
													   NULL
													  ,0
													  ,''
													  ,''
													  ,0
													  ,1
													  ,NOW()
													  ,{$this->user_id}
													  ,NOW()
													  ,{$this->user_id}
													  ,'0000-00-00'
													  ,0
													)");
								$this->db_query();

								$virtuemart_manufacturer_id = $this->db->insertid();

								$mf_slug = str_replace(array(' ','"',"'",",","."),array('','','','',''),strtolower($mf_name));

								if($virtuemart_manufacturer_id){

									foreach($lngs as $lng){
										$this->db_sqlQuery("INSERT INTO #__virtuemart_manufacturers_$lng(
															   virtuemart_manufacturer_id
															  ,mf_name
															  ,mf_email
															  ,mf_desc
															  ,mf_url
															  ,metadesc
															  ,metakey
															  ,customtitle
															  ,slug
															) VALUES (
															   $virtuemart_manufacturer_id
															  ," . $this->db_quote($mf_name) . "
															  ,''
															  ,''
															  ,''
															  ," . $this->db_quote($mf_name) . "
															  ," . $this->db_quote($mf_name) . "
															  ,''
															  ," . $this->db_quote($mf_slug) . "
															)");

										$this->db_query();
										if($lng == $this->db_lng_suffix){
											global $added_aux;
											if(!isset($added_aux))
												$added_aux = new stdClass;

											if(!isset($added_aux->manufacturers))
												$added_aux->manufacturers = array();

											$added_aux->manufacturers[$virtuemart_manufacturer_id] = array("virtuemart_manufacturer_id" => $virtuemart_manufacturer_id, "mf_name" => $mf_name);
										}
									}
								}
							}
						}
						$mfs_val_final[] = $virtuemart_manufacturer_id;
					}
				}

				if(empty($mfs_val_final))
					$this->db_sqlQuery("DELETE FROM #__virtuemart_product_manufacturers WHERE virtuemart_product_id = $virtuemart_product_id");
				else
					$this->db_sqlQuery("DELETE FROM #__virtuemart_product_manufacturers WHERE virtuemart_product_id = $virtuemart_product_id AND NOT virtuemart_manufacturer_id IN(".implode(",",$mfs_val_final).")");

				$this->db_query();

				if(!empty($mfs_val_final)){
					$this->db_sqlQuery("INSERT INTO #__virtuemart_product_manufacturers(id ,virtuemart_product_id,virtuemart_manufacturer_id)
										SELECT
											NULL,
											$virtuemart_product_id,
											virtuemart_manufacturer_id
											FROM
											#__virtuemart_manufacturers
											WHERE
											virtuemart_manufacturer_id IN (".implode(",",$mfs_val_final).")
											AND
											NOT virtuemart_manufacturer_id IN (SELECT virtuemart_manufacturer_id FROM `#__virtuemart_product_manufacturers` WHERE virtuemart_product_id = $virtuemart_product_id)");
					$this->db_query();
				}

				if(isset($this->tbl["#__virtuemart_products"]["has_manufacturers"]))
					$upd_prop[] = (" p.has_manufacturers = " . (!empty($mfs_val_final) ? "1" : "0") . " ");
			}

			if($categories_update){
				$sql_cats = implode(",", $update_data->categories);
				if(empty($update_data->categories))
					$sql_cats = "-1";
				$this->db_query("DELETE FROM #__virtuemart_product_categories WHERE virtuemart_product_id = $virtuemart_product_id AND NOT virtuemart_category_id in ( $sql_cats )");

				$this->db_sqlQuery("SELECT virtuemart_category_id FROM #__virtuemart_product_categories WHERE virtuemart_product_id = $virtuemart_product_id");
  			    $cur_cats = $this->db->loadColumn();

				foreach($update_data->categories as $catid){
					if(!in_array($catid,$cur_cats)){
						$this->db_query("INSERT INTO #__virtuemart_product_categories(id ,virtuemart_product_id ,virtuemart_category_id  ,ordering)
										 VALUES(NULL,$virtuemart_product_id,$catid,0);");
					}
				}

				if(isset($this->tbl["#__virtuemart_products"]["has_categories"]))
					$upd_prop[] = (" p.has_categories = " . (!empty($update_data->categories) ? "1" : "0") . " ");
			}

			if($shoppergroups_update){
				$sql_sgroups = implode(",", $update_data->shoppergroups);
				if(empty($update_data->shoppergroups))
					$sql_sgroups = "-1";
				$this->db_query("DELETE FROM #__virtuemart_product_shoppergroups WHERE virtuemart_product_id = {$virtuemart_product_id} AND NOT virtuemart_shoppergroup_id in ( {$sql_sgroups} )");

				$this->db_sqlQuery("SELECT virtuemart_shoppergroup_id FROM #__virtuemart_product_shoppergroups WHERE virtuemart_product_id = {$virtuemart_product_id}");
  			    $cur_sgroups = $this->db->loadColumn();

				foreach($update_data->shoppergroups as $sgid){
					if(!in_array($sgid,$cur_sgroups)){
						$this->db_query("INSERT INTO #__virtuemart_product_shoppergroups(id ,virtuemart_product_id ,virtuemart_shoppergroup_id)
										 VALUES(NULL,{$virtuemart_product_id},{$sgid});");
					}
				}

				if(isset($this->tbl["#__virtuemart_products"]["has_shoppergroups"]))
					$upd_prop[] = (" p.has_shoppergroups = " . (!empty($update_data->shoppergroups) ? "1" : "0") . " ");
			}

			if($prices_update){

				if(!isset($update_data->prices)){
					$update_data->prices = $this->extractPricesFromProductData($virtuemart_product_id, $update_data, $was_create);
				}

				$existing_ids   = array();
				$new_prices = array();
				$existing_prices = array();

				foreach($update_data->prices as $price_id => $price){
					if(isset($price->virtuemart_product_price_id)){
						if(!$this->is_intval($price->virtuemart_product_price_id)){
							$new_prices[]   = $price;
							continue;
						}
						$existing_ids[] = $price->virtuemart_product_price_id;
						$existing_prices[] = $price;
					}else
						$new_prices[]   = $price;

				}

				$s_existing_ids = implode(",",$existing_ids);
				if(!$s_existing_ids)
					$s_existing_ids = -1;

				$this->db_query("DELETE FROM #__virtuemart_product_prices WHERE virtuemart_product_id = {$virtuemart_product_id} AND NOT virtuemart_product_price_id in ( {$s_existing_ids} )");

				foreach($existing_prices as $price){
					$this->updatePrice($virtuemart_product_id, $price);
				}

				foreach($new_prices as $price){
					$this->addPrice($virtuemart_product_id, $price);
				}

				if(isset($this->tbl["#__virtuemart_products"]["has_prices"]))
					$upd_prop[] = (" p.has_prices = " . (!empty($update_data->prices) ? "1" : "0") . " ");
			}

			if(property_exists($update_data, "product_sales_price")){
				$pp = NULL;
				if(floatval($update_data->product_sales_price) > 0 || $update_data->product_sales_price == "0"){
					ob_start();
					$pdata = array();
					$pdata["salesPrice"]        = $update_data->product_sales_price;
					$pp = $this->calculator->calculateCostprice ($virtuemart_product_id, $pdata);
					ob_end_clean();
				}
				$upd_prop[] = (" pp.product_price = " . $this->db_quote($pp) . " ");
			}

			//SECOND UPDATE GO
			if(count($upd_prop)){
				$u_query = "UPDATE
						   #__virtuemart_products as p
						LEFT JOIN
						   #__virtuemart_product_prices as pp on {$bind_price_condition}
						LEFT JOIN
						   #__virtuemart_products_". $this->db_lng_suffix ." as pl on pl.virtuemart_product_id = p.virtuemart_product_id
						SET

						  ". implode(",",$upd_prop) ."
						  ,p.modified_on = NOW()
						  ,pp.modified_on = NOW()
						WHERE p.virtuemart_product_id = $virtuemart_product_id;";

				$this->db_sqlQuery($u_query);
				$this->db_query();
				$upd_prop = array();
			}

			//READ FRESH DB FROM DB AND POP-UP RETURN OBJECT
			
			$updated = $this->getProduct($virtuemart_product_id, true);

			foreach($updated as $key => $val){
				$update_data->{$key} = $val;
			}

			if(count($upd_udf)){
				if(isset($this->settings)){
					
					$udf_settings_prop = "udf_settings";
					if($this->datascope == "b2b"){
						$udf_settings_prop = "udf_settings_products";
					}
					
					$udf_updated = false;
					if(isset($this->settings->{$udf_settings_prop})){
						if(count($this->settings->{$udf_settings_prop})){
							foreach($this->settings->{$udf_settings_prop} as $udf){
								if(isset($udf->udf_update)){
									if($udf->udf_update){
										if(array_key_exists($udf->udf_name, $upd_udf)){
											$this->udfEntityUpdate($update_data,$udf,$upd_udf[$udf->udf_name],$updated);
											$udf_updated = true;
										}
									}
								}
							}
						}
					}
					if($udf_updated){
						$updated = $this->getProduct($virtuemart_product_id, true);
						foreach($updated as $key => $val){
							$update_data->{$key} = $val;
						}
					}
				}
			}
			
			$db_triggers_setting_name = "db_triggers_settings";
			if($this->datascope == "b2b"){
				$db_triggers_setting_name = "db_triggers_settings_products";
			}

			$db_triggered = false;
			if(isset($this->settings->{$db_triggers_setting_name})){
				if(!empty($this->settings->{$db_triggers_setting_name})){
					foreach($this->settings->{$db_triggers_setting_name} as $trg){
						if(!$trg->dbtrigg_enabled)
							continue;

						$props = explode(",",$trg->dbtrigg_trigger_on);
						$exec_on_prop = null;

						foreach($props as $prop){

							if(strpos($prop,"product_price") !== false){
								$prop = "prices";
							}else if(strpos($prop,"product_sales_price") !== false){
								$prop = "prices";
							}else if(strpos($prop,"product_override_price") !== false){
								$prop = "prices";
							}

							if(in_array($prop,$updated_properties)){
								$exec_on_prop = $prop;
								break;
							}
						}

						if($exec_on_prop){
							try{
								if($trg->dbtrigg_query){
									$this->paramSQL($update_data, $trg->dbtrigg_query, $update_data->{$exec_on_prop});
									$db_triggered = true;
								}
							}catch(Throwable $ex){
								//
							}
						}
					}
				}
			}

			if($db_triggered){
				if(!$updated)
					$updated = $this->getProduct($virtuemart_product_id, true);
				
				foreach($updated as $key => $val){
					$update_data->{$key} = $val;
				}
			}

			if(isset($update_data->_variants)){
				foreach($update_data->_variants as $var_id => $var_data){
					$update_data->_variants->{$var_id} = $this->updateProduct($var_data,$updates_additional_ids,$virtuemart_product_id);
				}
			}

			if($do_triggers){
				 try{
				    $product_table_data->load($virtuemart_product_id);
					$this->joomla_dispatcher_trigger('plgVmAfterStoreProduct',array(&$update_data_array, &$product_table_data));
				 }catch(Throwable $ps_ex){

				 }
			}

			return $update_data;

		}catch(Throwable $ex){
			$err_id = $virtuemart_product_id;

			if(!$err_id)
				$err_id = "noid_".rand(1,999999);

			$scerr[$err_id]   = $ex->getMessage();
			return $update_data;
		}
	}

	function initJoomlaDispatcher(){
		try{
			if(!isset($this->joomla_dispatcher)){
				if(method_exists("VmConfig","importVMPlugins")){
					
					VmConfig::importVMPlugins('vmcustom');
					VmConfig::importVMPlugins('vmpayment');
					VmConfig::importVMPlugins('vmshipment');
					
					if(defined('JVERSION')){
						if(intval(substr(JVERSION,0,1)) > 3){//J4+
							$this->joomla_dispatcher = Joomla\CMS\Factory::getApplication()->getDispatcher();
							return;
						}
					}
					//OLD:	
					$this->joomla_dispatcher = JDispatcher::getInstance ();
				}else
				   $this->joomla_dispatcher = false;
			}
		}catch(Throwable $ex){
			//
		}
	}

	function joomla_dispatcher_trigger($event_name, $data){
		try{
			if($this->joomla_dispatcher){
				if(defined('JVERSION')){
					if(intval(substr(JVERSION,0,1)) > 3){//J4+
						Joomla\CMS\Factory::getApplication()->triggerEvent($event_name, $data);
						return;
					}
				}
				//OLD:	
				$this->joomla_dispatcher->trigger($event_name, $data);
			}
		}catch(Throwable $ex){
			//
		}
	}

	function delete_product($data,&$err){
		global $scerr;
		
		if(!SCvmAccess::manager('product.edit') && $this->datascope != "b2b"){
			$scerr[0]           = "The account you use to access site is not permitted to edit products!";
			return null;
		}

		$tables = array();

		$tables[] = '#__virtuemart_product_categories';
		$tables[] = '#__virtuemart_product_customfields';
		if(SC_VM_RUNV < 3)
			$tables[] = '#__virtuemart_product_downloads';
		$tables[] = '#__virtuemart_product_manufacturers';
		$tables[] = '#__virtuemart_product_medias';
		$tables[] = '#__virtuemart_product_prices';
		if(SC_VM_RUNV < 3)
			$tables[] = '#__virtuemart_product_relations';
		$tables[] = '#__virtuemart_product_shoppergroups';
		$tables[] = '#__virtuemart_products';
		$lngs = $this->getDBLanguages();
		foreach($lngs as $db_lng_suffix)
			$tables[] = ("#__virtuemart_products_{$db_lng_suffix}");

		if(isset($data->products)){

			$this->initJoomlaDispatcher();

			$ok = true;

			for($i =0; $i < count($data->products);$i++){
				if(isset($data->products[$i]->virtuemart_product_id)){
					$virtuemart_product_id = $data->products[$i]->virtuemart_product_id;
					foreach($tables as $ind => $tbl){
						$this->db_sqlQuery("DELETE FROM $tbl WHERE virtuemart_product_id = {$virtuemart_product_id}");
						$this->db->execute();
					}
					$data->products[$i]->deleted = 1;
					try{
						$this->joomla_dispatcher_trigger('plgVmOnDeleteProduct', array($virtuemart_product_id, &$ok));
					}catch(Throwable $Ex){
						//
					}
				}
			}
		}
		return $data;
	}

	function get_event_log($data,&$err){
		try{
			$type_scope = "";
			if(isset($data->events_type)){
				if($data->events_type){
					$type_scope = " AND `event` LIKE '%{$data->events_type}%' ";
				}
			}
			if(isset($data->events_after)){
				$this->db_sqlQuery("SELECT * FROM #__sellingcommander_vm_event_log WHERE created_on > " . $this->db_quote($data->events_after) . $type_scope);
			}else{
				$this->db_sqlQuery("SELECT * FROM #__sellingcommander_vm_event_log WHERE 1".$type_scope);
			}
			$data->events = $this->db->loadObjectList();
		}catch(Throwable $Ex){
			//
		}
		return $data;
	}

	function delete_orders($data,&$err){
		global $scerr;
		if(!SCvmAccess::manager('orders.edit') && $this->datascope != "b2b"){
			$scerr[0]           = "The account you use to access site is not permitted to edit orders!";
			return null;
		}

		$tables = array();

		$tables[] = '#__virtuemart_product_customfields';
		$tables[] = '#__virtuemart_order_item_histories';
		$tables[] = '#__virtuemart_order_histories';
		$tables[] = '#__virtuemart_order_userinfos';
		$tables[] = '#__virtuemart_order_calc_rules';
		$tables[] = '#__virtuemart_order_items';
		$tables[] = '#__virtuemart_orders';

		if(isset($data->orders)){
			for($i =0; $i < count($data->orders);$i++){
				if(isset($data->orders[$i]->virtuemart_order_id)){
					$virtuemart_order_id = $data->orders[$i]->virtuemart_order_id;
					foreach($tables as $ind => $tbl){

						if($tbl == "#__virtuemart_product_customfields")
							$this->db_sqlQuery("DELETE FROM $tbl WHERE virtuemart_product_id = -{$virtuemart_order_id}");
						else
							$this->db_sqlQuery("DELETE FROM $tbl WHERE virtuemart_order_id = {$virtuemart_order_id}");
						$this->db->execute();
					}
					$data->orders[$i]->deleted = 1;
				}
			}
		}
		return $data;
	}

	function update_media($data,&$err){
		global $scerr;
		if(!SCvmAccess::manager('product.edit') && $this->datascope != "b2b"){
			$scerr[0]           = "The account you use to access site is not permitted to edit products!";
			return null;
		}
		
		$this->prepareSessionForUpdateTask();

		if(isset($data->medias)){
			$affected_medias = array();

			for($I = 0; $I < count($data->medias); $I++){
				$data->medias[$I] = $this->update_media($data->medias[$I],$err);
				if(isset($data->medias[$I]->affected_medias)){
					foreach($data->medias[$I]->affected_medias as $key => $val){
						$affected_medias[$key] = $val;
					}
					unset($data->medias[$I]->affected_medias);
				}
			}

			$data->affected_medias = $affected_medias;
			return $data;
		}

		try{

			if(isset($data->filename)){
				$data->filename = trim(str_ireplace(array(" ","/"),array("-","-"),$data->filename));
			}

			$imgpath = JPATH_SITE. DIRECTORY_SEPARATOR . $this->media_product_path . DIRECTORY_SEPARATOR;

			if(isset($data->data)){

				$dind = stripos($data->data, ',');
				$data->data = substr($data->data, $dind + 1);

				$image = imagecreatefromstring(base64_decode($data->data));
				$data->data = false;

				if($image){

					if(stripos($data->type,'png') !== false || stripos($data->type,'gif') !== false){
						imagealphablending($image, false);
						imagesavealpha($image, true);
						$done = imagecolorallocatealpha($image, 255, 255, 255, 127);
					}

					$width  = imagesx($image);
					$height = imagesy($image);

					if(!$data->filename && $data->name){
						$data->filename = $data->name;
						$data->filename = str_ireplace(" ","-",$data->filename);
					}

					if(!$data->filename)
						$data->filename = $data->ref_upload_id . "." . str_ireplace(array("image/","jpeg"),array("","jpg"),$data->type);


					$ext = pathinfo($data->filename, PATHINFO_EXTENSION);
					if(!$ext){
						$ext = str_ireplace(array("image/","jpeg"),array("","jpg"),$data->type);
						$data->filename .= ".{$ext}";
					}

					$p   = pathinfo($data->filename, PATHINFO_FILENAME);

					$diff_n = "";
					$n      = 0;

					while(file_exists($imgpath . "{$p}{$diff_n}.{$ext}")){
						$n++;
						$diff_n = "-{$n}";
					}

					$image_written = false;
					if(stripos($data->type,'jpg') !== false || stripos($data->type,'jpeg') !== false || stripos($data->type,'jpg') !== false){
						$image_written = imagejpeg($image, $imgpath . "$p$diff_n.$ext" );
					}elseif(stripos($data->type,'gif') !== false){
						$image_written = imagegif ($image, $imgpath . "$p$diff_n.$ext");
					}else{
						$image_written = imagepng ($image, $imgpath . "$p$diff_n.$ext");
					}

					if($image_written){
						$data->data          = true;
						$data->corefilename  = $p;
						$data->filename      = "$p$diff_n.$ext";

						$data->image_written_path = $this->media_product_path . DIRECTORY_SEPARATOR . "$p$diff_n.$ext";
						$data->image_written_url  = str_replace("\\", "/", $this->media_product_path . "/$p$diff_n.$ext");

						$twidth  = $this->thumb_width;
						$theight = $this->thumb_height;

						if(!$twidth && $theight){
							$twidth = $theight * ($width/$height);
						}elseif(!$theight && $twidth){
							$theight = $twidth * ($height/$width);
						}elseif(!$theight && !$twidth){
							$twidth  = 220;
							$theight = 220;
						}



						$thumb_image = imagecreatetruecolor($twidth , $theight);

						if(stripos($data->type,'png') !== false  || stripos($data->type,'gif') !== false){
							imagealphablending($thumb_image, false);
							imagesavealpha($thumb_image, true);
							$transparent = imagecolorallocatealpha($thumb_image, 255, 255, 255, 127);
							imagefilledrectangle($thumb_image, 0, 0, $twidth, $theight, $transparent);
						}

						$scale_width  = 0;
						$scale_height = 0;
						$rat_i = $width  / $height;
						$rat_t = $twidth / $theight;

						if($rat_i > $rat_t){
							$scale_width  = $twidth * ( $height /  $theight);
							$scale_height = $height;
						}else{
							$scale_width  = $width;
							$scale_height = $theight * ( $width /  $twidth);
						}

						imagecopyresampled($thumb_image, $image, 0, 0, ($width - $scale_width)/2, ($height - $scale_height)/2, $twidth, $theight, $scale_width, $scale_height);

						$thumb_written = false;
						if(stripos($data->type,'jpg') !== false || stripos($data->type,'jpeg') !== false || stripos($data->type,'jpg') !== false){
							$thumb_written = imagejpeg($thumb_image, $imgpath . "resized" . DIRECTORY_SEPARATOR . "$p$diff_n.$ext" );
						}elseif(stripos($data->type,'gif') !== false){
							$thumb_written = imagegif ($thumb_image, $imgpath . "resized" . DIRECTORY_SEPARATOR . "$p$diff_n.$ext");
						}else{
							$thumb_written = imagepng ($thumb_image, $imgpath . "resized" . DIRECTORY_SEPARATOR . "$p$diff_n.$ext");
						}

						if($thumb_written){
							$data->thumb_written_path = $this->media_product_path . DIRECTORY_SEPARATOR . "resized" . DIRECTORY_SEPARATOR . "$p$diff_n.$ext";
							$data->thumb_written_url  = str_replace("\\", "/", $this->media_product_path . "/resized/$p$diff_n.$ext");
						}
					}
				}
			}else if(property_exists($data,'data')){
				$data->image_written_path = "";
				$data->image_written_url  = "";
				$data->thumb_written_path = "";
				$data->thumb_written_url  = "";
				$data->corefilename       = "";
				if(isset($data->media_object)){
					$data->media_object->file_url       = "";
					$data->media_object->file_url_thumb = "";
				}

			}else if(isset($data->existing_file)){

				if(file_exists($imgpath . $data->existing_file)){

					$data->thumb_written_path = $this->media_product_path . DIRECTORY_SEPARATOR . "resized" . DIRECTORY_SEPARATOR . $data->existing_file;
					$data->thumb_written_url  = str_replace("\\", "/", $this->media_product_path . "/resized/" . $data->existing_file);
					$data->image_written_path = $this->media_product_path . DIRECTORY_SEPARATOR . $data->existing_file;
					$data->image_written_url  = str_replace("\\", "/", $this->media_product_path . "/" . $data->existing_file);

					if(!file_exists($imgpath . "resized" . $data->existing_file)){

						$image  = null;
						$alpha  = false;
						$format = "";


						if(stripos($data->existing_file,".jpg") !== false || stripos($data->existing_file,".jpeg") !== false){
							$image = @imagecreatefromjpeg($imgpath . $data->existing_file);
							$format = "jpg";
						}else {
							$alpha = true;
							if(stripos($data->existing_file,".png") !== false){
								$image = @imagecreatefrompng($imgpath . $data->existing_file);
								$format = "png";
							}else if(stripos($data->existing_file,".gif") !== false){
								$image = @imagecreatefromgif($imgpath . $data->existing_file);
								$format = "gif";
							}
							if($image){
								imagealphablending($image, false);
								imagesavealpha($image, true);
								imagecolorallocatealpha($image, 255, 255, 255, 127);
							}
						}

						if($image){
							$width  = imagesx($image);
							$height = imagesy($image);

							$twidth  = $this->thumb_width;
							$theight = $this->thumb_height;

							if(!$twidth && $theight){
								$twidth = $theight * ($width/$height);
							}elseif(!$theight && $twidth){
								$theight = $twidth * ($height/$width);
							}elseif(!$theight && !$twidth){
								$twidth  = 220;
								$theight = 220;
							}

							$thumb_image = imagecreatetruecolor($twidth , $theight);

							if($alpha){
								imagealphablending($thumb_image, false);
								imagesavealpha($thumb_image, true);
								$transparent = imagecolorallocatealpha($thumb_image, 255, 255, 255, 127);
								imagefilledrectangle($thumb_image, 0, 0, $twidth, $theight, $transparent);
							}

							$scale_width  = 0;
							$scale_height = 0;
							$rat_i = $width  / $height;
							$rat_t = $twidth / $theight;

							if($rat_i > $rat_t){
								$scale_width  = $twidth * ( $height /  $theight);
								$scale_height = $height;
							}else{
								$scale_width  = $width;
								$scale_height = $theight * ( $width /  $twidth);
							}

							imagecopyresampled($thumb_image, $image, 0, 0, ($width - $scale_width)/2, ($height - $scale_height)/2, $twidth, $theight, $scale_width, $scale_height);

							$thumb_written = false;
							if($format == "jpg"){
								$thumb_written = imagejpeg($thumb_image, $imgpath . "resized" . DIRECTORY_SEPARATOR . $data->existing_file);
							}elseif($format == "gif"){
								$thumb_written = imagegif ($thumb_image, $imgpath . "resized" . DIRECTORY_SEPARATOR . $data->existing_file);
							}else{
								$thumb_written = imagepng ($thumb_image, $imgpath . "resized" . DIRECTORY_SEPARATOR . $data->existing_file);
							}
						}
					}

					$data->data               = true;
					$data->filename           = $data->existing_file;
					$data->name               = $data->existing_file;
					$data->type               = mime_content_type($imgpath . $data->existing_file);
					$data->corefilename       = pathinfo($data->existing_file,PATHINFO_FILENAME);

					if(isset($data->media_object)){
						$data->media_object->file_url       = $data->thumb_written_url;
						$data->media_object->file_url_thumb = $data->thumb_written_url;
					}else{
						$this->db_sqlQuery("SELECT * FROM #__virtuemart_medias WHERE file_url LIKE " . $this->db_quote(str_replace("//","/",$this->media_product_path . "/" . $data->existing_file)));
						$media_object = $this->db->loadObject();
						if($media_object){
							$data->media_object = $media_object;
							$data->media_object->file_url       = $data->thumb_written_url;
							$data->media_object->file_url_thumb = $data->thumb_written_url;
						}
					}
				}else{
					$data->image_written_path = "";
					$data->image_written_url  = "";
					$data->thumb_written_path = "";
					$data->thumb_written_url  = "";
					$data->corefilename       = "";
				}
			}

			$create_mo    = false;
			$media_object = null;

			if(!$data->media_object)
				$create_mo = true;
			else if(!$data->media_object->virtuemart_media_id)
				$create_mo = true;
			else{
				$this->db_sqlQuery("SELECT * FROM #__virtuemart_medias WHERE virtuemart_media_id = " . $data->media_object->virtuemart_media_id);
				$media_object = $this->db->loadObject();
				if(!$media_object){
					unset($data->media_object->virtuemart_media_id);
					$create_mo = true;
					$media_object = null;
				}
			}

			if($create_mo){
				$upd = new stdClass;

				//CREATE NEW MEDIA OBJECT


				$upd->user_id   = $this->user_id;
				$upd->published = 1;
				$upd->file_title            = "";
				$upd->file_description      = "";
				$upd->file_meta             = "";
				$upd->file_mimetype         = "";
				$upd->file_url              = "";
				$upd->file_url_thumb        = "";
				$upd->file_is_product_image = 1;

				if($data->media_object){
					foreach($data->media_object as $prop => $val){
						$upd->{$prop} = $val;
					}
				}

				if($data->data){
					//FILE WAS WRITTEN
					$upd->file_url        = $data->image_written_url;
					$upd->file_url_thumb  = $data->thumb_written_url;

					if(!$upd->file_title){
						$upd->file_title = ucwords(str_replace(array("-","_"),array(" "," "),$data->corefilename));
					}

					if(!$upd->file_description){
						$upd->file_description = ucwords(str_replace(array("-","_"),array(" "," "),$data->corefilename));
					}

					if(!$upd->file_mimetype && $data->type){
						$upd->file_mimetype = $data->type;
					}
				}

				$this->db_sqlQuery("INSERT INTO #__virtuemart_medias( virtuemart_media_id,virtuemart_vendor_id,file_title,file_description,file_meta,file_mimetype,file_type,file_url,file_url_thumb,file_lang ,file_is_product_image,file_is_downloadable,file_is_forSale,file_params,shared,published,created_on,created_by,modified_on,modified_by,locked_on,locked_by) VALUES (
								   NULL
								  ,0
								  ,". $this->db_quote($upd->file_title) ."
								  ,". $this->db_quote($upd->file_description) ."
								  ,". $this->db_quote($upd->file_meta) ."
								  ,". $this->db_quote($upd->file_mimetype) ."
								  ,'product'
								  ,". $this->db_quote($upd->file_url) ."
								  ,". $this->db_quote($upd->file_url_thumb) ."
								  ,''
								  ,". $upd->file_is_product_image ."
								  ,0
								  ,0
								  ,''
								  ,0
								  ,". $upd->published ."
								  ,NOW()
								  ,". $upd->user_id ."
								  ,NOW()
								  ,". $upd->user_id ."
								  ,'0000-00-00 00:00:00'
								  ,0
								)");

				$this->db->execute();
				$mid = $this->db->insertid();

				$this->sessionGroupConcat();

				$q = "  SELECT
								m.*,
								concat('[',GROUP_CONCAT(p.virtuemart_product_id),']') As ref_products
							FROM
								#__virtuemart_medias as m
								LEFT JOIN
								#__virtuemart_product_medias as pm on pm.virtuemart_media_id = m.virtuemart_media_id
								LEFT JOIN
								#__virtuemart_products as p on p.virtuemart_product_id = pm.virtuemart_product_id
							WHERE
								m.virtuemart_media_id = $mid
							GROUP BY
								m.virtuemart_media_id
							";

				$this->db_sqlQuery($q);
				$media_object = $this->db->loadObject();
				$data->media_object = $media_object;

			}else{

				if(isset($data->data)){
					if(isset($data->media_object->file_url)){
						if($data->media_object->file_url){
							if( strtolower(trim($data->filename)) != strtolower(trim(basename($data->media_object->file_url)))){
								//DELETE OLD FILE
								$this->db_sqlQuery("SELECT count(*) as fileCount FROM #__virtuemart_medias WHERE file_url LIKE '" . $this->db_quote($data->media_object->file_url) . "'");
								$fcount = $this->db->loadResult();
								if($fcount < 2){
									$path = JPATH_SITE . DIRECTORY_SEPARATOR . str_replace("/", DIRECTORY_SEPARATOR, $data->media_object->file_url);
									if(file_exists($path) && !is_dir($path)){
										unlink($path);
									}
								}

								if($data->media_object->file_url_thumb){
									$this->db_sqlQuery("SELECT count(*) as fileCount FROM #__virtuemart_medias WHERE file_url_thumb LIKE '" . $this->db_quote($data->media_object->file_url_thumb) . "'");
									$fcount = $this->db->loadResult();
									if($fcount < 2){
										$path = JPATH_SITE . DIRECTORY_SEPARATOR . str_replace("/", DIRECTORY_SEPARATOR, $data->media_object->file_url_thumb);
										if(file_exists($path) && !is_dir($path)){
											unlink($path);
										}
									}
								}

							}
						}
					}
				}

				if(isset($data->media_object)){
					if(isset($data->filename) && isset($media_object)){
						if(!isset($data->data) && trim($data->filename) != trim(basename($media_object->file_url))){
							//RENAME FS
							$p = explode(".",$data->filename);

							$ftype = $media_object->file_mimetype;
							$ftype = explode("/",$ftype);
							$ftype = $ftype[count($ftype) - 1];
							$ftype = str_replace("jpeg","jpg",$ftype);

							if(count($p) < 2)
								$p[] = $ftype;

							$ext = array_pop($p);

							$p = implode(".",$p);

							$diff_n = "";
							$n      = 0;

							while(file_exists($imgpath . "$p$diff_n.$ext")){
								if(!$n){
									$p = explode("-",$p);
									if(intval($p[count($p) - 1])){
										$n = intval($p[count($p) - 1]) + 1;
										array_pop($p);
									}
									$p = implode("-",$p);
								}else
									$n++;
								$diff_n = "-$n";
							}


							$old_path = str_replace("/",DIRECTORY_SEPARATOR, JPATH_SITE . DIRECTORY_SEPARATOR . $media_object->file_url);
							$old_thumb_path = str_replace("/",DIRECTORY_SEPARATOR, JPATH_SITE . DIRECTORY_SEPARATOR . $media_object->file_url_thumb);

							if(!file_exists($old_path) || is_dir($old_path))
								$old_path = "";

							if(!file_exists($old_thumb_path) || is_dir($old_thumb_path))
								$old_thumb_path = "";

							$rres = false;

							$new_path = str_replace("/",DIRECTORY_SEPARATOR,$imgpath . "$p$diff_n.$ext");

							if(!$old_path){
								if(file_exists($new_path)){
									$data->media_object->file_url = $this->media_product_path . "/$p$diff_n.$ext";
									$rres = true;
								}
							}else{

								$rres = rename(
										$old_path
										,
										$new_path
									 );


								if($rres){

									$q = "  SELECT
												m.virtuemart_media_id
											FROM
												#__virtuemart_medias as m
											WHERE
												 m.file_url LIKE ".$this->db_quote($media_object->file_url)."
												 AND
												 m.virtuemart_media_id != " . $data->media_object->virtuemart_media_id ."
											GROUP BY
												m.virtuemart_media_id
											";

									$this->db_sqlQuery($q);
									$affeced = $this->db->loadColumn();

									$data->media_object->file_url = $this->media_product_path . "/$p$diff_n.$ext";

									if(!empty($affeced)){
										if(!isset($data->affected_medias))
											$data->affected_medias = array();

										foreach($affeced as $a_m){
											if(!isset($data->affected_medias[$a_m]))
												$data->affected_medias[$a_m] = (' file_url = ' . $this->db_quote($data->media_object->file_url));
											else
												$data->affected_medias[$a_m] .= (', file_url = ' . $this->db_quote($data->media_object->file_url));
										}

									}


								}
							}

							$new_thumb_path = str_replace("/",DIRECTORY_SEPARATOR,$imgpath . DIRECTORY_SEPARATOR . "resized" . DIRECTORY_SEPARATOR . "$p$diff_n.$ext");

							if(!$old_thumb_path){
								if(file_exists($new_thumb_path)){
									$data->media_object->file_url = $this->media_product_path . "/resized/$p$diff_n.$ext";
									$rres = true;
								}
							}else{
								$rres = rename(
										$old_thumb_path
										,
										$new_thumb_path
									 );
								if($rres){


									$q = "  SELECT
												m.virtuemart_media_id
											FROM
												#__virtuemart_medias as m
											WHERE
												 m.file_url_thumb LIKE ".$this->db_quote($media_object->file_url_thumb)."
												 AND
												 m.virtuemart_media_id != " . $data->media_object->virtuemart_media_id ."
											GROUP BY
												m.virtuemart_media_id
											";

									$this->db_sqlQuery($q);
									$affeced = $this->db->loadColumn();

									$data->media_object->file_url_thumb = $this->media_product_path . "/resized/$p$diff_n.$ext";


									if(!empty($affeced)){
										if(!isset($data->affected_medias))
											$data->affected_medias = array();

										foreach($affeced as $a_m){
											$data->affected_medias[$a_m] = 1;
										}

										foreach($affeced as $a_m){
											if(!isset($data->affected_medias[$a_m]))
												$data->affected_medias[$a_m] = (' file_url_thumb = ' . $this->db_quote($data->media_object->file_url_thumb));
											else
												$data->affected_medias[$a_m] .= (', file_url_thumb = ' . $this->db_quote($data->media_object->file_url_thumb));
										}

									}



								}
							}


						}
					}

					$upd = array();
					foreach($data->media_object as $prop => $value){
						if($prop != "virtuemart_media_id" && strpos($prop,"ref_") !== 0 && strpos($prop,"__") !== 0){
							$upd[] = $prop . "=" . $this->db_quote($value);
						}
					}

					if(count($upd)){
						$this->db_sqlQuery("UPDATE #__virtuemart_medias SET " . implode(" , ", $upd ) . " WHERE virtuemart_media_id = " . $data->media_object->virtuemart_media_id);
						$this->db->execute();
					}

					$this->sessionGroupConcat();

					if(!empty($data->affected_medias)){
						foreach($data->affected_medias as $mid => $a_sql){
							if($a_sql){
								$this->db_sqlQuery("UPDATE #__virtuemart_medias SET $a_sql WHERE virtuemart_media_id = $mid;");
								$this->db->execute();
							}
						}


						$mids = array_keys($data->affected_medias);
						if(!empty($mids)){

							$q = "  SELECT
									m.*,
									concat('[',GROUP_CONCAT(p.virtuemart_product_id),']') As ref_products
								FROM
									#__virtuemart_medias as m
									LEFT JOIN
									#__virtuemart_product_medias as pm on pm.virtuemart_media_id = m.virtuemart_media_id
									LEFT JOIN
									#__virtuemart_products as p on p.virtuemart_product_id = pm.virtuemart_product_id
								WHERE
									m.virtuemart_media_id IN (" . implode(",",$mids) . ")
								GROUP BY
									m.virtuemart_media_id
								";
							$this->db_sqlQuery($q);

							$data->affected_medias = $this->db->loadObjectList("virtuemart_media_id");
						}else
							unset($data->affected_medias);
					}

					$q = "  SELECT
								m.*,
								concat('[',GROUP_CONCAT(p.virtuemart_product_id),']') As ref_products
							FROM
								#__virtuemart_medias as m
								LEFT JOIN
								#__virtuemart_product_medias as pm on pm.virtuemart_media_id = m.virtuemart_media_id
								LEFT JOIN
								#__virtuemart_products as p on p.virtuemart_product_id = pm.virtuemart_product_id
							WHERE
								m.virtuemart_media_id = " . $data->media_object->virtuemart_media_id . "
							GROUP BY
								m.virtuemart_media_id
							";

					$this->db_sqlQuery($q);
					$media_object = $this->db->loadObject();
					$data->media_object = $media_object;
				}
			}
		}catch(Throwable $ex){

			if(isset($data->affected_medias)){
				unset($data->affected_medias);
			}

			if(isset($data->media_object)){
				if(isset($data->media_object->virtuemart_media_id)){
					if($data->media_object->virtuemart_media_id){
						$this->db_sqlQuery("SELECT * FROM #__virtuemart_medias WHERE virtuemart_media_id = " . $data->media_object->virtuemart_media_id);
						$data->media_object = $this->db->loadObject();
					}
				}
			}

			$data->error   = true;
			$data->message = $ex->getMessage();

		}

		return $data;
	}

	function load_image_as_object($data,&$err){

		if($data->url){

			if(stripos($data->url,"http") !== 0){
				if(stripos($data->url,"/") === 0){
					$data->url = "http:" . $data->url;
				}else{
					$data->url = "http://" . $data->url;
				}
			}

			$image = @file_get_contents($data->url);

			if ($image){

				$data->pathinfo = pathinfo($data->url);
				$mime = mime_content_type($data->url);
				if($mime){
					$data->data    = 'data:'. $mime . ';base64,' . base64_encode($image);
					$data->pathinfo['mime'] = $mime;
				}else{
					$data->data = 'data:image/' . $data->pathinfo["extension"] . ';base64,' . base64_encode($image);
					$data->pathinfo['mime'] = 'image/' . $data->pathinfo["extension"];
				}
			}else{

				$data->error = true;
				$err[] = "Could not read image from ". $data->url;

			}

		}else{

			$data->error = true;
			$err[] = "No url parameter";
		}

		return $data;
	}

	function delete_single_media($data,&$err){
		global $scerr;
		if(!SCvmAccess::manager('product.edit') && $this->datascope != "b2b"){
			$scerr[0]           = "The account you use to access site is not permitted to edit products!";
			return null;
		}

		if($data->virtuemart_media_id){
			$this->db_sqlQuery("SELECT * FROM #__virtuemart_medias WHERE virtuemart_media_id = " . $data->virtuemart_media_id);
			$media_object = $this->db->loadObject();

			if($media_object){
				if($media_object->file_url){
					//DELETE OLD FILE
					$this->db_sqlQuery("SELECT count(*) as fileCount FROM #__virtuemart_medias WHERE file_url LIKE " . $this->db_quote($media_object->file_url) . "");
					$fcount = $this->db->loadResult();
					if($fcount < 2){

							$path = JPATH_SITE . DIRECTORY_SEPARATOR . str_replace("/", DIRECTORY_SEPARATOR, $media_object->file_url);
							if(file_exists($path) && !is_dir($path)){
								$data->file_deleted = 1;
								unlink($path);
							}

					}
				}else
					$data->file_deleted = 0;


				if($media_object->file_url_thumb){
					$this->db_sqlQuery("SELECT count(*) as fileCount FROM #__virtuemart_medias WHERE file_url_thumb LIKE " . $this->db_quote($media_object->file_url_thumb) . "");
					$fcount = $this->db->loadResult();
					if($fcount < 2){
						$path = JPATH_SITE . DIRECTORY_SEPARATOR . str_replace("/", DIRECTORY_SEPARATOR, $media_object->file_url_thumb);
						if(file_exists($path) && !is_dir($path)){
							$data->thumb_deleted = 1;
							unlink($path);
						}
					}
				}else
					$data->thumb_deleted = 0;

				$this->db_sqlQuery("DELETE FROM #__virtuemart_medias WHERE virtuemart_media_id = " . $media_object->virtuemart_media_id);
				$this->db->execute();
			}
		}
		$data->deleted = 1;
		return $data;
	}

	function get_data_structure($data,&$err){
		try{
			$this->db_sqlQuery("SELECT DATABASE();");
			$db_name = $this->db->loadResult();


			$q = "SELECT REPLACE(TABLE_NAME, '" . $this->db->getPrefix() . "' ,'#__') as table_name, GROUP_CONCAT(COLUMN_NAME ORDER BY ordinal_position) as columns from information_schema.columns
				  WHERE
				  TABLE_SCHEMA = '{$db_name}'
				  GROUP by TABLE_NAME
				  HAVING columns LIKE '%product_id%' OR table_name LIKE '%virtuemart%'
				 ";
			$this->db_sqlQuery($q);

			$data->structure = array(
				"database" => $this->db->loadAssocList("table_name", "columns")
			);

			if(!empty($data->structure["database"])){
				foreach($data->structure["database"] as $tbl => $cols){
					$data->structure["database"][$tbl] = explode(",",$cols);
				}
			}

		}catch(Throwable $ex){
			//
		}
		return $data;
	}

	function delete_media($data,&$err){
		global $scerr;
		if(!SCvmAccess::manager('product.edit') && $this->datascope != "b2b"){
			$scerr[0]           = "The account you use to access site is not permitted to edit products!";
			return null;
		}

		if(isset($data->medias)){
			for($i =0; $i < count($data->medias);$i++){
				$data->medias[$i] = $this->delete_single_media($data->medias[$i],$err);
			}
			return $data;
		}else if(isset($data->virtuemart_media_id)){
			return $this->delete_single_media($data,$err);
		}
	}

	private function createProductClone($virtuemart_product_id, $clone_parent_id , &$err,&$clone_map){
		global $scerr;
		if(!SCvmAccess::manager('product.edit') && $this->datascope != "b2b"){
			$scerr[0]           = "The account you use to access site is not permitted to edit products!";
			return null;
		}
		
		$this->prepareSessionForUpdateTask();

		$clone_id = null;
		try{
			$this->db_sqlQuery("SELECT * FROM #__virtuemart_products WHERE virtuemart_product_id = {$virtuemart_product_id}");
			$original = $this->db->loadAssoc();
			if(!$original)
				return null;

			$original["virtuemart_product_id"] = NULL;

			if($clone_parent_id > 0){
				$original["product_parent_id"] = $clone_parent_id;
			}

			foreach($original as $key => $val){
				if($key == "created_on" || $key == "modified_on"){
					$original[$key] = $this->db_quote(date("Y-m-d H:i:s"));
				}else
					$original[$key] = $this->db_quote($val);
			}

			$keys   = implode(",",array_keys($original));
			$values = implode(",",array_values($original));

			$q = "INSERT INTO #__virtuemart_products({$keys}) VALUES({$values})";

			$this->db_sqlQuery($q);
			$this->db->execute();
			$clone_id = $this->db->insertid();

			if(!$clone_id)
				return null;

			$clone_map[$virtuemart_product_id] = $clone_id;

			$this->db_sqlQuery("SELECT virtuemart_product_id FROM #__virtuemart_products WHERE product_parent_id = {$virtuemart_product_id}");
			$orig_chid_ids   = $this->db->loadColumn();
			$clone_ids       = array();
			$clone_variants  = null;

			if(!empty($orig_chid_ids)){
				$clone_variants = new stdClass;
				foreach($orig_chid_ids as $orig_chid_id){
					$child_clone = $this->createProductClone($orig_chid_id , $clone_id, $err, $clone_map);
					if($child_clone){
						if($child_clone->virtuemart_product_id){
							$clone_variants->{$child_clone->virtuemart_product_id} = $child_clone;
							$clone_ids[$orig_chid_id] = $child_clone->virtuemart_product_id;
						}
					}
				}
			}

			foreach($this->product_tables as $product_table){
				if($product_table != "#__virtuemart_products"){
					if(isset($this->tbl[$product_table]["virtuemart_product_id"])){

						$this->db_sqlQuery("SELECT * FROM {$product_table} WHERE virtuemart_product_id = {$virtuemart_product_id}");
						$originals = $this->db->loadAssocList();

						if(empty($originals))
							continue;

						foreach($originals as $original){
							$original["virtuemart_product_id"] = $clone_id;

							foreach($original as $key => $val){

								if(isset($this->tbl[$product_table][$key]->Extra)){
									if(stripos($this->tbl[$product_table][$key]->Extra, "auto_increment") !== false){
										$val = NULL;
									}
								}

								if(isset($this->tbl[$product_table][$key]->Key)){
									if(stripos($this->tbl[$product_table][$key]->Key, "uni") !== false){
										$val = $original[$key] . "-{$clone_id}";
									}
								}

								if($key == "product_name" && $clone_parent_id == -1){
									$val = explode(" - clone", $val);
									$val = $val[0];
									$val = $original[$key] . (" - clone " . date('Y-m-d H:i:s'));
								}

								if($key == "customfield_value"){
									if($val){
										if(isset($clone_ids[$val])){
											$val = $clone_ids[$val];
										}
									}
								}

								if($key == "customfield_params"){
									if($val){
										foreach($clone_ids as $oid => $cid){
											$val = str_replace("\"{$oid}\"","\"{$cid}\"",$val);
										}
									}
								}

								if($key == "created_on" || $key == "modified_on"){
									$original[$key] = $this->db_quote(date("Y-m-d H:i:s"));
								}else
									$original[$key] = $this->db_quote($val);
							}

							$keys   = implode(",",array_keys($original));
							$values = implode(",",array_values($original));

							$q = "INSERT INTO {$product_table} ({$keys}) VALUES({$values})";
							$this->db_sqlQuery($q);
							$this->db->execute();
						}
					}
				}
			}

		}catch(Throwable $ex){
			$err[$virtuemart_product_id] = $ex->getMessage();
		}

		if($clone_id){
			$clone = $this->getProduct($clone_id, true);
			if($clone_variants)
				$clone->_variants = $clone_variants;
			return $clone;
		}
		return null;
	}

	function createClones($data,&$err){
		global $scerr;
		if(!SCvmAccess::manager('product.edit') && $this->datascope != "b2b"){
			$scerr[0]           = "The account you use to access site is not permitted to edit products!";
			return null;
		}

		$response = new stdClass;
		$response->products = array();

		$this->db_sqlQuery("SHOW TABLES LIKE '%virtuemart_product%'");
		$this->product_tables = $this->db->loadColumn();

		for($I = 0; $I < count($this->product_tables);$I++){
			$product_table = $this->product_tables[$I];
			$this->product_tables[$I] = $this->loadTableDefinition($product_table);
		}

		foreach($data->product_ids as $virtuemart_product_id){
			$clone_map = array();
			$clone = $this->createProductClone($virtuemart_product_id,-1,$err,$clone_map);
			if($clone){
				$clone->insert_after_uid = $virtuemart_product_id;
				$response->products[$clone->virtuemart_product_id] = $clone;
			}
		}

		return $response;
	}

	function refresh($data,&$err){
		return $data;
	}

	function deploy_platform_reports($data,&$err){
		if(isset($data->reports)){

			$local_data_path = realpath(__DIR__ . DIRECTORY_SEPARATOR .  "local_data");
			$fix_message = false;
			$fix_message_template = false;

			$current_reports = glob("{$local_data_path}" . DIRECTORY_SEPARATOR . "*.liquid");

			foreach ($current_reports as $filepath) {
				if(!isset($data->reports->{basename($filepath,".liquid")})){
					if(unlink($filepath) !== true){
						$err[] = "Unable to remove {$filepath}";
						$fix_message = true;
					}
				}
			}

			$app = JFactory::getApplication();
			$template =	$app->getTemplate();
			$template_vmhtml_dir = JPATH_SITE . DIRECTORY_SEPARATOR . "templates" . DIRECTORY_SEPARATOR . $template . DIRECTORY_SEPARATOR . "html" . DIRECTORY_SEPARATOR . "com_virtuemart";
			$vm_default_view_dir = JPATH_SITE . DIRECTORY_SEPARATOR . "components" . DIRECTORY_SEPARATOR . "com_virtuemart" . DIRECTORY_SEPARATOR . "views";

			foreach($data->reports as $use => $template){
				if(file_put_contents($local_data_path . DIRECTORY_SEPARATOR . "{$use}.liquid", $template) === false){
					$err[] = "Unable to store {$local_data_path}/{$use}.liquid";
					$fix_message = true;
				}else{
					$path    = "";
					$context = "";
					if(stripos($use,"mail_order") !== false){
						if(stripos($use,"admin") !== false)
							$path = $template_vmhtml_dir . DIRECTORY_SEPARATOR . "invoice" . DIRECTORY_SEPARATOR . "mail_html_vendor.php";
						else
							$path = $template_vmhtml_dir . DIRECTORY_SEPARATOR . "invoice" . DIRECTORY_SEPARATOR . "mail_html.php";

						if(!file_exists($path)){
							if(stripos($use,"admin") !== false)
								$context = file_get_contents($vm_default_view_dir . DIRECTORY_SEPARATOR . "invoice" . DIRECTORY_SEPARATOR . "tmpl" . DIRECTORY_SEPARATOR . "mail_html_vendor.php");
							else
								$context = file_get_contents($vm_default_view_dir . DIRECTORY_SEPARATOR . "invoice" . DIRECTORY_SEPARATOR . "tmpl" . DIRECTORY_SEPARATOR . "mail_html.php");
						}else{
							$context = file_get_contents($path);
						}

						if(!$context){
							$context = "";
						}

						$report_base = (stripos($use,"admin") === false) ? "mail_order_for_orderstates" : "mail_order_admin_for_orderstates";

						if(strpos($context,"SC REPORT") === false){
							$context =	str_replace('{$report_base}', $report_base , file_get_contents(__DIR__ . DIRECTORY_SEPARATOR . "local_data" . DIRECTORY_SEPARATOR . "ordermail.dat")) .	$context;
							$context = str_replace("SCMANAGER_VER",SCMANAGER_VER,$context);

							if(!file_exists(dirname($path))){
								if(!mkdir(dirname($path),0775,true)){
									$fix_message_template = true;
									continue;
								}
							}

							if(file_put_contents($path, $context) === false){
								$fix_message_template = true;
								continue;
							}
						}else if(strpos($context,"SCREPORT_" . SCMANAGER_VER) === false){
							//NEW VERSION

							$context = substr($context, strpos($context, "?>") + 2);

							$context =	str_replace('{$report_base}', $report_base , file_get_contents(__DIR__ . DIRECTORY_SEPARATOR . "local_data" . DIRECTORY_SEPARATOR . "ordermail.dat")) .	$context;
							$context = str_replace("SCMANAGER_VER",SCMANAGER_VER,$context);
							if(file_put_contents($path, $context) === false){
								$fix_message_template = true;
								continue;
							}
						}

					}else if(stripos($use,"mail_shopper") !== false){
						if(stripos($use,"admin") !== false)
							$path = $template_vmhtml_dir . DIRECTORY_SEPARATOR . "user" . DIRECTORY_SEPARATOR . "mail_html_regvendor.php";
						else
							$path = $template_vmhtml_dir . DIRECTORY_SEPARATOR . "user" . DIRECTORY_SEPARATOR . "mail_html_reguser.php";

						if(!file_exists($path)){
							if(stripos($use,"admin") !== false)
								$context = file_get_contents($vm_default_view_dir . DIRECTORY_SEPARATOR . "user" . DIRECTORY_SEPARATOR . "tmpl" . DIRECTORY_SEPARATOR . "mail_html_regvendor.php");
							else
								$context = file_get_contents($vm_default_view_dir . DIRECTORY_SEPARATOR . "user" . DIRECTORY_SEPARATOR . "tmpl" . DIRECTORY_SEPARATOR . "mail_html_reguser.php");
						}else{
							$context = file_get_contents($path);
						}

						if(!$context){
							$context = "";
						}

						$report_base = (stripos($use,"admin") === false) ? "mail_shopper_registration" : "mail_shopper_registration_admin";

						if(strpos($context,"SC REPORT") === false){
							$context =	str_replace('{$report_base}', $report_base , file_get_contents(__DIR__ . DIRECTORY_SEPARATOR . "local_data" . DIRECTORY_SEPARATOR . "shoppermail.dat")) .	$context;
							$context = str_replace("SCMANAGER_VER",SCMANAGER_VER,$context);

							if(!file_exists(dirname($path))){
								if(!mkdir(dirname($path),0775,true)){
									$fix_message_template = true;
									continue;
								}
							}

							if(file_put_contents($path, $context) === false){
								$fix_message_template = true;
								continue;
							}
						}else if(strpos($context,"SCREPORT_" . SCMANAGER_VER) === false){
							//NEW VERSION
							$context = substr($context, strpos($context, "?>") + 2);

							$context =	str_replace('{$report_base}', $report_base , file_get_contents(__DIR__ . DIRECTORY_SEPARATOR . "local_data" . DIRECTORY_SEPARATOR . "shoppermail.dat")) .	$context;
							$context = str_replace("SCMANAGER_VER",SCMANAGER_VER,$context);
							if(file_put_contents($path, $context) === false){
								$fix_message_template = true;
								continue;
							}
						}
					}
				}
			}

			if($fix_message)
				$data->message = "Could not store .liquid templates! Please make sure user www-data can write to {$local_data_path}!linux command for fix: chown -R www-data:www-data {$local_data_path}";
			else if($fix_message_template)
				$data->message = "Could not modify template files! Please make sure user www-data can write to {$template_vmhtml_dir} folder";
			else
				$data->message = "Local site reports deployed!";

		}else{
			$err[] = "No data found in request!";
		}
		return $data;
	}

}
?>
